(*********************************************************************
 *                                                                   *
 *  :Program.    GameSupportTest.mod                                 *
 *  :Author.     Michael Frie                                       *
 *  :Address.    Kernerstr. 22a                                      *
 *  :Address.    7000 Stuttgart 1                                    *
 *  :shortcut.   [mif]                                               *
 *  :Version.    0.1                                                 *
 *  :Date.       17.04.88                                            *
 *  :Copyright.  PD                                                  *
 *  :Language.   Modula-II                                           *
 *  :Translator. M2Amiga                                             *
 *  :Contents.   test for the module GameSupport                     *
 *  :Remark.                                                         *
 *                                                                   *
 *********************************************************************)

MODULE GameSupportTest;


FROM GameSupport IMPORT Result, GetController, InitController,
                        QDJoystick,
                        Left, Back;

FROM Terminal    IMPORT WriteLn, WriteString;


VAR r : Result;
    who : BOOLEAN;

BEGIN
  InitController(1);
  who := FALSE;
  REPEAT
    IF who THEN
      GetController (r,1);
    ELSE
      QDJoystick(r,1);
    END;
    IF    r.x = Left THEN WriteString ("Links ");
    ELSIF r.x =  1   THEN WriteString ("Rechts ");
    END;
    IF    r.y = Back THEN WriteString ("Hoch ");
    ELSIF r.y =  1   THEN WriteString ("Runter ");
    END;
    IF    r.button = -1 THEN WriteString ("Losgelassen ");
    ELSIF r.button =  1 THEN WriteString ("Gedrckt ");
      who := NOT who;
    END;
    WriteLn;
  UNTIL (r.button = 1) AND (r.y = Back);
END GameSupportTest.
