(*********************************************************************
 
   -:Program.  	 WBexecute.mod
   -:Author.   	 Pit Burkhardt  
    :Address.    Stettinerstrae 25 7030 Bblingen / BRD
    :Phone.      ----
   -:shortcut. 	 [pit]
   -:Version.  	 1.0   
   -:Date.     	 09.05.1988
   -:Copyright.  PD
   -:Language. 	 Modula-II
   -:Translator. M2Amiga
   -:Imports.	 ----
   -:UpDate.	 ----
   -:Contents.	 Executes CLI-Programs and Batches from Workbench 
   		 by <SHIFT>-klicking
    :Remark.	 Habe eine Idee von Bene aufgegriffen
    
**********************************************************************)

(*********************************************************************
Dieses kleine Programm fhrt Batch-Dateien durch erweiterte Selektion aus. 
Die Batch-Dateien mit <shift>-klick anklicken und dann WBexecute mit
<shift>-doppelklick aktivieren.
Andere Mglichkeit: Batch-Datei anklicken und Info im Men Workbench
selektieren. Im Info-Fenster kann jetzt das Default-Tool auf WBexecute
gestellt werden (mit path). Jetzt kann die Batch-Datei durch Doppelklicken
aktiviert werden. 
Die Batch-Dateien mssen im s-Ordner der Diskette im Laufwerk df0: liegen, 
sonst werden sie nicht gefunden.
**********************************************************************)


MODULE WBexecute;

FROM Dos IMPORT 	Execute,FileHandlePtr,Delay,Open,Close,newFile,
			FileLockPtr;

FROM SYSTEM IMPORT 	ADR;

FROM Arts IMPORT	TermProcedure;

FROM Strings IMPORT	Insert;

FROM Arguments IMPORT	NumArgs, GetArg;

CONST	ERRORSTR1='echo "usage: <shift>-klick Batch-File(s) in df0:s/,"';
	ERRORSTR2='echo "       then <shift>-doubleklick WBexecute."';
        
VAR		Window		:FileHandlePtr;
		Args,i,len	:INTEGER;
                ArgStr		:ARRAY [0..10] OF CHAR;
                CommandStr	:ARRAY [0..40] OF CHAR;
		error		:INTEGER;

PROCEDURE EndUp;
 BEGIN
  IF Window<>0 THEN Close(Window) END;
 END EndUp;

BEGIN
  TermProcedure(EndUp);
  Args:=NumArgs();
  IF Args=0 THEN
  	Window:=Open(ADR("CON:0/10/640/40/WBexecute"),newFile);
  	error:=Execute(ADR(ERRORSTR1),NIL,Window);
  	error:=Execute(ADR(ERRORSTR2),NIL,Window);
  	Delay(500);
  ELSE
  	Window:=Open(ADR("CON:0/10/640/80/WBexecute"),newFile);
  	FOR i:=1 TO Args DO
  	  CommandStr:="execute df0:s/                          ";
  	  GetArg(i,ArgStr,len);
  	  Insert(CommandStr,14,ArgStr);
  	  error:=Execute(ADR(CommandStr),NIL,Window);
  	END;
  	Delay(250);
  END; (*IF*)
END WBexecute.

