IMPLEMENTATION MODULE NTSC;

FROM SYSTEM IMPORT ADR, ADDRESS;
FROM Arts   IMPORT TermProcedure;

FROM Exec   IMPORT OpenLibrary, CloseLibrary, LibraryPtr;
IMPORT Graphics;

CONST
  ntsc = 0;

VAR
  GfxBase: POINTER TO Graphics.GfxBase;

(*------  Test NTSC-Amiga:  ------*)

PROCEDURE NTSC(): BOOLEAN;
(* returns TRUE on american Amigas. *)

BEGIN
  RETURN (ntsc IN GfxBase^.displayFlags);
END NTSC;

(*------  CleanUp:  ------*)

PROCEDURE CleanUp();

BEGIN
  CloseLibrary(LibraryPtr(GfxBase));
END CleanUp;

(*------  Initialization:  ------*)

BEGIN
  GfxBase := ADDRESS(OpenLibrary(ADR("graphics.library"),0));
  TermProcedure(CleanUp);
END NTSC.
