(******************************************************
 *
 * :Program.    ScrollDemo.mod
 * :Author.     Holger Gzella
 * :Address.    Freischffenweg 12  D-4600 Dortmund 16
 * :Phone.      (0231) 85 16 02
 * :Version.    1.1
 * :Date.       9/7/89  20:57:39 first Version by Holger Gzella
 * :History.    V1.1 13-Jul-89 changed SetTaskPri(Me,127) to STP(Me,5) [fbs]
 * :Copyright.  PD
 * :Language.   Modula-2
 * :Translator. M2Amiga 3.2d
 * :Contents.   Demo for Scroll.def+.mod modules
 * :Remark.     Simple scrolltext. Nothing exiting.
 *
 ******************************************************)

MODULE ScrollDemo;

FROM SYSTEM   IMPORT ADR;
FROM Exec     IMPORT SetTaskPri,FindTask,Byte;
FROM Graphics IMPORT RastPortPtr;
FROM Windows  IMPORT OpenWindow,CloseWindow,WinGad,WinGadSet,Window;
FROM Scroll   IMPORT ScrollX;

VAR Fenster: Window;
    rp     : RastPortPtr;
    Pri    : Byte;
    String : ARRAY[0..60] OF CHAR;

BEGIN

  String:="Ein Demo fr Scroll.def u. Scroll.mod ...                    ";

  (* Hier wird ein Kompromi zwischen Multitasking und Geschwindigkeit
     geschlossen: die eigene Taskprioritt wird heraufgesetzt. Das ist
     zwar nicht ganz richtig, aber so einen Scrolltext lt man ja
     nicht ewig auf dem Bildschirm stehen, insofern ... *)

  Pri:=SetTaskPri(FindTask(NIL),5);

  OpenWindow(Fenster,0,100,640,25,"Scroll!",WinGadSet{moving,arranging});
  rp:=Fenster^.rPort;

  (* Nun wird gescrollt. *)

  ScrollX(rp,638,4,-1,SIZE(String),10,String);

  CloseWindow(Fenster);

  (* Aufrumen mu sein! *)

  Pri:=SetTaskPri(FindTask(NIL),Pri); (* zurck auf alte Pri. *)

END ScrollDemo.

