(*************************************************************
 *
 * :Program.   WarnBoot.asm
 * :Author.    Holger Gzella
 * :Address.   Freischffenweg 12  D-4600 Dortmund 16
 * :Phone.     (0231) 85 16 02
 * :Date.      11/7/89  19:15:47
 * :Copyright. PD
 * :Version.   v1.0
 * :Language.  Assembler
 * :Translator.DevPac v2.11
 * :Contents.  This is the source of the WBG-Bootblock.
 * :Remark.    This may be somewhat useful.
 * :Remark.    Beware to overwrite special bootblock-loaders!
 *
 *************************************************************)

anfang:
        movem.l d0-d2/a1-a6,-(SP)

        lea     intui(pc),a1
        clr.l   d0
        move.l  $4,a6
        jsr     -408(a6)
        move.l  d0,a6
        move.l  #0,d0
        lea     txt(pc),a0
        move.l  #90,d1
        jsr     -90(a6)
        move.l  a6,a1
        move.l  $4,a6
        jsr     -414(a6)
        bne     weiter
        move.l  $4,a6
        move.l  #$20004,d1
        jsr     -216(a6)
        move.l  $4,a6
        move.l  #$20004,d1
        jsr     -198(a6)
weiter:
        movem.l (SP)+,d0-d2/a1-a6

        move.l  $4,a6
        lea     Resname(PC),a1
        jsr     -96(a6)
        tst.l   d0
        beq     Error
        move.l  d0,a0
        move.l  22(a0),a0
        moveq   #$00,d0
Ende:   rts

Error:
        move    #$ff,d0
        bra     Ende

Resname:
        dc.b    'dos.library',0
 even
intui:
        dc.b    'intuition.library',0
 even

txt:    dc.w    378
        dc.b    10,"HOLGER GZELLA A500W.",0
        dc.b    $93
        dc.b    0,80
        dc.b    20,"* Disk in DF0: und Speicher BOOT-VIRUS-FREI!! *",0
        dc.b    $ea
        dc.b    0,100
        dc.b    30,"Das System kann die Kontrolle bernehmen ...",0
        dc.b    $eb
        dc.b    0,100
        dc.b    50,"-LINKER  MAUSKNOPF-: Bootvorgang weiterfhren",0
        dc.b    $e9
        dc.b    0,100
        dc.b    60,"-RECHTER MAUSKNOPF-: FastMemory abschalten",0
        dc.b    $e8
        dc.b    0,80
        dc.b    80,"created on 20/5/89  21:49:22   by Holger Gzella",0
        dc.b    0

        END

