(*

    Programm	:	Kurve
    Autor	:	Jrg Wesemann
    Adresse	:	Auf der Heide 10 , 2807 Achim - Baden
    Telefon	:	04202 / 70658
    Version	:	3.20 (deutsch)
    Datum	:	28.09.1989
    Copyright	:	Public Domain, bei eigenen nderungen bitte Nachricht !
    Compiler	:	M2-Amiga Modula-2, Version 3.2d, 01.11.88
    Importiert	:	
    Fehler	:	nicht bekannt
    
*)

IMPLEMENTATION MODULE integration;

FROM SYSTEM 		IMPORT 	ADR;
FROM InOut 		IMPORT 	Write,WriteString,WriteLn,OpenOutput,
				CloseOutput;
FROM LongRealInOut 	IMPORT 	ReadReal,WriteReal;
FROM startupproc 	IMPORT 	cursorr,crlf,CLS,m,n,nullbuffer,string,center,
				dateiabfrage,intf,fragedatei,wptr;
FROM intervall 		IMPORT 	kleinintervall;
FROM lparser 		IMPORT 	lparse;    
FROM Strings 		IMPORT 	Length;
FROM menu 		IMPORT 	wartemenu;
FROM Intuition		IMPORT	WindowToFront;




PROCEDURE integration;

  VAR
    a,b,g,err,i,lasti 	: LONGREAL;
    k		     	: CARDINAL;
    zuviele		: BOOLEAN;
    
BEGIN
  
  nullbuffer[1]:="0.0";
  nullbuffer[2]:= "0.001";
  kleinintervall(nullbuffer,ADR("INTEGRATION - Intervall"));
  a:= lparse(nullbuffer[1],0.0);
  g:= lparse(nullbuffer[2],0.0);
  b:= lparse(nullbuffer[3],0.0);
  err:= g;
  WindowToFront(wptr);
  Write(CLS);
  IF dateiabfrage THEN
    fragedatei();
  END;  
  crlf(2);
  center("INTEGRATION"); WriteLn;
  center("-----------"); crlf(2);
  center("von"); crlf(2);
  cursorr(20+(31-Length(string)) DIV 2 );
  WriteString("f(x) = ");
  WriteString(string); crlf(3);
  cursorr(23); WriteString("Xmin: "); WriteReal(a,m,n); cursorr(5);
  WriteString("Xmax: "); WriteReal(b,m,n); crlf(3);
  i:= intf(a,b,err,zuviele);
  IF zuviele THEN
    WriteLn;
    center("Maximale Anzahl der Iterationen berschritten");
  ELSE
    cursorr(22); WriteString("Integral           I = "); WriteReal(i,m,n);
    WriteLn; cursorr(22);
    WriteString("absoluter Fehler  dI = "); WriteReal(err,m,n);
  END;
  WriteLn;
  CloseOutput;
  crlf(2); cursorr(22);
  WriteString("Bitte 'RETURN' drcken fr MENU ");
  wartemenu;

END integration;


END integration.
