(*

    Programm	:	Kurve
    Autor	:	Jrg Wesemann
    Adresse	:	Auf der Heide 10 , 2807 Achim - Baden
    Telefon	:	04202 / 70658
    Version	:	3.20 (deutsch)
    Datum	:	28.09.1989
    Copyright	:	Public Domain, bei eigenen nderungen bitte Nachricht !
    Compiler	:	M2-Amiga Modula-2, Version 3.2d, 01.11.88
    Importiert	:	DeactivateGadget: Stefan Selewski, R.o.M. AMOK 11
    Fehler	:	nicht bekannt    
*)

IMPLEMENTATION MODULE intervall ;

FROM Arts 		IMPORT 	Assert,BreakPoint;
FROM SYSTEM 		IMPORT 	ADDRESS,ADR,LONGSET;
FROM Intuition 		IMPORT 	ScreenFlags,ScreenFlagSet,NewWindow,WindowPtr,
		      		IDCMPFlags,IDCMPFlagSet,WindowFlags,strGadget,
                                WindowFlagSet,OpenWindow,CloseWindow,Border,
                                IntuiMessage,Gadget,GadgetFlags,GadgetFlagSet,
                                ActivationFlags,boolGadget,ActivationFlagSet,
                                StringInfo,IntuiText,Image,RefreshGadgets,
                                ActivateGadget,ModifyIDCMP;
FROM Graphics 		IMPORT 	Text,Move,jam1,RastPortPtr,Draw,SetAPen;
FROM Exec 		IMPORT 	GetMsg,ReplyMsg,WaitPort,FreeMem,UByte;
FROM Strings 		IMPORT 	Length,Insert;
FROM Str		IMPORT	Copy;
FROM LongRealConversions  IMPORT	RealToStr;
FROM InOut 		IMPORT 	WriteLn,WriteString,WriteInt;
FROM startupproc 	IMPORT 	stringbuffergr,stringbufferkl,STRING,funkstr,
				string,Buffer7,FORMEL,FNUM;
FROM imagedata 		IMPORT 	okimagedata,okhimagedata,CopyToChip,oksize,
				okhsize,CARDPTR;
FROM lparser		IMPORT	lparse;
FROM ableitung		IMPORT  ableitung;
FROM DeactivateGadget	IMPORT	PressRButton;
FROM UPN		IMPORT  UPN, AddVarsToUPN,Compile,GetVarNr,SetVar;

  VAR
    ok,okh			  : Image;
    imageptr,himageptr		  : CARDPTR;
    hRegister[0BFEC01H]	  	  : UByte;
    lastKey		 	  : UByte;
    klaro			  : BOOLEAN;
    aktgadget			  : CARDINAL;

  PROCEDURE rand(rast: RastPortPtr; x,y,dx,dy: INTEGER);

  BEGIN
    Move(rast,x,y);
    Draw(rast,x+dx,y);
    Draw(rast,x+dx,y+dy);
    Draw(rast,x,y+dy);
    Draw(rast,x,y);
  END rand;


  PROCEDURE fktstring(VAR Buffer: STRING);

    CONST
      stringfkt     	= 1 ;
      booleangadget 	= 2 ;
        
    VAR 
      MyWindow    		: NewWindow ;
      MyWindowPtr         	: WindowPtr ;
      class			: IDCMPFlagSet ;
      IntuiMsg    		: POINTER TO IntuiMessage ;
      myintuitext		: IntuiText ;
      gad,gad2 			: Gadget ;
      Info 			: StringInfo ;
      Rahmen			: Border;
      xyFeld			: ARRAY [0..9]  OF INTEGER ;
      UndoBuffer		: STRING;
      rp			: RastPortPtr;
     
  BEGIN
    WITH MyWindow DO
      leftEdge:= 0; topEdge:= 0;       
      width:= 640; height:= 256;
      detailPen:= 0; blockPen:= 0;
      idcmpFlags:= IDCMPFlagSet{gadgetUp,intuiTicks}; 
      flags:= WindowFlagSet{};  
      firstGadget:=  ADR(gad);
      checkMark:= NIL;
      title:= ADR("Eingabe der Funktion");
      bitMap:= NIL;
      type:= ScreenFlagSet{wbenchScreen};
      minWidth:= 640; maxWidth:= 640;
      minHeight:= 256; maxHeight:= 256;
    END;
    WITH Rahmen DO				
      leftEdge:= -1; topEdge:= -2;
      frontPen:= 1; backPen:= 0;
      drawMode:= jam1;
      count:= 5; xy:= ADR(xyFeld);
      nextBorder:= NIL;
    END;
    xyFeld[0]:= 0;   xyFeld[1]:= 0;
    xyFeld[2]:= 261; xyFeld[3]:= 0;
    xyFeld[4]:= 261; xyFeld[5]:= 11;
    xyFeld[6]:= 0;   xyFeld[7]:= 11;
    xyFeld[8]:= 0;   xyFeld[9]:= 0;
    UndoBuffer:= " ";
    WITH Info DO
      buffer:= ADR(Buffer); undoBuffer:= ADR(UndoBuffer);
      bufferPos:= 0; maxChars:= 80; dispPos:= 0;
    END;
    WITH gad DO			
      nextGadget:= ADR(gad2);
      leftEdge:= 220; topEdge:= 120;
      width:= 260; height:= 10;
      flags:= GadgetFlagSet{};
      activation:= ActivationFlagSet{toggleSelect,stringCenter};
      gadgetType:= strGadget;
      gadgetRender:= ADR(Rahmen); selectRender:= NIL; 
      gadgetText:= NIL; specialInfo:= ADR(Info);
      gadgetID:= stringfkt;
      userData:= NIL;
    END;
    CopyToChip(ADR(okimagedata),imageptr,oksize);
    CopyToChip(ADR(okhimagedata),himageptr,okhsize);
    WITH ok DO
      leftEdge:= 0; topEdge:= 0; width:= 80; height:= 20; depth:=2;
      imageData:= imageptr; planePick:= 3; planeOnOff:= 0;
      nextImage:= NIL;
    END;
    WITH okh DO
      leftEdge:= 0; topEdge:= 0; width:= 80; height:= 20; depth:=2;
      imageData:= himageptr; planePick:= 3; planeOnOff:= 0;
      nextImage:= NIL;
    END;
    WITH gad2 DO
      nextGadget:= NIL;
      leftEdge:= 280; topEdge:= 205;
      width:= 80; height:= 20;
      flags:= GadgetFlagSet{gadgImage,gadgHImage};
      activation:= ActivationFlagSet{gadgImmediate,relVerify};
      gadgetType:= boolGadget;
      gadgetRender:= ADR(ok); selectRender:= ADR(okh); 
      gadgetText:= NIL; specialInfo:= NIL;
      gadgetID:= booleangadget;
      userData:= NIL;
    END;
    MyWindowPtr:= OpenWindow(MyWindow);
    Assert(MyWindowPtr # NIL, ADR("Fenster nicht geffnet"));
    rp:= MyWindowPtr^.rPort;
    rand(rp,100,60,440,100);
    Move(rp,100,90); Draw(rp,540,90);
    Move(rp,145,79);
    Text(rp,ADR("E I N G A B E  der festen Integrationsgrenze"),44);
    Move(rp,160,126);
    Text(rp,ADR("A =  "),5);
    SetAPen(rp,2);
    rand(rp,104,62,432,26);
    rand(rp,104,92,432,66);
    SetAPen(rp,1);
    klaro:= ActivateGadget(ADR(gad),MyWindowPtr,NIL);
    LOOP
      WaitPort(MyWindowPtr^.userPort); 
      lastKey:= hRegister;
      ModifyIDCMP(MyWindowPtr,IDCMPFlagSet{gadgetUp});
      IntuiMsg:= GetMsg(MyWindowPtr^.userPort);
      class:= IntuiMsg^.class;
      ReplyMsg(IntuiMsg);
      IF ( class=IDCMPFlagSet{gadgetUp} ) OR (lastKey=121) OR
         ( class=IDCMPFlagSet{closeWindow} ) OR (lastKey=119) THEN
        EXIT;
      END;
      ModifyIDCMP(MyWindowPtr,IDCMPFlagSet{gadgetUp,intuiTicks});
    END;				
    CloseWindow(MyWindowPtr);
    FreeMem(imageptr,oksize);
    FreeMem(himageptr,okhsize);
  END fktstring;


  PROCEDURE kleinintervall(VAR Buffer: stringbufferkl;Titeladr: ADDRESS);

    CONST
      stringxmin  	= 1;
      stringxmax  	= 2;
      stringdx    	= 3;
      stringart   	= 4;
      booleangadget 	= 5;
         
    VAR 
    
      MyWindow    		  : NewWindow;
      MyWindowPtr         	  : WindowPtr;
      class			  : IDCMPFlagSet;
      IntuiMsg    		  : POINTER TO IntuiMessage;
      myintuitext		  : IntuiText;
      gadarray 			  : ARRAY [1..5] OF Gadget;
      Info 			  : ARRAY [1..4] OF StringInfo;
      Rahmen 			  : ARRAY [1..3] OF Border;
      xyFeld 			  : ARRAY [1..3],[0..9]  OF INTEGER;
      UndoBuffer		  : stringbufferkl;
      rp			  : RastPortPtr;

  BEGIN 
    WITH MyWindow DO
      leftEdge:= 0; topEdge:= 0;         
      width:= 640; height:= 256;            
      detailPen:= 0; blockPen:= 0;
      idcmpFlags:= IDCMPFlagSet{gadgetUp,gadgetDown,intuiTicks};
      flags:= WindowFlagSet{};  
      firstGadget:=  ADR(gadarray[1]);
      checkMark:= NIL;
      title:= Titeladr;
      bitMap:= NIL;
      type:= ScreenFlagSet{wbenchScreen};
      minWidth:= 640; maxWidth:= 640;
      minHeight:= 256; maxHeight:= 256;
    END;
    WITH Rahmen[1] DO
      leftEdge:= -1; topEdge:= -2;
      frontPen:= 1; backPen:= 0;
      drawMode:= jam1;
      count:= 5; xy:= ADR(xyFeld[1]);
      nextBorder:= NIL;
    END;
    xyFeld[1,0]:= 0;   xyFeld[1,1]:= 0;
    xyFeld[1,2]:= 191; xyFeld[1,3]:= 0;
    xyFeld[1,4]:= 191; xyFeld[1,5]:= 11;
    xyFeld[1,6]:= 0;   xyFeld[1,7]:= 11;
    xyFeld[1,8]:= 0;   xyFeld[1,9]:= 0;
    UndoBuffer[1]:= " ";
    WITH Info[1] DO
       buffer:= ADR(Buffer[1,0]); undoBuffer:= ADR(UndoBuffer[1,0]);
       bufferPos:= 0; maxChars:= 40; dispPos:= 0;
    END;
    WITH gadarray[1] DO
      nextGadget:= ADR(gadarray[2]);
      leftEdge:= 100; topEdge :=120;
      width:= 190; height:= 10;
      flags:= GadgetFlagSet{};
      activation:= ActivationFlagSet{toggleSelect,stringCenter};
      gadgetType:= strGadget;
      gadgetRender:= ADR(Rahmen[1]); selectRender:= NIL;
      gadgetText:= NIL; specialInfo:= ADR(Info[1]);
      gadgetID:= stringxmin;
      userData:= NIL;
    END;

    UndoBuffer[2]:= " ";
    WITH Info[2] DO
      buffer:= ADR(Buffer[3,0]); undoBuffer:= ADR(UndoBuffer[3,0]);
      bufferPos:= 0; maxChars:= 40; dispPos:= 0;
    END;
    WITH gadarray[2] DO
      nextGadget:= ADR(gadarray[3]);
      leftEdge:= 350; topEdge :=120;
      width:= 190; height:= 10;
      flags:= GadgetFlagSet{};
      activation:= ActivationFlagSet{toggleSelect,stringCenter};
      gadgetType:= strGadget;
      gadgetRender:= ADR(Rahmen[1]); selectRender:= NIL;
      gadgetText:= NIL; specialInfo:= ADR(Info[2]);
      gadgetID:= stringxmax;
      userData:= NIL;
    END;
    UndoBuffer[3]:= " ";
    WITH Info[3] DO
       buffer:= ADR(Buffer[2,0]); undoBuffer:= ADR(UndoBuffer[2,0]);
       bufferPos:= 0; maxChars:= 40; dispPos:= 0;
    END;
    WITH gadarray[3] DO
      nextGadget:= ADR(gadarray[4]) ;
      leftEdge:= 225; topEdge :=168;
      width:= 190; height:= 10;
      flags:= GadgetFlagSet{};
      activation:= ActivationFlagSet{toggleSelect,stringCenter};
      gadgetType:= strGadget;
      gadgetRender:= ADR(Rahmen[1]); selectRender:= NIL; 
      gadgetText:= NIL; specialInfo:= ADR(Info[3]);
      gadgetID:= stringdx;
      userData:= NIL;
    END; 
    WITH Rahmen[2] DO 
      leftEdge:= -2; topEdge:= -2;
      frontPen:= 1; backPen:= 0;
      drawMode:= jam1; 
      count:= 5; xy:= ADR(xyFeld[2,0]);
      nextBorder:= NIL;
    END;
    xyFeld[2,0]:= 0  ; xyFeld[2,1]:= 0 ;
    xyFeld[2,2]:= 32 ; xyFeld[2,3]:= 0 ;
    xyFeld[2,4]:= 32 ; xyFeld[2,5]:= 11;
    xyFeld[2,6]:= 0  ; xyFeld[2,7]:= 11;
    xyFeld[2,8]:= 0  ; xyFeld[2,9]:= 0 ;
    UndoBuffer[4]:= " ";
    WITH Info[4] DO
      buffer:= ADR(Buffer[4,0]); undoBuffer:= ADR(UndoBuffer[4,0]);
      bufferPos:= 0; maxChars:= 10; dispPos:= 0;
    END;
    WITH gadarray[4] DO
      nextGadget:= ADR(gadarray[5]);
      leftEdge:= 305; topEdge :=78;
      width:= 30; height:= 10;
      flags:= GadgetFlagSet{};
      activation:= ActivationFlagSet{toggleSelect,stringCenter};
      gadgetType:= strGadget;
      gadgetRender:= ADR(Rahmen[2]); selectRender:= NIL; 
      gadgetText:= NIL; specialInfo:= ADR(Info[4]);
      gadgetID:= stringart;
      userData:= NIL;
    END;
    CopyToChip(ADR(okimagedata),imageptr,oksize);
    CopyToChip(ADR(okhimagedata),himageptr,okhsize);
    WITH ok DO
      leftEdge:= 0; topEdge:= 0; width:= 80; height:= 20; depth:=2;
      imageData:= imageptr; planePick:= 3; planeOnOff:= 0;
      nextImage:= NIL;
    END;
    WITH okh DO
      leftEdge:= 0; topEdge:= 0; width:= 80; height:= 20; depth:=2;
      imageData:= himageptr; planePick:= 3; planeOnOff:= 0;
      nextImage:= NIL;
    END;
    WITH gadarray[5] DO
      nextGadget:= NIL;
      leftEdge:= 280; topEdge :=220;
      width:= 80; height:= 20;
      flags:= GadgetFlagSet{gadgImage,gadgHImage};
      activation:= ActivationFlagSet{toggleSelect,gadgImmediate,relVerify};
      gadgetType:= boolGadget;
      gadgetRender:= ADR(ok); selectRender:= ADR(okh); 
      gadgetText:= NIL; specialInfo:= NIL;
      gadgetID:= booleangadget;
      userData:= NIL;
    END;
    MyWindowPtr:= OpenWindow(MyWindow);
    Assert(MyWindowPtr # NIL, ADR("Fenster nicht geffnet"));
    rp:= MyWindowPtr^.rPort;
    Move(rp,215,35); Text(rp,ADR("E I N G A B E  des Intervalls"),29);
    rand(rp,70,20,500,183);
    Move(rp,70,44); Draw(rp,570,44);
    SetAPen(rp,2);
    rand(rp,74,22,492,20);
    rand(rp,74,46,492,155);
    Move(rp,180,115); Text(rp,ADR("Xmin"),4);
    Move(rp,430,115); Text(rp,ADR("Xmax"),4);
    Move(rp,305,163); Text(rp,ADR("dX"),2);
    Move(rp,306,73); Text(rp,ADR("Art"),3); 
    aktgadget:= 1;
    LOOP
      klaro:= ActivateGadget(ADR(gadarray[aktgadget]),MyWindowPtr,NIL);
      WaitPort(MyWindowPtr^.userPort); 
      lastKey:= hRegister;
     (* WriteInt(INTEGER(lastKey),8); *)
      ModifyIDCMP(MyWindowPtr,IDCMPFlagSet{gadgetUp,gadgetDown});
      IntuiMsg:= GetMsg(MyWindowPtr^.userPort);
      class:= IntuiMsg^.class;
      ReplyMsg(IntuiMsg);
      IF ( (lastKey=101)  OR (lastKey=119)) AND PressRButton() THEN 
        INC(aktgadget);
        IF (aktgadget>=5) AND (lastKey=119) THEN
          EXIT;
        ELSIF (aktgadget>=5) THEN
          aktgadget:= 1;
        END;
      ELSIF  (lastKey=103) AND PressRButton() THEN
        DEC(aktgadget);
        IF (aktgadget<=0) THEN
          aktgadget:= 4;
        END;
      ELSIF (lastKey=121) THEN
        EXIT;
      END;
      IF ( class=IDCMPFlagSet{gadgetUp} ) OR 
         ( class=IDCMPFlagSet{closeWindow} ) THEN
        EXIT;
      END;
      ModifyIDCMP(MyWindowPtr,IDCMPFlagSet{gadgetUp,gadgetDown,intuiTicks});
    END;						(* LOOP 1	*)
    CloseWindow(MyWindowPtr);
    FreeMem(imageptr,oksize);
    FreeMem(himageptr,okhsize);
  END kleinintervall;


  PROCEDURE grossintervall(VAR Buffer: stringbuffergr );

    CONST 
      stringymax  	= 1;
      stringymin 	= 2;
      stringxmin  	= 3;
      stringxmax  	= 4;
      stringdx    	= 5;
      stringdy    	= 6;
      stringabl   	= 7;
      stringpkt   	= 8;
      stringgenau 	= 9;
      booleangadget 	= 10;
         
    VAR 
      MyWindow    			  : NewWindow;
      MyWindowPtr         		  : WindowPtr;
      class				  : IDCMPFlagSet;
      IntuiMsg    			  : POINTER TO IntuiMessage;
      gadarray 				  : ARRAY [1..10] OF Gadget;
      Info 				  : ARRAY [1..9] OF StringInfo;
      Rahmen 				  : ARRAY [1..3] OF Border;
      xyFeld 				  : ARRAY [1..10],[0..9]  OF INTEGER;
      UndoBuffer			  : stringbuffergr;
      rp				  : RastPortPtr;
    
  BEGIN 
    WITH MyWindow DO
      leftEdge:= 0; topEdge:= 0;         
      width:= 640; height:= 256;         
      detailPen:= 0; blockPen:= 0;       
      idcmpFlags:= IDCMPFlagSet{gadgetUp,intuiTicks}; 
      flags:= WindowFlagSet{};  
      firstGadget:= ADR(gadarray[1]);
      checkMark:= NIL;
      title:= ADR("PLOTTER - Intervalleingabe");
      bitMap:= NIL;
      type:= ScreenFlagSet{wbenchScreen};
      minWidth:= 640; maxWidth:= 640;
      minHeight:= 256; maxHeight:= 256;     
    END;
    WITH Rahmen[1] DO 
      leftEdge:= -2; topEdge:= -2;
      frontPen:= 1; backPen:= 0;
      drawMode:= jam1; 
      count:= 5; xy:= ADR(xyFeld[1,0]);
      nextBorder:= NIL;
    END;
    xyFeld[1,0]:=   0; xyFeld[1,1]:=  0;
    xyFeld[1,2]:= 191; xyFeld[1,3]:=  0;
    xyFeld[1,4]:= 191; xyFeld[1,5]:= 11;
    xyFeld[1,6]:=   0; xyFeld[1,7]:= 11;
    xyFeld[1,8]:=   0; xyFeld[1,9]:=  0;
    UndoBuffer[1]:= " ";
    WITH Info[1] DO
      buffer:= ADR(Buffer[1,0]); undoBuffer:= ADR(UndoBuffer[1,0]);
      bufferPos:= 0; maxChars:= 40; dispPos:= 0;
    END;
    WITH gadarray[1] DO
      nextGadget:= ADR(gadarray[2]);
      leftEdge:= 225; topEdge :=70;
      width:= 190; height:= 10;
      flags:= GadgetFlagSet{};
      activation:= ActivationFlagSet{toggleSelect,stringCenter};
      gadgetType:= strGadget;
      gadgetRender:= ADR(Rahmen[1]); selectRender:= NIL; 
      gadgetText:= NIL; specialInfo:= ADR(Info[1]);
      gadgetID:= stringymax;
      userData:= NIL;
    END;
    UndoBuffer[2]:= " ";
    WITH Info[2] DO
      buffer:= ADR(Buffer[2,0]); undoBuffer:= ADR(UndoBuffer[2,0]);
      bufferPos:= 0; maxChars:= 40; dispPos:= 0;
    END;
    WITH gadarray[2] DO
      nextGadget:= ADR(gadarray[3]);
      leftEdge:= 225; topEdge :=132;
      width:= 190; height:= 10;
      flags:= GadgetFlagSet{};
      activation:= ActivationFlagSet{toggleSelect,stringCenter};
      gadgetType:= strGadget;
      gadgetRender:= ADR(Rahmen[1]); selectRender:= NIL; 
      gadgetText:= NIL; specialInfo:= ADR(Info[2]);
      gadgetID:= stringymin;
      userData:= NIL;
    END;
    UndoBuffer[3]:= " ";
    WITH Info[3] DO
      buffer:= ADR(Buffer[3,0]); undoBuffer:= ADR(UndoBuffer[3,0]);
      bufferPos:= 0; maxChars:= 40; dispPos:= 0;
    END;
    WITH gadarray[3] DO
      nextGadget:= ADR(gadarray[4]);
      leftEdge:= 100; topEdge :=101;
      width:= 190; height:= 10;
      flags:= GadgetFlagSet{};
      activation:= ActivationFlagSet{toggleSelect,stringCenter};
      gadgetType:= strGadget;
      gadgetRender:= ADR(Rahmen[1]); selectRender:= NIL; 
      gadgetText:= NIL; specialInfo:= ADR(Info[3]);
      gadgetID:= stringxmin;
      userData:= NIL;
    END;
    UndoBuffer[4]:= " ";
    WITH Info[4] DO
      buffer:= ADR(Buffer[4,0]); undoBuffer:= ADR(UndoBuffer[4,0]);
      bufferPos:= 0; maxChars:= 40; dispPos:= 0;
    END;
    WITH gadarray[4] DO
      nextGadget:= ADR(gadarray[5]);
      leftEdge:= 350; topEdge :=101;
      width:= 190; height:= 10;
      flags:= GadgetFlagSet{};
      activation:= ActivationFlagSet{toggleSelect,stringCenter};
      gadgetType:= strGadget;
      gadgetRender:= ADR(Rahmen[1]); selectRender:= NIL; 
      gadgetText:= NIL; specialInfo:= ADR(Info[4]);
      gadgetID:= stringxmax;
      userData:= NIL;
    END;
    WITH Rahmen[2] DO 
      leftEdge:= -2; topEdge:= -2;
      frontPen:= 1; backPen:= 0;
      drawMode:= jam1; 
      count:= 5; xy:= ADR(xyFeld[2,0]);
      nextBorder:= NIL;
    END;
    xyFeld[2,0]:=  0; xyFeld[2,1]:=  0;
    xyFeld[2,2]:= 82; xyFeld[2,3]:=  0;
    xyFeld[2,4]:= 82; xyFeld[2,5]:= 11;
    xyFeld[2,6]:=  0; xyFeld[2,7]:= 11;
    xyFeld[2,8]:=  0; xyFeld[2,9]:=  0;
    UndoBuffer[5]:= " ";
    WITH Info[5] DO
      buffer:= ADR(Buffer[5,0]); undoBuffer:= ADR(UndoBuffer[5,0]);
      bufferPos:= 0; maxChars:= 40; dispPos:= 0;
    END;
    WITH gadarray[5] DO
      nextGadget:= ADR(gadarray[6]);
      leftEdge:= 80; topEdge :=185;
      width:= 80; height:= 10;
      flags:= GadgetFlagSet{};
      activation:= ActivationFlagSet{toggleSelect,stringCenter};
      gadgetType:= strGadget;
      gadgetRender:= ADR(Rahmen[2]); selectRender:= NIL; 
      gadgetText:= NIL; specialInfo:= ADR(Info[5]);
      gadgetID:= stringdx;
      userData:= NIL;
    END;        
    UndoBuffer[6]:= " ";
    WITH Info[6] DO
      buffer:= ADR(Buffer[6,0]); undoBuffer:= ADR(UndoBuffer[6,0]);
      bufferPos:= 0; maxChars:= 40; dispPos:= 0;
    END;
    WITH gadarray[6] DO
      nextGadget:= ADR(gadarray[7]);
      leftEdge:= 190; topEdge :=185;
      width:= 80; height:= 10;
      flags:= GadgetFlagSet{};
      activation:= ActivationFlagSet{toggleSelect,stringCenter};
      gadgetType:= strGadget;
      gadgetRender:= ADR(Rahmen[2]); selectRender:= NIL; 
      gadgetText:= NIL; specialInfo:= ADR(Info[6]);
      gadgetID:= stringdy;
      userData:= NIL;
    END;        
    WITH Rahmen[3] DO 
      leftEdge:= -2; topEdge:= -2;
      frontPen:= 1; backPen:= 0;
      drawMode:= jam1; 
      count:= 5; xy:= ADR(xyFeld[3,0]);
      nextBorder:= NIL;
    END;
    xyFeld[3,0]:=  0; xyFeld[3,1]:=  0;
    xyFeld[3,2]:= 62; xyFeld[3,3]:=  0;
    xyFeld[3,4]:= 62; xyFeld[3,5]:= 11;
    xyFeld[3,6]:=  0; xyFeld[3,7]:= 11;
    xyFeld[3,8]:=  0; xyFeld[3,9]:=  0;
    UndoBuffer[7]:= " ";
    WITH Info[7] DO
      buffer:= ADR(Buffer[7,0]); undoBuffer:= ADR(UndoBuffer[7,0]);
      bufferPos:= 0; maxChars:= 40; dispPos:= 0;
    END;
    WITH gadarray[7] DO
      nextGadget:= ADR(gadarray[8]);
      leftEdge:= 325; topEdge :=185;
      width:= 60; height:= 10;
      flags:= GadgetFlagSet{};
      activation:= ActivationFlagSet{toggleSelect,stringCenter};
      gadgetType:= strGadget;
      gadgetRender:= ADR(Rahmen[3]); selectRender:= NIL; 
      gadgetText:= NIL; specialInfo:= ADR(Info[7]);
      gadgetID:= stringabl;
      userData:= NIL;
    END;       
    UndoBuffer[8]:= " ";
    WITH Info[8] DO
      buffer:= ADR(Buffer[8,0]); undoBuffer:= ADR(UndoBuffer[8,0]);
      bufferPos:= 0; maxChars:= 40; dispPos:= 0;
    END;
    WITH gadarray[8] DO
      nextGadget:= ADR(gadarray[9]);
      leftEdge:= 415; topEdge :=185;
      width:= 60; height:= 10;
      flags:= GadgetFlagSet{};
      activation:= ActivationFlagSet{toggleSelect,stringCenter};
      gadgetType:= strGadget;
      gadgetRender:= ADR(Rahmen[3]); selectRender:= NIL; 
      gadgetText:= NIL; specialInfo:= ADR(Info[8]);
      gadgetID:= stringpkt;
      userData:= NIL;
    END;        
    UndoBuffer[9]:= " ";
    WITH Info[9] DO
      buffer:= ADR(Buffer[9,0]); undoBuffer:= ADR(UndoBuffer[9,0]);
      bufferPos:= 0; maxChars:= 40; dispPos:= 0;
    END;
    WITH gadarray[9] DO
      nextGadget:= ADR(gadarray[10]);
      leftEdge:= 505; topEdge :=185;
      width:= 60; height:= 10;
      flags:= GadgetFlagSet{};
      activation:= ActivationFlagSet{stringCenter};
      gadgetType:= strGadget;
      gadgetRender:= ADR(Rahmen[3]); selectRender:= NIL; 
      gadgetText:= NIL; specialInfo:= ADR(Info[9]);
      gadgetID:= stringgenau;
      userData:= NIL;
    END;        
    CopyToChip(ADR(okimagedata),imageptr,oksize);
    CopyToChip(ADR(okhimagedata),himageptr,okhsize);
    WITH ok DO
      leftEdge:= 0; topEdge:= 0; width:= 80; height:= 20; depth:=2;
      imageData:= imageptr; planePick:= 3; planeOnOff:= 0;
      nextImage:= NIL;
    END;
    WITH okh DO
      leftEdge:= 0; topEdge:= 0; width:= 80; height:= 20; depth:=2;
      imageData:= himageptr; planePick:= 3; planeOnOff:= 0;
      nextImage:= NIL;
    END;
    WITH gadarray[10] DO
      nextGadget:= NIL;
      leftEdge:= 280; topEdge:= 230;
      width:= 80; height:= 20;
      flags:= GadgetFlagSet{gadgImage,gadgHImage};
      activation:= ActivationFlagSet{gadgImmediate,relVerify,toggleSelect};
      gadgetType:= boolGadget;
      gadgetRender:= ADR(ok); selectRender:= ADR(okh); 
      gadgetText:= NIL; specialInfo:= NIL;
      gadgetID:= booleangadget;
      userData:= NIL;
    END;
    MyWindowPtr:= OpenWindow(MyWindow);
    Assert(MyWindowPtr # NIL, ADR("Fenster nicht geffnet"));
    rp:= MyWindowPtr^.rPort;
    Move(rp,185,29);  Text(rp,ADR("P L O T T E R    Intervalleingabe"),33); 
    rand(rp,50,10,543,210);
    Move(rp,50,40); Draw(rp,593,40); 
    SetAPen(rp,2);  
    Move(rp,300,90);  Text(rp,ADR("Ymax"),4);
    Move(rp,177,122); Text(rp,ADR("Xmin"),4);
    Move(rp,427,122); Text(rp,ADR("Xmax"),4);
    Move(rp,300,153); Text(rp,ADR("Ymin"),4);
    Move(rp,110,206); Text(rp,ADR("dX"),2);
    Move(rp,220,206); Text(rp,ADR("dY"),2);
    Move(rp,330,206); Text(rp,ADR("Abltg."),6);
    Move(rp,420,206); Text(rp,ADR("Punkte"),6);
    Move(rp,512,206); Text(rp,ADR("Genau"),5);
    rand(rp,54,12,535,26);
    rand(rp,54,42,535,176);
    aktgadget:= stringymax;
    LOOP
      klaro:= ActivateGadget(ADR(gadarray[aktgadget]),MyWindowPtr,NIL);
      WaitPort(MyWindowPtr^.userPort); 
      lastKey:= hRegister;
      ModifyIDCMP(MyWindowPtr,IDCMPFlagSet{gadgetUp});
      IntuiMsg:= GetMsg(MyWindowPtr^.userPort);
      class:= IntuiMsg^.class;
      ReplyMsg(IntuiMsg);
      IF ( (lastKey=101) OR (lastKey=119) ) AND 
            PressRButton() THEN
        INC(aktgadget);
        IF (aktgadget=10) AND  (lastKey=119)  THEN
          EXIT;
        END;
        IF (aktgadget>=10) THEN
          aktgadget:= 1;
        END;
      ELSIF (lastKey=103) AND PressRButton() THEN
        DEC(aktgadget);
        IF (aktgadget<=0) THEN 
          aktgadget:= 9;
        END;
      ELSIF (lastKey=121) THEN
        EXIT;
      END;
      IF ( class=IDCMPFlagSet{gadgetUp} ) OR
         (class=IDCMPFlagSet{closeWindow} ) THEN
        EXIT;
      END;
      ModifyIDCMP(MyWindowPtr,IDCMPFlagSet{gadgetUp,intuiTicks});
    END;
    CloseWindow(MyWindowPtr);
    FreeMem(imageptr,oksize);
    FreeMem(himageptr,okhsize);
  END grossintervall;



  PROCEDURE funkeingabe();

    VAR 
      MyWindow    		: NewWindow ;
      MyWindowPtr         	: WindowPtr ;
      class			: IDCMPFlagSet ;
      IntuiMsg    		: POINTER TO IntuiMessage ;
      myintuitext		: ARRAY [1..3] OF IntuiText ;
      fgad			: ARRAY[1..6] OF Gadget;
      bgad			: ARRAY[1..9] OF Gadget;	
      Info 			: ARRAY[1..6] OF StringInfo ;
      Rahmen			: ARRAY[1..4] OF Border;
      xyFeld			: ARRAY[1..4],[0..9]  OF INTEGER ;
      UndoBuffer		: ARRAY[1..6] OF STRING;
      printstr			: STRING;
      rp			: RastPortPtr;
      i				: CARDINAL;
      helpstr			: ARRAY[0..2] OF CHAR;
      error			: BOOLEAN;
      welches			: POINTER TO Gadget;
 
     
  BEGIN
    WITH MyWindow DO
      leftEdge:= 0; topEdge:= 0;       
      width:= 640; height:= 256;
      detailPen:= 0; blockPen:= 0;
      idcmpFlags:= IDCMPFlagSet{gadgetUp,intuiTicks}; 
      flags:= WindowFlagSet{};  
      firstGadget:=  ADR(fgad[1]);
      checkMark:= NIL;
      title:= ADR("Eingabe der Funktion");
      bitMap:= NIL;
      type:= ScreenFlagSet{wbenchScreen};
      minWidth:= 640; maxWidth:= 640;
      minHeight:= 256; maxHeight:= 256;     
    END;
    WITH Rahmen[1] DO				
      leftEdge:= -1; topEdge:= -2;
      frontPen:= 1; backPen:= 0;
      drawMode:= jam1;
      count:= 5; xy:= ADR(xyFeld[1]);
      nextBorder:= NIL;
    END;
    xyFeld[1][0]:= 0;   xyFeld[1][1]:= 0;
    xyFeld[1][2]:= 261; xyFeld[1][3]:= 0;
    xyFeld[1][4]:= 261; xyFeld[1][5]:= 11;
    xyFeld[1][6]:= 0;   xyFeld[1][7]:= 11;
    xyFeld[1][8]:= 0;   xyFeld[1][9]:= 0;
    WITH Rahmen[2] DO				
      leftEdge:= -4; topEdge:= -4;
      frontPen:= 1; backPen:= 0;
      drawMode:= jam1;
      count:= 5; xy:= ADR(xyFeld[2]);
      nextBorder:= ADR(Rahmen[1]);
    END;
    xyFeld[2][0]:= 0;   xyFeld[2][1]:= 0;
    xyFeld[2][2]:= 267; xyFeld[2][3]:= 0;
    xyFeld[2][4]:= 267; xyFeld[2][5]:= 15;
    xyFeld[2][6]:= 0;   xyFeld[2][7]:= 15;
    xyFeld[2][8]:= 0;   xyFeld[2][9]:= 0;
    
    WITH Rahmen[3] DO				
      leftEdge:= -1; topEdge:= -1;
      frontPen:= 1; backPen:= 0;
      drawMode:= jam1;
      count:= 5; xy:= ADR(xyFeld[3]);
      nextBorder:= NIL;
    END;
    xyFeld[3][0]:= 0;   xyFeld[3][1]:= 0;
    xyFeld[3][2]:= 61;  xyFeld[3][3]:= 0;
    xyFeld[3][4]:= 61;  xyFeld[3][5]:= 16;
    xyFeld[3][6]:= 0;   xyFeld[3][7]:= 16;
    xyFeld[3][8]:= 0;   xyFeld[3][9]:= 0;
    
   WITH Rahmen[4] DO				
      leftEdge:= -1; topEdge:= -1;
      frontPen:= 1; backPen:= 0;
      drawMode:= jam1;
      count:= 5; xy:= ADR(xyFeld[4]);
      nextBorder:= NIL;
    END;
    xyFeld[4][0]:= 0;   xyFeld[4][1]:= 0;
    xyFeld[4][2]:= 11;  xyFeld[4][3]:= 0;
    xyFeld[4][4]:= 11;  xyFeld[4][5]:= 11;
    xyFeld[4][6]:= 0;   xyFeld[4][7]:= 11;
    xyFeld[4][8]:= 0;   xyFeld[4][9]:= 0;
    
    FOR i:= 1 TO 5 DO
      WITH Info[i] DO
        buffer:= ADR(funkstr[i]);
        undoBuffer:= ADR(UndoBuffer[i]);
        bufferPos:= 0; maxChars:= 80; dispPos:= 0;
      END; 
      WITH fgad[i] DO			
        nextGadget:= ADR(fgad[i+1]);
        leftEdge:= 220; topEdge:= 30+20*i;
        width:= 260; height:= 10;
        flags:= GadgetFlagSet{};
        activation:= ActivationFlagSet{stringCenter};
        gadgetType:= strGadget;
        gadgetRender:= ADR(Rahmen[1]); selectRender:= NIL; 
        gadgetText:= NIL; specialInfo:= ADR(Info[i]);
        gadgetID:= i;
        userData:= NIL;
      END;
    END;
    WITH fgad[6] DO
      nextGadget:= ADR(bgad[1]);
      leftEdge:= 220; topEdge:= 155;
      width:= 260; height:= 10;
      flags:= GadgetFlagSet{};
      activation:= ActivationFlagSet{stringCenter};
      gadgetType:= strGadget;
      gadgetRender:= ADR(Rahmen[2]); selectRender:= NIL; 
      gadgetText:= NIL; specialInfo:= ADR(Info[6]);
      gadgetID:= 6;
      userData:= NIL;
    END;
    WITH Info[6] DO
      buffer:= ADR(string); undoBuffer:= ADR(UndoBuffer[6]);
      bufferPos:= 0; maxChars:= 80; dispPos:= 0;
    END; 
    
    CopyToChip(ADR(okimagedata),imageptr,oksize);
    CopyToChip(ADR(okhimagedata),himageptr,okhsize);
    WITH ok DO
      leftEdge:= 0; topEdge:= 0; width:= 80; height:= 20; depth:=2;
      imageData:= imageptr; planePick:= 3; planeOnOff:= 0;
      nextImage:= NIL;
    END;
    WITH okh DO
      leftEdge:= 0; topEdge:= 0; width:= 80; height:= 20; depth:=2;
      imageData:= himageptr; planePick:= 3; planeOnOff:= 0;
      nextImage:= NIL;
    END;
    
    FOR i:= 1 TO 3 DO
      WITH myintuitext[i] DO
         frontPen:= 1; backPen:= 0;
        drawMode:= jam1;
        leftEdge:= 3; topEdge:= 2;
        nextText:= NIL;
        iTextFont:= NIL;
        CASE i OF
          |1:	iText:= ADR("Copy");
          |2:   iText:= ADR("Ableit");
          |3:   iText:= ADR("Clear");
        END;
      END;
      WITH bgad[i] DO
        nextGadget:= ADR(bgad[i+1]);
        leftEdge:= 15+135*i; topEdge:= 203;
        width:= 60; height:= 15;
        flags:= GadgetFlagSet{};
        activation:= ActivationFlagSet{gadgImmediate,relVerify};
        gadgetType:= boolGadget;
        gadgetRender:= ADR(Rahmen[3]); selectRender:= NIL;
        gadgetText:= ADR(myintuitext[i]); specialInfo:= NIL;
        gadgetID:= 6+i;
        userData:= NIL;
      END;
    END;
    WITH bgad[4] DO
      nextGadget:= ADR(bgad[5]);
      leftEdge:= 275; topEdge:= 229;
      width:= 60; height:= 20;
      flags:= GadgetFlagSet{gadgImage,gadgHImage};
      activation:= ActivationFlagSet{gadgImmediate,relVerify};
      gadgetType:= boolGadget;
      gadgetRender:= ADR(ok); selectRender:= ADR(okh); 
      gadgetText:= NIL; specialInfo:= NIL;
      gadgetID:= 10;
      userData:= NIL;
    END;
    FOR i:= 5 TO 8 DO
      WITH bgad[i] DO
        nextGadget:= ADR(bgad[i+1]);
        leftEdge:= 500; topEdge:= 29+20*(i-4);;
        width:= 10; height:= 10;
        flags:= GadgetFlagSet{};
        activation:= ActivationFlagSet{gadgImmediate,relVerify};
        gadgetType:= boolGadget;
        gadgetRender:= ADR(Rahmen[4]); selectRender:= NIL;
        gadgetText:= NIL; specialInfo:= NIL;
        mutualExclude:= LONGSET{};
        gadgetID:= i+6;
        userData:= NIL;
      END;
    END;
    
    WITH bgad[9] DO
        nextGadget:= NIL;
        leftEdge:= 500; topEdge:= 30+20*(9-4);
        width:= 10; height:= 10;
        flags:= GadgetFlagSet{};
        activation:= ActivationFlagSet{gadgImmediate,relVerify};
        gadgetType:= boolGadget;
        gadgetRender:= ADR(Rahmen[4]); selectRender:= NIL;
        gadgetText:= NIL; specialInfo:= NIL;
        gadgetID:= 9+6;
        userData:= NIL;
    END;
    
    MyWindowPtr:= OpenWindow(MyWindow);
    Assert(MyWindowPtr # NIL, ADR("Fenster nicht geffnet"));
    rp:= MyWindowPtr^.rPort;
    rand(rp,100,10,440,26);
    rand(rp,100,38,440,216);
    SetAPen(rp,2);
    rand(rp,104,12,432,22);
    rand(rp,104,40,432,212);
    Move(rp,210,27);
    Text(rp,ADR("E I N G A B E  der Funktion"),27);
    SetAPen(rp,1);
    FOR i:= 1 TO 5 DO
      printstr:= "f(x) =";
      RealToStr(LONGREAL(i),helpstr,1,0,FALSE,error);
      Insert(printstr,1,helpstr);
      Move(rp,150,37+20*i);
      Text(rp,ADR(printstr),7);
    END;
    Move(rp,150,162);
    Text(rp,ADR("f (x) ="),7); 
    klaro:= ActivateGadget(ADR(fgad[1]),MyWindowPtr,NIL);
    i:= 1;
    LOOP
      WaitPort(MyWindowPtr^.userPort); 
      lastKey:= hRegister;
      ModifyIDCMP(MyWindowPtr,IDCMPFlagSet{gadgetUp});
      IntuiMsg:= GetMsg(MyWindowPtr^.userPort);
      class:= IntuiMsg^.class;
      welches:= IntuiMsg^.iAddress;
      ReplyMsg(IntuiMsg);
      IF ( class=IDCMPFlagSet{closeWindow} ) OR (lastKey=121) THEN
        Copy(string,funkstr[i]);
        EXIT; 
      ELSIF (lastKey=119) AND PressRButton()  THEN
        Copy(string,funkstr[i]);
        RefreshGadgets(ADR(fgad[1]),MyWindowPtr,NIL);
        klaro:= ActivateGadget(ADR(fgad[6]),MyWindowPtr,NIL);
      ELSIF (gadgetUp IN class) THEN
        CASE welches^.gadgetID OF
          | 7: Copy(string,funkstr[i]);
               RefreshGadgets(ADR(fgad[1]),MyWindowPtr,NIL);
          | 8: ableitung(funkstr[i],printstr);
               Copy(funkstr[i],printstr);
               RefreshGadgets(ADR(fgad[1]),MyWindowPtr,NIL);
          | 9: funkstr[i]:= "";
               RefreshGadgets(ADR(fgad[1]),MyWindowPtr,NIL);
          |10: EXIT;
          |11..15: 
               i:= welches^.gadgetID-10;
        ELSE
          ;  
        END;
      END;
      ModifyIDCMP(MyWindowPtr,IDCMPFlagSet{gadgetUp,intuiTicks});
    END;				
    CloseWindow(MyWindowPtr);
    MyWindowPtr:= NIL;
    FreeMem(imageptr,oksize);
    FreeMem(himageptr,okhsize);
    IF NOT Compile(FORMEL,string) THEN
      BreakPoint(ADR("Konnte Funktion nicht parsen !"));
    END;
    FNUM:= GetVarNr(FORMEL,"x");
    
  END funkeingabe;



END intervall.

