(*

    Programm	:	Kurve
    Autor	:	Jrg Wesemann
    Adresse	:	Auf der Heide 10 , 2807 Achim - Baden
    Telefon	:	04202 / 70658
    Version	:	3.20 (deutsch)
    Datum	:	28.09.1989
    Copyright	:	Public Domain, bei eigenen nderungen bitte Nachricht !
    Compiler	:	M2-Amiga Modula-2, Version 3.2d, 01.11.88
    Importiert	:	-
    Fehler	:	nicht bekannt

*)

IMPLEMENTATION MODULE symmetrie;

FROM InOut 		IMPORT 	Write,WriteString,WriteLn,OpenOutput,
				CloseOutput;
FROM startupproc 	IMPORT 	fn,crlf,CLS,cursorr,nopoints,eps,d,wptr,
				dateiabfrage,center,fragedatei;
FROM menu 		IMPORT 	wartemenu;
FROM Intuition		IMPORT	WindowToFront;


PROCEDURE symmetrie;

   PROCEDURE punkts():BOOLEAN;
   
     VAR
       i  : CARDINAL;
       x  : LONGREAL;
       s  : BOOLEAN;
       
   BEGIN
     s:= TRUE;
     i:= 1;
     x:= 0.0;
     WHILE (s = TRUE) AND (i <= nopoints ) DO
       x:= x + d;
       s:= ABS(fn(x,0) + fn(-x,0)) < eps;
       INC(i);
     END;
     RETURN s;
   
   END punkts;
   
   
   
   PROCEDURE achss():BOOLEAN;
   
     VAR
       i  : CARDINAL;
       x  : LONGREAL;
       s  : BOOLEAN;
   
   BEGIN
     s:= TRUE;
     i:= 1;
     x:= 0.0;
     WHILE (s = TRUE) AND (i <= nopoints ) DO
       x:= x + d;
       s:= ABS(fn(x,0) - fn(-x,0)) < eps;
       INC(i);
     END;
     RETURN s; 
   END achss;
       
BEGIN						(* symmetrie Main	*)
  WindowToFront(wptr);
  Write(CLS); 
  IF dateiabfrage THEN
    fragedatei();
  END;   
  crlf(4);
  center("SYMMETRIEBERPRFUNG"); WriteLn;
  center("--------------------"); 
  crlf(6);
  IF (punkts() = TRUE) THEN
    center("Die Funktion ist   - punktsymmetrisch -   zum Ursprung");
  ELSIF (achss() = TRUE) THEN
    center("Die Funktion ist   - achsensymmetrisch -   zur Y-Achse");
  ELSE
    center("Es ist keine Symmetrie erkennbar"); 
  END;
  WriteLn;
  CloseOutput;
  crlf(4);
  center("Bitte 'RETURN' drcken fr MENU ");
  wartemenu;
END symmetrie;           
            
END symmetrie.
