(*********************************************************************
 
    :Program.  	 UNIXtst.mod
    :Author.   	 Joel Swank (von Fred Fish #165)
    :Author.     bersetzung in MODULA2, Gary Struhlik
    :Version.  	 1.0
    :Date.     	 10.09.1989 (original C Source code 19.04.88, Joel Swank)
    :Copyright.  Public Domain
    :Language. 	 Modula-II
    :Translator. M2Amiga 3.2d
    :Imports.	 UNIXPlot [Joel Swank] [gs]
    :Contents.   Testprogramm fr UNIXPlot Kommandos
    :Remark.	 Fr den Amiga Modula-2 Klub / Stuttgart

***************************************************************)

MODULE UNIXtst;

FROM UNIXPlot IMPORT openpl,space, erase, move, label, circle, arc, cont,
                     point, line, linemod, closepl;

BEGIN
	openpl("plotdemo.plot");
	space(0,0,4096,4096);
	erase();
	move(100,100);
	label("Test label");
	line(200,300,300,400);
	circle(500,500,50);
	circle(500,500,200);
	point(1000,1000);
	arc(1000,1000,1100,1000,1000,1100);
	cont(600,700);
	point(50,50);
	point(50,52);
	point(50,54);
	linemod("dotted");
	line(250,350,350,450);
	closepl()
END UNIXtst.
