(*--------------------------------------------------------------------------
    :Program.      MUPF.mod
    :Author.       Norbert Sdorf
    :Address.      Krnerstrae 6, D 6840 Lampertheim 1
    :Phone.        06206/2212
    :History.      V1.0, 3-September-1989
    :Copyright.    Norbert Sdorf 1989.(program freely distributable)
    :Language.     Modula-II
    :Translator.   M2Amiga 3.2d
    :Contents.     'system-configuration' per Mausklick als
    :Contents.     RAM-Datei (mit Icon), zur Verwendung mit 'UsePrefs'.
---------------------------------------------------------------------------*)
MODULE MUPF;

(* $R- $V- $S- $F- *)

FROM SYSTEM    IMPORT ADR,INLINE;
FROM Arts      IMPORT Requester,Terminate;
FROM ASCII     IMPORT eol;
FROM Dos       IMPORT Open,Close,Read,Write,FileHandlePtr,oldFile,
                      newFile,Delay;
FROM Icon      IMPORT GetDiskObject,PutDiskObject,FreeDiskObject;
FROM Workbench IMPORT noIconPosition,DiskObjectPtr;
FROM Intuition IMPORT GetPrefs;

TYPE String = ARRAY [0..79] OF CHAR;

VAR
      ConFigFile,MupfFile,Console   : FileHandlePtr;
      MyObject                      : DiskObjectPtr;
      Buffer                        : ARRAY [0..255] OF CHAR;
      x,MessLen                     : CARDINAL;
      written,Lenge                 : LONGINT;
      OutMessage                    : ARRAY [0..13] OF String;
      done                          : BOOLEAN;

PROCEDURE IconDaten; (* $E- *)

BEGIN

INLINE(0E310H,00001H,00000H,00000H,00089H,0000FH,00027H,00016H);
INLINE(00004H,00003H,00001H,00001H,0DD88H,00000H,00000H,00000H);
INLINE(00000H,00000H,00000H,00000H,00000H,00000H,00000H,00000H);
INLINE(00405H,00001H,0DDA0H,00000H,0AE80H,00000H,00077H,00000H);
INLINE(00004H,00000H,00000H,00000H,00000H,00000H,00000H,00000H);
INLINE(00000H,00027H,00015H,00002H,00006H,07660H,00300H,00000H);
INLINE(00000H,00000H,00000H,00000H,03FFFH,0FFFFH,0F800H,03FFFH);
INLINE(0FFFFH,0F800H,03521H,02021H,09800H,03FFFH,0FFFFH,0F800H);
INLINE(03FFEH,0007FH,0F800H,03218H,0FF18H,01800H,03FF3H,0FFCFH);
INLINE(0F800H,03FE7H,0C3E7H,0F800H,03260H,013E4H,01800H,03FFFH);
INLINE(0E7CFH,0F800H,03FFFH,09F3FH,0F800H,03213H,03E64H,09800H);
INLINE(03FFEH,07CFFH,0F800H,03FFFH,001FFH,0F800H,03086H,07CC8H);
INLINE(01800H,03FFFH,001FFH,0F800H,03033H,0FF20H,01800H,03FFFH);
INLINE(0FFFFH,0F800H,03FFFH,0FFFFH,0F800H,00000H,00000H,00000H);
INLINE(0FFFFH,0FFFFH,0FE00H,0C000H,00000H,00600H,0C000H,00000H);
INLINE(00600H,0CADEH,0DFDEH,06600H,0C000H,00000H,00600H,0C001H);
INLINE(0FF80H,00600H,0CDE7H,0FFE7H,0E600H,0C00FH,0FFF0H,00600H);
INLINE(0C01FH,0FFF8H,00600H,0CD9FH,0EFFBH,0E600H,0C000H,01FF0H);
INLINE(00600H,0C000H,07FC0H,00600H,0CDECH,0FF9BH,06600H,0C001H);
INLINE(0FF00H,00600H,0C000H,0FE00H,00600H,0CF79H,0FF37H,0E600H);
INLINE(0C000H,0FE00H,00600H,0CFCCH,000DFH,0E600H,0C000H,00000H);
INLINE(00600H,0C000H,00000H,00600H,0FFFFH,0FFFFH,0FE00H,00000H);
INLINE(00013H,05359H,0533AH,07072H,06566H,0732FH,05573H,06550H);
INLINE(07265H,06673H,00000H,00000H,00800H,00000H,02928H,0636FH);
INLINE(06E66H,06967H,07572H,06174H,0696FH,06E20H,06669H,06C65H);
INLINE(02063H,07265H,06174H,06564H,02062H,07920H,04D55H,05046H);
INLINE(02031H,02E30H,02900H);

END IconDaten;

BEGIN

 OutMessage[0]:="******************************************************";
 OutMessage[1]:="* MUPF = M(ake) U(se)P(refs) F(ile) ... version 1.0  *";
 OutMessage[2]:="******************************************************";
 OutMessage[3]:="* Copyrights by N.Sdorf '89 (freely distributable) *";
 OutMessage[4]:="* -------------------------------------------------- *";
 OutMessage[5]:="*   DONE. Please open RAM DISK, rename configuration *";
 OutMessage[6]:="*         file and copy where needed !               *";
 OutMessage[7]:="*                                                    *";
 OutMessage[8]:="* FERTIG. Bitte RAM DISK ffnen, Konfigurationsdatei *";
 OutMessage[9]:="*         umbenennen und auf Diskette kopieren !     *";
OutMessage[10]:="*                                                    *";
OutMessage[11]:="******************************************************";
OutMessage[12]:="                                                      ";
OutMessage[13]:="Quit = <RETURN> ";
MessLen:=54;

    Console:=Open(ADR("CON:10/25/580/160/ MUPF 1.0 "),newFile);
 IF Console = NIL THEN
    done:=Requester(ADR("MUPF: No CON:-window !"),
                    ADR("MUPF: Kein CON:-Fenster !"),NIL,ADR("QUIT"));
    Terminate(0);
 END;

   FOR x:=0 TO 4 DO
       OutMessage[x,MessLen]:=eol;
       written:=Write(Console,ADR(OutMessage[x]),MessLen+1);
   END;

   GetPrefs(ADR(Buffer),232);

       MupfFile:=Open(ADR("ram:MUPFdata"),newFile);
    IF MupfFile # NIL THEN
       Lenge:=Write(MupfFile,ADR(Buffer),232);
       Close(MupfFile);
    ELSE
       done:=Requester(ADR("MUPF: couldn't create file !"),
                       ADR("MUPF: Datei nicht erzeugt !"),NIL,ADR("QUIT"));
       Close(Console);Terminate(0);
    END;

       MupfFile:=Open(ADR("ram:MUPFdata.info"),newFile);
    IF MupfFile # NIL THEN
       Lenge:=Write(MupfFile,ADR(IconDaten),422);
       Close(MupfFile);
    ELSE
       done:=Requester(ADR("MUPF: couldn't create icon !"),
                       ADR("MUPF: Ikone nicht erzeugt !"),NIL,ADR("QUIT"));
       Close(Console);Terminate(0);
    END;

     MyObject:=GetDiskObject(ADR("ram:MUPFdata"));
     MyObject^.currentX:=noIconPosition;
     MyObject^.currentY:=noIconPosition;
     written:=PutDiskObject(ADR("ram:MUPFdata"),MyObject);
     FreeDiskObject(MyObject);

 FOR x:=5 TO 12 DO
     OutMessage[x,MessLen]:=eol;
     written:=Write(Console,ADR(OutMessage[x]),MessLen+1);
 END;
   written:=Write(Console,ADR(OutMessage[13]),16);
   Lenge:=Read(Console,ADR(Buffer),1);
   Close(Console);

END MUPF.
