(**********************************************************************
  :Program.    Assembler2.mod
  :Contents.   Some M2-Procedures translated to Assembler for M2Amiga V3.2d
  :Author.     Stefan Salewski
  :Copyright.  Public Domain
  :Language.   Modula-2 with INLINE-Assembler-Code
  :Translator. M2Amiga AMSoft V3.2d and Profimat
  :History.    V1.0 2.Jul.1989
  :Address.    Stolper Weg 3, D-2160 Stade
**********************************************************************)

IMPLEMENTATION MODULE Assembler2;
  FROM SYSTEM IMPORT INLINE,ADDRESS,BYTE;
  FROM Exec IMPORT UByte;

  (*$F-*) 
  PROCEDURE MaxCard(i{2}:CARDINAL;j{3}:CARDINAL):CARDINAL;
  (*$E-*)
  BEGIN
    INLINE(07000H,0B642H,06204H,03002H,04E75H,03003H,04E75H);
  END MaxCard;

  PROCEDURE MaxInt(i{2}:INTEGER;j{3}:INTEGER):INTEGER;
  (*$E-*)
  BEGIN
    INLINE(0B642H,06E06H,03002H,048C0H,04E75H,03003H,048C0H,04E75H);
  END MaxInt;

  PROCEDURE MinCard(i{2}:CARDINAL;j{3}:CARDINAL):CARDINAL;
  (*$E-*)
  BEGIN
    INLINE(07000H,0B642H,06204H,03003H,04E75H,03002H,04E75H);
  END MinCard;

  PROCEDURE MinInt(i{2}:INTEGER;j{3}:INTEGER):INTEGER;
  (*$E-*)
  BEGIN
    INLINE(0B642H,06E06H,03003H,048C0H,04E75H,03002H,048C0H,04E75H);
  END MinInt;

  PROCEDURE MaxLongCard(i{2}:LONGCARD;j{3}:LONGCARD):LONGCARD;
  (*$E-*)
  BEGIN
    INLINE(0B682H,06204H,02002H,04E75H,02003H,04E75H);
  END MaxLongCard;

  PROCEDURE MaxLongInt(i{2}:LONGINT;j{3}:LONGINT):LONGINT;
  (*$E-*)
  BEGIN
    INLINE(0B682H,06E04H,02002H,04E75H,02003H,04E75H);
  END MaxLongInt;

  PROCEDURE MinLongCard(i{2}:LONGCARD;j{3}:LONGCARD):LONGCARD;
  (*$E-*)
  BEGIN
    INLINE(0B682H,06204H,02003H,04E75H,02002H,04E75H);
  END MinLongCard;

  PROCEDURE MinLongInt(i{2}:LONGINT;j{3}:LONGINT):LONGINT;
  (*$E-*)
  BEGIN
    INLINE(0B682H,06E04H,02003H,04E75H,02002H,04E75H);
  END MinLongInt;
  
  PROCEDURE Fill(dest{A2}:ADDRESS;byte{2}:BYTE;len{3}:CARDINAL);
  (*$E-*)
  BEGIN
    INLINE(05343H,014C2H,051CBH,0FFFCH,04E75H);
  END Fill;
  
  PROCEDURE Equal(adr0{A0}:ADDRESS;adr1{A1}:ADDRESS;len{2}:CARDINAL):BOOLEAN;
  (*$E-*)
  BEGIN
  INLINE(05342H,01018H,0B019H,056CAH,0FFFAH,0B47CH,0FFFFH,06604H,
         070FFH,04E75H,07000H,04E75H);
  END Equal;

(*$F=*)

END Assembler2.mod
