(*---------------------------------------------------------------------------
   :Program.    Proc
   :Contants.   Start Procedure as Process
   :Remark.     Ported from C to Modula-2
   :History.    C-Edition by Arno Glzer
   :History.    V1.0, M. Peuckert, havigt spent a lot of time meditating
   :History.    V2.0, M. Peuckert, November 89
   :Author.     Markus Peuckert
   :Address.    Schtzenstr. 50, D-3550 Marburg, West-Germany,
   :Copyright.  PD
   :Language.   Modula-2
   :Translator. M2Amiga V3.2d
---------------------------------------------------------------------------*)

MODULE ProcTest;

FROM Arts       IMPORT  Assert;
FROM SYSTEM     IMPORT  ADR, LONGSET;
FROM Dos        IMPORT  ProcessPtr;
FROM Exec       IMPORT  FindTask, Wait, Signal;
FROM Dos        IMPORT  Delay;
FROM Terminal   IMPORT  WriteString, WriteLn, waitCloseGadget;
FROM Process    IMPORT  CreateFuncProcess;


CONST   ProcName        = "NewProc";

VAR     ProcPtr         : ProcessPtr;
        Sig             : LONGSET;



PROCEDURE TuWas;
BEGIN
 WriteString ("Ein neuer Proze ist da und wartet ein bichen");  WriteLn;
 Sig := Wait (LONGSET {1});
 WriteString ("Message da"); WriteLn;
 Delay (200);
 WriteString ("Warten fertig !"); WriteLn;
END TuWas;


BEGIN
 ProcPtr := NIL;        waitCloseGadget := FALSE;

 WriteString ("Hallo, hier ist der HauptProze"); WriteLn;
 ProcPtr := CreateFuncProcess (ProcName, 0, 8000, ADR(TuWas));

 Signal (ADR(ProcPtr^.task), LONGSET{1});

 WriteString ("HauptProze: Auch was tun!"); WriteLn;

 WHILE (FindTask (ADR(ProcName))#NIL) DO END;

 WriteString ("Haupt: Der ProzedurProze ist beendet/gelscht!"); WriteLn;
 Delay (100);

END ProcTest.
