(* -------------------------------------------------------------------------
  :Program.       TestDisky
  :Author.        Kai Bolay
  :Address.       Hoffmannstrae 168, 7250 Leonberg
  :Phone.         07152/22135
  :History.       v2.00 Kai Bolay 20-Jan-90 Rewritten for new FileRequest
  :History.       v2.01 Kai Bolay 17-Feb-90 Compiled under M2Amiga v3.3
  :Copyright.     PD
  :Language.      Modula-2
  :Translator.    M2Amiga 3.3d
  :Imports.       FileRequest
  :Contents.      Program to explain usage of FileRequest
------------------------------------------------------------------------- *)

MODULE TestDisky;

FROM FileRequest IMPORT RequestFile;
FROM Terminal    IMPORT WriteString, WriteLn;

VAR Path : ARRAY [1..200] OF CHAR;

BEGIN
   Path := "DF0:Select any file!";
   IF RequestFile (Path) THEN WriteString ("OK: "); WriteString (Path);
                         ELSE WriteString ("I've been canceled!"); END;
   WriteLn;
END TestDisky.
