IMPLEMENTATION MODULE edi;

FROM SYSTEM    IMPORT ADR, LONGSET;
FROM Intuition IMPORT MenuItem,Menu,MenuItemFlags,MenuItemFlagSet,
                      IDCMPFlags, IDCMPFlagSet, SetMenuStrip,
                      ClearMenuStrip, WindowPtr, NewWindow,
                      IntuiMessage, IntuiText,
                      ScreenFlags, ScreenFlagSet, WindowFlags,
                      WindowFlagSet, OpenWindow, CloseWindow;
FROM Graphics  IMPORT jam1;
FROM Exec      IMPORT GetMsg, ReplyMsg;

VAR MenuWindowPtr  : WindowPtr;
    IntuiMsg       : POINTER TO IntuiMessage;
    class          : IDCMPFlagSet;
    code           : CARDINAL;
    Menustrip      : ARRAY[1..5] OF Menu;
    Item           : ARRAY[1..32] OF MenuItem;
    ItemText       : ARRAY[1..32] OF IntuiText;
    ok             : BOOLEAN;
    MenuWindow     : NewWindow;

PROCEDURE InitMenu;
BEGIN
WITH MenuWindow DO
  leftEdge   :=0;   topEdge  :=0;
  width      :=640; height   :=256;
  detailPen  :=0;   blockPen :=1;
  idcmpFlags :=IDCMPFlagSet{ menuPick };
  flags      :=WindowFlagSet{ activate };
  firstGadget:=NIL; checkMark:=NIL;
  title      :=ADR('MenuWindow');
  bitMap     :=NIL;
  type       :=ScreenFlagSet{ wbenchScreen };
END (* WITH *);
WITH Menustrip[1] DO
  nextMenu:=ADR(Menustrip[2]);
  leftEdge:=0; topEdge:=0;
  width:=88; height:=9;
  flags:={0};
  menuName:=ADR('Projekt');
  firstItem:=ADR(Item[1]);
END (* WITH *);

WITH Menustrip[2] DO
  nextMenu:=ADR(Menustrip[3]);
  leftEdge:=108; topEdge:=0;
  width:=64; height:=9;
  flags:={0};
  menuName:=ADR('Edit');
  firstItem:=ADR(Item[9]);
END (* WITH *);

WITH Menustrip[3] DO
  nextMenu:=ADR(Menustrip[4]);
  leftEdge:=200; topEdge:=0;
  width:=88; height:=9;
  flags:={0};
  menuName:=ADR('Befehle');
  firstItem:=ADR(Item[14]);
END (* WITH *);

WITH Menustrip[4] DO
  nextMenu:=ADR(Menustrip[5]);
  leftEdge:=300; topEdge:=0;
  width:=100; height:=9;
  flags:={0};
  menuName:=ADR('Optionen');
  firstItem:=ADR(Item[24]);
END (* WITH *);

WITH Menustrip[5] DO
  nextMenu:=NIL;
  leftEdge:=420; topEdge:=0;
  width:=100; height:=9;
  flags:={0};
  menuName:=ADR('Modula-2');
  firstItem:=ADR(Item[30]);
END (* WITH *);

WITH Item[1] DO
  nextItem:=ADR(Item[2]);
  leftEdge:=0; topEdge:=0;
  width:=132; height:=9;
  flags:=MenuItemFlagSet{highComp,itemText,itemEnabled};
  mutualExclude:=LONGSET{};
  itemFill:=ADR(ItemText[1]);
  selectFill:=NIL;
  subItem:=NIL;
END (* WITH *); 

WITH Item[2] DO
  nextItem:=ADR(Item[3]);
  leftEdge:=0; topEdge:=10;
  width:=132; height:=9;
  flags:=MenuItemFlagSet{highComp,itemText,itemEnabled};
  mutualExclude:=LONGSET{};
  itemFill:=ADR(ItemText[2]);
  selectFill:=NIL;
  subItem:=NIL;
END (* WITH *); 

WITH Item[3] DO
  nextItem:=ADR(Item[4]);
  leftEdge:=0; topEdge:=20;
  width:=132; height:=9;
  flags:=MenuItemFlagSet{highComp,itemText,itemEnabled};
  mutualExclude:=LONGSET{};
  itemFill:=ADR(ItemText[3]);
  selectFill:=NIL;
  subItem:=NIL;
END (* WITH *); 

WITH Item[4] DO
  nextItem:=ADR(Item[5]);
  leftEdge:=0; topEdge:=30;
  width:=132; height:=9;
  flags:=MenuItemFlagSet{highComp,itemText,itemEnabled};
  mutualExclude:=LONGSET{};
  itemFill:=ADR(ItemText[4]);
  selectFill:=NIL;
  subItem:=NIL;
END (* WITH *); 

WITH Item[5] DO
  nextItem:=ADR(Item[6]);
  leftEdge:=0; topEdge:=40;
  width:=132; height:=9;
  flags:=MenuItemFlagSet{highComp,itemText,itemEnabled};
  mutualExclude:=LONGSET{};
  itemFill:=ADR(ItemText[5]);
  selectFill:=NIL;
  subItem:=NIL;
END (* WITH *); 

WITH Item[6] DO
  nextItem:=ADR(Item[7]);
  leftEdge:=0; topEdge:=50;
  width:=132; height:=9;
  flags:=MenuItemFlagSet{highComp,itemText,itemEnabled};
  mutualExclude:=LONGSET{};
  itemFill:=ADR(ItemText[6]);
  selectFill:=NIL;
  subItem:=NIL;
END (* WITH *); 

WITH Item[7] DO
  nextItem:=ADR(Item[8]);
  leftEdge:=0; topEdge:=60;
  width:=132; height:=9;
  flags:=MenuItemFlagSet{highComp,itemText,itemEnabled};
  mutualExclude:=LONGSET{};
  itemFill:=ADR(ItemText[7]);
  selectFill:=NIL;
  subItem:=NIL;
END (* WITH *); 

WITH Item[8] DO
  nextItem:=NIL;
  leftEdge:=0; topEdge:=70;
  width:=132; height:=9;
  flags:=MenuItemFlagSet{highComp,itemText,itemEnabled};
  mutualExclude:=LONGSET{};
  itemFill:=ADR(ItemText[8]);
  selectFill:=NIL;
  subItem:=NIL;
END (* WITH *); 

WITH Item[9] DO
  nextItem:=ADR(Item[10]);
  leftEdge:=0; topEdge:=0;
  width:=105; height:=9;
  flags:=MenuItemFlagSet{highComp,itemText,itemEnabled};
  mutualExclude:=LONGSET{};
  itemFill:=ADR(ItemText[9]);
  selectFill:=NIL;
  subItem:=NIL;
END (* WITH *); 

WITH Item[10] DO
  nextItem:=ADR(Item[11]);
  leftEdge:=0; topEdge:=10;
  width:=105; height:=9;
  flags:=MenuItemFlagSet{highComp,itemText,itemEnabled};
  mutualExclude:=LONGSET{};
  itemFill:=ADR(ItemText[10]);
  selectFill:=NIL;
  subItem:=NIL;
END (* WITH *); 

WITH Item[11] DO
  nextItem:=ADR(Item[12]);
  leftEdge:=0; topEdge:=20;
  width:=105; height:=9;
  flags:=MenuItemFlagSet{highComp,itemText,itemEnabled};
  mutualExclude:=LONGSET{};
  itemFill:=ADR(ItemText[11]);
  selectFill:=NIL;
  subItem:=NIL;
END (* WITH *); 

WITH Item[12] DO
  nextItem:=ADR(Item[13]);
  leftEdge:=0; topEdge:=30;
  width:=105; height:=9;
  flags:=MenuItemFlagSet{highComp,itemText,itemEnabled};
  mutualExclude:=LONGSET{};
  itemFill:=ADR(ItemText[12]);
  selectFill:=NIL;
  subItem:=NIL;
END (* WITH *); 

WITH Item[13] DO
  nextItem:=NIL;
  leftEdge:=0; topEdge:=40;
  width:=105; height:=9;
  flags:=MenuItemFlagSet{highComp,itemText,itemEnabled};
  mutualExclude:=LONGSET{};
  itemFill:=ADR(ItemText[13]);
  selectFill:=NIL;
  subItem:=NIL;
END (* WITH *); 

WITH Item[14] DO
  nextItem:=ADR(Item[15]);
  leftEdge:=-1; topEdge:=0;
  width:=148; height:=9;
  flags:=MenuItemFlagSet{highComp,itemText,itemEnabled};
  mutualExclude:=LONGSET{};
  itemFill:=ADR(ItemText[14]);
  selectFill:=NIL;
  subItem:=NIL;
END (* WITH *); 

WITH Item[15] DO
  nextItem:=ADR(Item[16]);
  leftEdge:=-1; topEdge:=10;
  width:=148; height:=9;
  flags:=MenuItemFlagSet{highComp,itemText,itemEnabled};
  mutualExclude:=LONGSET{};
  itemFill:=ADR(ItemText[15]);
  selectFill:=NIL;
  subItem:=NIL;
END (* WITH *); 

WITH Item[16] DO
  nextItem:=ADR(Item[17]);
  leftEdge:=-1; topEdge:=20;
  width:=148; height:=9;
  flags:=MenuItemFlagSet{highComp,itemText,itemEnabled};
  mutualExclude:=LONGSET{};
  itemFill:=ADR(ItemText[16]);
  selectFill:=NIL;
  subItem:=NIL;
END (* WITH *); 

WITH Item[17] DO
  nextItem:=ADR(Item[18]);
  leftEdge:=-1; topEdge:=30;
  width:=148; height:=9;
  flags:=MenuItemFlagSet{highComp,itemText,itemEnabled};
  mutualExclude:=LONGSET{};
  itemFill:=ADR(ItemText[17]);
  selectFill:=NIL;
  subItem:=NIL;
END (* WITH *); 

WITH Item[18] DO
  nextItem:=ADR(Item[19]);
  leftEdge:=-1; topEdge:=40;
  width:=148; height:=9;
  flags:=MenuItemFlagSet{highComp,itemText,itemEnabled};
  mutualExclude:=LONGSET{};
  itemFill:=ADR(ItemText[18]);
  selectFill:=NIL;
  subItem:=NIL;
END (* WITH *); 

WITH Item[19] DO
  nextItem:=ADR(Item[20]);
  leftEdge:=-1; topEdge:=50;
  width:=148; height:=9;
  flags:=MenuItemFlagSet{highComp,itemText,itemEnabled};
  mutualExclude:=LONGSET{};
  itemFill:=ADR(ItemText[19]);
  selectFill:=NIL;
  subItem:=NIL;
END (* WITH *); 

WITH Item[20] DO
  nextItem:=ADR(Item[21]);
  leftEdge:=-1; topEdge:=60;
  width:=148; height:=9;
  flags:=MenuItemFlagSet{highComp,itemText,itemEnabled};
  mutualExclude:=LONGSET{};
  itemFill:=ADR(ItemText[20]);
  selectFill:=NIL;
  subItem:=NIL;
END (* WITH *); 

WITH Item[21] DO
  nextItem:=ADR(Item[22]);
  leftEdge:=-1; topEdge:=70;
  width:=148; height:=9;
  flags:=MenuItemFlagSet{highComp,itemText,itemEnabled};
  mutualExclude:=LONGSET{};
  itemFill:=ADR(ItemText[21]);
  selectFill:=NIL;
  subItem:=NIL;
END (* WITH *); 

WITH Item[22] DO
  nextItem:=ADR(Item[23]);
  leftEdge:=-1; topEdge:=80;
  width:=148; height:=9;
  flags:=MenuItemFlagSet{highComp,itemText,itemEnabled};
  mutualExclude:=LONGSET{};
  itemFill:=ADR(ItemText[22]);
  selectFill:=NIL;
  subItem:=NIL;
END (* WITH *); 

WITH Item[23] DO
  nextItem:=NIL;
  leftEdge:=-1; topEdge:=90;
  width:=148; height:=9;
  flags:=MenuItemFlagSet{highComp,itemText,itemEnabled};
  mutualExclude:=LONGSET{};
  itemFill:=ADR(ItemText[23]);
  selectFill:=NIL;
  subItem:=NIL;
END (* WITH *); 

WITH Item[24] DO
  nextItem:=ADR(Item[25]);
  leftEdge:=1; topEdge:=0;
  width:=132; height:=9;
  flags:=MenuItemFlagSet{highComp,itemText,itemEnabled};
  mutualExclude:=LONGSET{};
  itemFill:=ADR(ItemText[24]);
  selectFill:=NIL;
  subItem:=NIL;
END (* WITH *); 

WITH Item[25] DO
  nextItem:=ADR(Item[26]);
  leftEdge:=1; topEdge:=10;
  width:=132; height:=9;
  flags:=MenuItemFlagSet{highComp,itemText,itemEnabled};
  mutualExclude:=LONGSET{};
  itemFill:=ADR(ItemText[25]);
  selectFill:=NIL;
  subItem:=NIL;
END (* WITH *); 

WITH Item[26] DO
  nextItem:=ADR(Item[27]);
  leftEdge:=1; topEdge:=20;
  width:=132; height:=9;
  flags:=MenuItemFlagSet{highComp,itemText,itemEnabled};
  mutualExclude:=LONGSET{};
  itemFill:=ADR(ItemText[26]);
  selectFill:=NIL;
  subItem:=NIL;
END (* WITH *); 

WITH Item[27] DO
  nextItem:=ADR(Item[28]);
  leftEdge:=1; topEdge:=30;
  width:=132; height:=9;
  flags:=MenuItemFlagSet{highComp,itemText,itemEnabled};
  mutualExclude:=LONGSET{};
  itemFill:=ADR(ItemText[27]);
  selectFill:=NIL;
  subItem:=NIL;
END (* WITH *); 

WITH Item[28] DO
  nextItem:=ADR(Item[29]);
  leftEdge:=1; topEdge:=40;
  width:=132; height:=9;
  flags:=MenuItemFlagSet{highComp,itemText,itemEnabled};
  mutualExclude:=LONGSET{};
  itemFill:=ADR(ItemText[28]);
  selectFill:=NIL;
  subItem:=NIL;
END (* WITH *); 

WITH Item[29] DO
  nextItem:=NIL;
  leftEdge:=1; topEdge:=50;
  width:=132; height:=9;
  flags:=MenuItemFlagSet{highComp,itemText,itemEnabled};
  mutualExclude:=LONGSET{};
  itemFill:=ADR(ItemText[29]);
  selectFill:=NIL;
  subItem:=NIL;
END (* WITH *); 

WITH Item[30] DO
  nextItem:=ADR(Item[31]);
  leftEdge:=0; topEdge:=0;
  width:=140; height:=9;
  flags:=MenuItemFlagSet{highComp,itemText,itemEnabled};
  mutualExclude:=LONGSET{};
  itemFill:=ADR(ItemText[30]);
  selectFill:=NIL;
  subItem:=NIL;
END (* WITH *); 

WITH Item[31] DO
  nextItem:=ADR(Item[32]);
  leftEdge:=0; topEdge:=10;
  width:=140; height:=9;
  flags:=MenuItemFlagSet{highComp,itemText,itemEnabled};
  mutualExclude:=LONGSET{};
  itemFill:=ADR(ItemText[31]);
  selectFill:=NIL;
  subItem:=NIL;
END (* WITH *); 

WITH Item[32] DO
  nextItem:=NIL;
  leftEdge:=0; topEdge:=20;
  width:=140; height:=9;
  flags:=MenuItemFlagSet{highComp,itemText,itemEnabled};
  mutualExclude:=LONGSET{};
  itemFill:=ADR(ItemText[32]);
  selectFill:=NIL;
  subItem:=NIL;
END (* WITH *); 


WITH ItemText[1] DO
  nextText:=NIL;
  frontPen:=0; backPen:=0;
  drawMode:=jam1;
  leftEdge:=0; topEdge:=0;
  iTextFont:=NIL;
  iText:=ADR('Oeffne Datei');
END (* WITH *);

WITH ItemText[2] DO
  nextText:=NIL;
  frontPen:=0; backPen:=0;
  drawMode:=jam1;
  leftEdge:=0; topEdge:=0;
  iTextFont:=NIL;
  iText:=ADR('Lies Datei');
END (* WITH *);

WITH ItemText[3] DO
  nextText:=NIL;
  frontPen:=0; backPen:=0;
  drawMode:=jam1;
  leftEdge:=0; topEdge:=0;
  iTextFont:=NIL;
  iText:=ADR('Neuer Dateiname');
END (* WITH *);

WITH ItemText[4] DO
  nextText:=NIL;
  frontPen:=0; backPen:=0;
  drawMode:=jam1;
  leftEdge:=0; topEdge:=0;
  iTextFont:=NIL;
  iText:=ADR('Neuer Buffer');
END (* WITH *);

WITH ItemText[5] DO
  nextText:=NIL;
  frontPen:=0; backPen:=0;
  drawMode:=jam1;
  leftEdge:=0; topEdge:=0;
  iTextFont:=NIL;
  iText:=ADR('Sichern');
END (* WITH *);

WITH ItemText[6] DO
  nextText:=NIL;
  frontPen:=0; backPen:=0;
  drawMode:=jam1;
  leftEdge:=0; topEdge:=0;
  iTextFont:=NIL;
  iText:=ADR('Sichern als');
END (* WITH *);

WITH ItemText[7] DO
  nextText:=NIL;
  frontPen:=0; backPen:=0;
  drawMode:=jam1;
  leftEdge:=0; topEdge:=0;
  iTextFont:=NIL;
  iText:=ADR('Sichern & Ende');
END (* WITH *);

WITH ItemText[8] DO
  nextText:=NIL;
  frontPen:=0; backPen:=0;
  drawMode:=jam1;
  leftEdge:=0; topEdge:=0;
  iTextFont:=NIL;
  iText:=ADR('Ende');
END (* WITH *);

WITH ItemText[9] DO
  nextText:=NIL;
  frontPen:=0; backPen:=0;
  drawMode:=jam1;
  leftEdge:=0; topEdge:=0;
  iTextFont:=NIL;
  iText:=ADR('Ausschneiden');
END (* WITH *);

WITH ItemText[10] DO
  nextText:=NIL;
  frontPen:=0; backPen:=0;
  drawMode:=jam1;
  leftEdge:=0; topEdge:=0;
  iTextFont:=NIL;
  iText:=ADR('Kopieren');
END (* WITH *);

WITH ItemText[11] DO
  nextText:=NIL;
  frontPen:=0; backPen:=0;
  drawMode:=jam1;
  leftEdge:=0; topEdge:=0;
  iTextFont:=NIL;
  iText:=ADR('Einsetzen');
END (* WITH *);

WITH ItemText[12] DO
  nextText:=NIL;
  frontPen:=0; backPen:=0;
  drawMode:=jam1;
  leftEdge:=0; topEdge:=0;
  iTextFont:=NIL;
  iText:=ADR('Loeschen');
END (* WITH *);

WITH ItemText[13] DO
  nextText:=NIL;
  frontPen:=0; backPen:=0;
  drawMode:=jam1;
  leftEdge:=0; topEdge:=0;
  iTextFont:=NIL;
  iText:=ADR('Auf Datei');
END (* WITH *);

WITH ItemText[14] DO
  nextText:=NIL;
  frontPen:=0; backPen:=0;
  drawMode:=jam1;
  leftEdge:=0; topEdge:=0;
  iTextFont:=NIL;
  iText:=ADR('Teile Fenster');
END (* WITH *);

WITH ItemText[15] DO
  nextText:=NIL;
  frontPen:=0; backPen:=0;
  drawMode:=jam1;
  leftEdge:=0; topEdge:=0;
  iTextFont:=NIL;
  iText:=ADR('Schliesse Fenster');
END (* WITH *);

WITH ItemText[16] DO
  nextText:=NIL;
  frontPen:=0; backPen:=0;
  drawMode:=jam1;
  leftEdge:=0; topEdge:=0;
  iTextFont:=NIL;
  iText:=ADR('Nur ein Fenster');
END (* WITH *);

WITH ItemText[17] DO
  nextText:=NIL;
  frontPen:=0; backPen:=0;
  drawMode:=jam1;
  leftEdge:=0; topEdge:=0;
  iTextFont:=NIL;
  iText:=ADR('Suche');
END (* WITH *);

WITH ItemText[18] DO
  nextText:=NIL;
  frontPen:=0; backPen:=0;
  drawMode:=jam1;
  leftEdge:=0; topEdge:=0;
  iTextFont:=NIL;
  iText:=ADR('Ersetze');
END (* WITH *);

WITH ItemText[19] DO
  nextText:=NIL;
  frontPen:=0; backPen:=0;
  drawMode:=jam1;
  leftEdge:=0; topEdge:=0;
  iTextFont:=NIL;
  iText:=ADR('Beginne Makro');
END (* WITH *);

WITH ItemText[20] DO
  nextText:=NIL;
  frontPen:=0; backPen:=0;
  drawMode:=jam1;
  leftEdge:=0; topEdge:=0;
  iTextFont:=NIL;
  iText:=ADR('Beende Makro');
END (* WITH *);

WITH ItemText[21] DO
  nextText:=NIL;
  frontPen:=0; backPen:=0;
  drawMode:=jam1;
  leftEdge:=0; topEdge:=0;
  iTextFont:=NIL;
  iText:=ADR('Makro ausfuehren');
END (* WITH *);

WITH ItemText[22] DO
  nextText:=NIL;
  frontPen:=0; backPen:=0;
  drawMode:=jam1;
  leftEdge:=0; topEdge:=0;
  iTextFont:=NIL;
  iText:=ADR('Neues CLI');
END (* WITH *);

WITH ItemText[23] DO
  nextText:=NIL;
  frontPen:=0; backPen:=0;
  drawMode:=jam1;
  leftEdge:=0; topEdge:=0;
  iTextFont:=NIL;
  iText:=ADR('Neues Verzeichnis');
END (* WITH *);

WITH ItemText[24] DO
  nextText:=NIL;
  frontPen:=0; backPen:=0;
  drawMode:=jam1;
  leftEdge:=0; topEdge:=0;
  iTextFont:=NIL;
  iText:=ADR('Aut. Einruecken');
END (* WITH *);

WITH ItemText[25] DO
  nextText:=NIL;
  frontPen:=0; backPen:=0;
  drawMode:=jam1;
  leftEdge:=0; topEdge:=0;
  iTextFont:=NIL;
  iText:=ADR('Gross/Klein');
END (* WITH *);

WITH ItemText[26] DO
  nextText:=NIL;
  frontPen:=0; backPen:=0;
  drawMode:=jam1;
  leftEdge:=0; topEdge:=0;
  iTextFont:=NIL;
  iText:=ADR('Erzeuge Ikone');
END (* WITH *);

WITH ItemText[27] DO
  nextText:=NIL;
  frontPen:=0; backPen:=0;
  drawMode:=jam1;
  leftEdge:=0; topEdge:=0;
  iTextFont:=NIL;
  iText:=ADR('Behalte Backup');
END (* WITH *);

WITH ItemText[28] DO
  nextText:=NIL;
  frontPen:=0; backPen:=0;
  drawMode:=jam1;
  leftEdge:=0; topEdge:=0;
  iTextFont:=NIL;
  iText:=ADR('Saeubere Zeilen');
END (* WITH *);

WITH ItemText[29] DO
  nextText:=NIL;
  frontPen:=0; backPen:=0;
  drawMode:=jam1;
  leftEdge:=0; topEdge:=0;
  iTextFont:=NIL;
  iText:=ADR('FileRequester');
END (* WITH *);

WITH ItemText[30] DO
  nextText:=NIL;
  frontPen:=0; backPen:=0;
  drawMode:=jam1;
  leftEdge:=0; topEdge:=0;
  iTextFont:=NIL;
  iText:=ADR('Naechster Fehler');
END (* WITH *);

WITH ItemText[31] DO
  nextText:=NIL;
  frontPen:=0; backPen:=0;
  drawMode:=jam1;
  leftEdge:=0; topEdge:=0;
  iTextFont:=NIL;
  iText:=ADR('Lies Fehlerliste');
END (* WITH *);

WITH ItemText[32] DO
  nextText:=NIL;
  frontPen:=0; backPen:=0;
  drawMode:=jam1;
  leftEdge:=0; topEdge:=0;
  iTextFont:=NIL;
  iText:=ADR('Compile Text');
END (* WITH *);

MenuWindowPtr:=OpenWindow(MenuWindow);
ok:=SetMenuStrip(MenuWindowPtr,ADR(Menustrip[1]) );
END InitMenu;
PROCEDURE MenuNum(Code : CARDINAL): CARDINAL;
BEGIN
  RETURN Code MOD 0020H;
END MenuNum;

PROCEDURE ItemNum(Code : CARDINAL): CARDINAL;
BEGIN
  RETURN Code DIV 0020H MOD 0040H;
END ItemNum;

PROCEDURE SubNum(Code : CARDINAL): CARDINAL;
BEGIN
  RETURN Code DIV 0800H;
END SubNum;

PROCEDURE MenuAbfrage;
BEGIN
  LOOP
    IntuiMsg:=GetMsg(MenuWindowPtr^.userPort);
    WHILE IntuiMsg # NIL DO
      class:=IntuiMsg^.class;
      code :=IntuiMsg^.code;
      ReplyMsg(IntuiMsg);
      IF (menuPick IN class) THEN
        CASE MenuNum(code) OF
            0: CASE ItemNum(code) OF
                 0: (* Prozedur fuer Oeffne Datei *)     |
                 1: (* Prozedur fuer Lies Datei *)     |
                 2: (* Prozedur fuer Neuer Dateiname *)     |
                 3: (* Prozedur fuer Neuer Buffer *)     |
                 4: (* Prozedur fuer Sichern *)     |
                 5: (* Prozedur fuer Sichern als *)     |
                 6: (* Prozedur fuer Sichern & Ende *)     |
                 7: (* Prozedur fuer Ende *)     |
               ELSE
               END (* CASE ItemNum *);    |
            1: CASE ItemNum(code) OF
                 0: (* Prozedur fuer Ausschneiden *)     |
                 1: (* Prozedur fuer Kopieren *)     |
                 2: (* Prozedur fuer Einsetzen *)     |
                 3: (* Prozedur fuer Loeschen *)     |
                 4: (* Prozedur fuer Auf Datei *)     |
               ELSE
               END (* CASE ItemNum *);    |
            2: CASE ItemNum(code) OF
                 0: (* Prozedur fuer Teile Fenster *)     |
                 1: (* Prozedur fuer Schliesse Fenster *)     |
                 2: (* Prozedur fuer Nur ein Fenster *)     |
                 3: (* Prozedur fuer Suche *)     |
                 4: (* Prozedur fuer Ersetze *)     |
                 5: (* Prozedur fuer Beginne Makro *)     |
                 6: (* Prozedur fuer Beende Makro *)     |
                 7: (* Prozedur fuer Makro ausfuehren *)     |
                 8: (* Prozedur fuer Neues CLI *)     |
                 9: (* Prozedur fuer Neues Verzeichnis *)     |
               ELSE
               END (* CASE ItemNum *);    |
            3: CASE ItemNum(code) OF
                 0: (* Prozedur fuer Aut. Einruecken *)     |
                 1: (* Prozedur fuer Gross/Klein *)     |
                 2: (* Prozedur fuer Erzeuge Ikone *)     |
                 3: (* Prozedur fuer Behalte Backup *)     |
                 4: (* Prozedur fuer Saeubere Zeilen *)     |
                 5: (* Prozedur fuer FileRequester *)     |
               ELSE
               END (* CASE ItemNum *);    |
            4: CASE ItemNum(code) OF
                 0: (* Prozedur fuer Naechster Fehler *)     |
                 1: (* Prozedur fuer Lies Fehlerliste *)     |
                 2: (* Prozedur fuer Compile Text *)     |
               ELSE
               END (* CASE ItemNum *);    |
        ELSE
        END (* CASE MenuNum *)   
      END (* IF *);
      IntuiMsg:=GetMsg(MenuWindowPtr^.userPort);
    END (* WHILE *);
  END (* LOOP *);
END MenuAbfrage;

PROCEDURE CloseMenu;
BEGIN
  ClearMenuStrip(MenuWindowPtr);
  CloseWindow(MenuWindowPtr);
END CloseMenu;

BEGIN
END edi.