(*----------------------------------------------------------------------------
  :Program.     Oberon.mod
  :Author.      Edgar Schwarz
  :Address.     Bhlgrten 4, D-7052 Scwaikheim
  :Phone.       (0)71951 / 53773
  :ShortCut.    [es]
  :Version.     0.1
  :Date.        4.10.89
  :CopyRight.   PD
  :Language.    MODULA-II
  :Translator.  M2Amiga.
  :Imports.     Oberonsyn, Oberonsem [CoCo]
  :Imports.     Errors [CoCoSystem]
  :Update.
  :History.
  :Contents.    Program to Compile Oberon to VM2
  :Contents.    Sourcecodes.
  :Remark.      Das wichtigste dabei ist Oberon.atg, die Grammatik
  :Remark.      zumindest einige Features sind schon verwirklicht
  :Usage.       Oberon
----------------------------------------------------------------------------*)
           
MODULE Oberon;

FROM InOut IMPORT
  WriteString, WriteLn, Read;
FROM Oberonsyn IMPORT 
  Parse, printinput;
FROM Errors IMPORT
  PrintSynErrors;
FROM FileIO IMPORT
  con;
    
VAR correct: BOOLEAN;
    nFehler: CARDINAL;
    
BEGIN
  (*printinput := TRUE;*)
  Parse(correct);
  IF correct THEN 
    WriteLn();
    WriteString('Programm in Ordnung');
  ELSE
    WriteLn();
    WriteString('Programm hat Fehler');
  END;
  WriteLn;
  PrintSynErrors(con,nFehler);
END Oberon. 
