(*          generated semantic analyzer
            ===========================
This module is produced by COCO from the semantic actions of the
attribute grammar.
---------------------------------------------------------------------*)
IMPLEMENTATION MODULE Oberonsem;
FROM FileIO IMPORT con, WriteCard, WriteString;
FROM SYSTEM IMPORT WORD;
FROM Oberonsyn IMPORT at;


  FROM OberonLex IMPORT RestartHash;
  FROM FileSystem IMPORT File,Lookup,Close;
  FROM FileIO IMPORT WriteLn;
  IMPORT og;(*OberonGen*)
  FROM og IMPORT spix,value;

PROCEDURE ASSIGN(VAR x:WORD; y:WORD);
BEGIN
  x:=y;
  END ASSIGN;

PROCEDURE Semant(sem:CARDINAL);

CONST NrSemacts=10; (*max. number of sem. actions*) (*3.12.,I,Dob*)

PROCEDURE Part1;
BEGIN
  CASE sem OF
     11: ;

  |  12: (*line 169*)
         ASSIGN(spix,at[1]);
  |  13: (*line 169*)
         og.qual1(spix);
  |  14: (*line 170*)
         og.qual2(spix);
  |  15: (*line 208*)
         og.IdList1(spix)
  |  16: (*line 209*)
         og.IdList2(spix)
  |  17: (*line 229*)
         og.desigQual();
  |  18: (*line 232*)
         og.expListT:=og.AI;
  |  19: (*line 243*)
         og.exp1();
      END; (*CASE*)
  END Part1;

PROCEDURE Part2;
BEGIN
  CASE sem OF
     20: (*line 248*)
         og.relation('=');
  |  21: (*line 249*)
         og.relation('#');
  |  22: (*line 250*)
         og.relation('<');
  |  23: (*line 251*)
         og.relation('<=');
  |  24: (*line 252*)
         og.relation('>');
  |  25: (*line 253*)
         og.relation('>=');
  |  26: (*line 254*)
         og.relation('IN');
  |  27: (*line 255*)
         og.relation('IS');
  |  28: (*line 263*)
         og.AddOp('+');
  |  29: (*line 264*)
         og.AddOp('-');
      END; (*CASE*)
  END Part2;

PROCEDURE Part3;
BEGIN
  CASE sem OF
     30: (*line 265*)
         og.AddOp('OR');
  |  31: (*line 273*)
         og.MulOp('*');
  |  32: (*line 274*)
         og.MulOp('/');
  |  33: (*line 275*)
         og.MulOp('DIV');
  |  34: (*line 276*)
         og.MulOp('MOD');
  |  35: (*line 277*)
         og.MulOp('&');
  |  36: (*line 280*)
         ASSIGN(value,at[1]);
  |  37: (*line 280*)
         og.factNum(value);
  |  38: (*line 281*)
         og.factStr(spix);
  |  39: (*line 296*)
         og.expListT:=og.AP;
      END; (*CASE*)
  END Part3;

PROCEDURE Part4;
BEGIN
  CASE sem OF
     40: (*line 315*)
         og.ACdesig();
  |  41: (*line 317*)
         og.ACcall();
  |  42: (*line 425*)
         og.ImpList();
  |  43: (*line 427*)
         og.ImpList();
  |  44: (*line 431*)
         og.import1(spix)
  |  45: (*line 433*)
         og.import2(spix)
  |  46: (*line 443*)
         RestartHash();
  |  47: (*line 444*)
         og.ImpPartName(spix);
  |  48: (*line 447*)
         og.startStop();
         og.BEGINstart();
  |  49: (*line 450*)
         og.CLOSEstart();
      END; (*CASE*)
  END Part4;

PROCEDURE Part5;
BEGIN
  CASE sem OF
     50: (*line 453*)
         og.CLOSEstop();
  |  51: (*line 454*)
         og.ImpPartName(spix);
      END; (*CASE*)
  END Part5;


BEGIN
  IF printactions THEN
    WriteString(con,"$   [");
    WriteCard(con,sem,3);
    WriteString(con,"] ");
    END;

  CASE (((sem-10) DIV NrSemacts)+1)  OF
    1: Part1;
  | 2: Part2; 
  | 3: Part3; 
  | 4: Part4; 
  | 5: Part5; 
    END; (*CASE*)
  END Semant;
BEGIN
  printactions:=FALSE;
  END Oberonsem.
