(**********************************************************************

    :Program.    CursorDemo.mod
    :Contents.   Demonstriert die Benutzung von Cursor Prozeduren
    :Author.     Markus Uhlendahl
    :Address.    Vorm Burgtor 16, D-4408 Dlmen
    :Phone.      02594/81540
    :Copyright.  Public Domain
    :Language.   Modula-2
    :Translator. M2Amiga AMSoft V3.3d

**********************************************************************)
MODULE CursorDemo;


FROM SYSTEM    IMPORT FFP;

FROM Terminal  IMPORT Write,WriteString,WriteLn;

FROM Cursor    IMPORT bold,normal,italic,ClrScr,Gotoxy,SetStyle,HideCursor,
                      ShowCursor;

FROM MathTrans IMPORT Sin,Cos;

FROM Joystick  IMPORT fire,joystick0;


VAR a,b,c : FFP;
    x,y   : INTEGER;


BEGIN
  ClrScr;
  SetStyle (normal,2,3);
  WriteString ("CursorDemo demonstriert Cursor Prozeduren ...");WriteLn;
  SetStyle (bold,2,0);
  WriteString ("fett ...");
  SetStyle (italic,2,0);
  WriteString ("und jetzt auch noch schrg");WriteLn;
  SetStyle (normal,2,3);
  WriteString ("Bitte linke Maustaste drcken");WriteLn;
  REPEAT
  UNTIL fire (joystick0); (* auf linke Maustaste warten *)
  c:=0.0;
  ClrScr;
  HideCursor;
  REPEAT
    a:=Sin(c)*35.0+40.0;
    b:=Cos(c)*10.0+12.0;
    x:=INTEGER(a);
    y:=INTEGER(b);
    Gotoxy (x,y);
    Write ("+");
    c:=c+0.05;
  UNTIL c>6.14;
  SetStyle (normal,1,0);
  ShowCursor;
END CursorDemo.

