(**********************************************************************

    :Program.    TPMath.mod
    :Contents.   Turbo Pascal Matheprozeduren
    :Author.     Markus Uhlendahl
    :Address.    Vorm Burgtor 16, D-4408 Dlmen
    :Phone.      02594/81540
    :Copyright.  Public Domain
    :Language.   Modula-2
    :Translator. M2Amiga AMSoft V3.3d

**********************************************************************)
IMPLEMENTATION MODULE TPMath;


IMPORT MathLib0;


PROCEDURE Abs (r : REAL) : REAL;

  BEGIN
    RETURN (ABS(r));
  END Abs;


PROCEDURE ArcTan (r : REAL) : REAL;

  BEGIN
    RETURN (MathLib0.arctan(r));
  END ArcTan;


PROCEDURE Cos (r : REAL) : REAL;

  BEGIN
    RETURN (MathLib0.cos(r));
  END Cos;


PROCEDURE Exp (r : REAL) : REAL;

  BEGIN
    RETURN (MathLib0.exp(r));
  END Exp;


PROCEDURE Frac (r : REAL) : REAL;

  BEGIN
    RETURN (r-REAL(LONGINT(r)));
  END Frac;


PROCEDURE Ln (r : REAL) : REAL;

  BEGIN
    RETURN (MathLib0.ln(r));
  END Ln;


PROCEDURE Round (r : REAL) : REAL;

  BEGIN
    r:=r+0.5;
    RETURN (REAL(LONGINT(r)));
  END Round;


PROCEDURE Sin (r : REAL) : REAL;

  BEGIN
    RETURN (MathLib0.sin(r));
  END Sin;


PROCEDURE Sqr (r : REAL) : REAL;

  BEGIN
    RETURN (r * r);
  END Sqr;


PROCEDURE Sqrt (r : REAL) : REAL;

  BEGIN
    RETURN (MathLib0.sqrt(r));
  END Sqrt;


END TPMath.
