(**********************************************************************

    :Program.    TPScreen.mod
    :Contents.   Turbo Pascal Bildschirmprozeduren
    :Author.     Markus Uhlendahl
    :Address.    Vorm Burgtor 16, D-4408 Dlmen
    :Phone.      02594/81540
    :Copyright.  Public Domain
    :Language.   Modula-2
    :Translator. M2Amiga AMSoft V3.3d

**********************************************************************)
IMPLEMENTATION MODULE TPScreen;


FROM SYSTEM IMPORT ADR;

FROM Dos    IMPORT Write,Output;


VAR message : ARRAY[0..10] OF CHAR;
    fehler  : LONGINT;


PROCEDURE ClrEoL;

  BEGIN
    message[1]:=CHAR(75);
    fehler:=Write (Output(),ADR(message),2);
  END ClrEoL;


PROCEDURE ClrScr;

  BEGIN
    message[1]:=CHAR(12);
    fehler:=Write (Output(),ADR(message)+1,1);
  END ClrScr;


PROCEDURE DelLine;

  BEGIN
    message[1]:=CHAR(04DH);
    fehler:=Write (Output(),ADR(message),2);
  END DelLine;


PROCEDURE Gotoxy (x,y : INTEGER);

  VAR index : INTEGER;

  BEGIN
    index:=1;
    IF y>10 THEN
      message[index]:=CHAR((y DIV 10)+48);
      message[index+1]:=CHAR((y MOD 10)+48);
      INC (index,2);
    ELSE
      message[index]:=CHAR((y MOD 10)+48);
      INC (index);
    END;
    message[index]:=CHAR(03BH);
    INC (index);
    IF x>10 THEN
      message[index]:=CHAR((x DIV 10)+48);
      message[index+1]:=CHAR((x MOD 10)+48);
      INC (index,2);
    ELSE
      message[index]:=CHAR((x MOD 10)+48);
      INC (index);
    END;
    message[index]:=CHAR(048H);
    fehler:=Write (Output(),ADR(message),index+1);
  END Gotoxy;


PROCEDURE InsLine;

  BEGIN
    message[1]:=CHAR(04CH);
    fehler:=Write (Output(),ADR(message),2);
  END InsLine;


BEGIN
  message[0]:=CHAR(09BH);
END TPScreen.
