IMPLEMENTATION MODULE FachLehrer;

FROM FaecherNamen IMPORT FaecherTypen, FaecherNamen;
FROM AbiturScreen IMPORT AddAbiTxtLin, ShowAbiTxt, roT;
FROM Str IMPORT Copy, Concat;
FROM Dos IMPORT FileHandlePtr, oldFile, Open, Close;
FROM SYSTEM IMPORT ADR;
FROM LineReader IMPORT ReadALine;


TYPE Zeile = ARRAY[0..50] OF CHAR;

VAR FLTxt : ARRAY [Turnen..Informatik] OF RECORD
                                             Zeilen: INTEGER;
                                             Txt: ARRAY[0..30] OF Zeile
                                          END;


PROCEDURE ShowLehrerText(F: FaecherTypen);
VAR i: INTEGER;
BEGIN
   IF FLTxt[F].Zeilen > 0 THEN
      FOR i := 0 TO FLTxt[F].Zeilen -1 DO
         AddAbiTxtLin(FLTxt[F].Txt[i])
      END;
      ShowAbiTxt(roT)
   END
END ShowLehrerText;


PROCEDURE InitFLTxt;
VAR Zeile: INTEGER;
    Fach: FaecherTypen;
    Str: ARRAY[0..50] OF CHAR;
    FHPtr: FileHandlePtr;
    EOFile: BOOLEAN;
BEGIN
   FOR Fach := Turnen TO Informatik DO
      FLTxt[Fach].Zeilen := 0;
      Zeile := 0;
      Copy(Str, "Text/");
      Concat(Str, FaecherNamen[Fach].VollName);
      FHPtr := Open(ADR(Str), oldFile);
      IF FHPtr # NIL THEN
         REPEAT
            ReadALine(FHPtr, Str, EOFile);
            IF NOT EOFile THEN
               Copy(FLTxt[Fach].Txt[Zeile], Str);
               INC(Zeile);
               INC(FLTxt[Fach].Zeilen)
            END
         UNTIL EOFile;
         Close(FHPtr)
      END
   END
END InitFLTxt;




BEGIN
   InitFLTxt;
END FachLehrer.
