(*----------------------------------------------------------------------
  :Program.    FileNames1.mod
  :Contents.   Funktionierendes GetExtension (s. FileNames)
  :Author.     Hubert Bildstein
  :Copyright.  Public Domain
  :Language.   Modula-2
  :Translator. M2Amiga V3.3d
  :History.    V1.0   5.12.1990
  :Remark.     GetExtension aus FileNames liefert bei mir keine
  :Remark.     sinnvollen Resultate !?
----------------------------------------------------------------------*)

IMPLEMENTATION MODULE FileNames1;

FROM Str   IMPORT LastPos, noOccur, first, Length;
FROM ASCII IMPORT nul;

PROCEDURE GetExtension (VAR fname, extension : ARRAY OF CHAR;
                        VAR len : INTEGER);
(* Aufspalten eines Filenamens in Namen und Erweiterung *)

VAR Pos, i : INTEGER;
    LenExt : INTEGER;

BEGIN

 Pos := LastPos (fname,HIGH(fname),".");

 IF (Pos # noOccur) THEN
    LenExt := INTEGER(Length(fname)) - Pos;
    FOR i:=first TO LenExt DO
        extension[i] := fname[i+Pos];
    END;
    extension[LenExt+1] := nul;

    fname[Pos] := nul;
 ELSE
    extension := nul;
 END; (*IF*)
 len := Length(fname);

END GetExtension;

END FileNames1.
