(*----------------------------------------------------------------------
  :Program.    Message.mod
  :Contents.   IDCMP-Abfrage eines Fensters
  :Author.     Hubert Bildstein
  :Copyright.  Public Domain
  :Language.   Modula-2
  :Translator. M2Amiga V3.3d
  :History.    V1.0   5.12.1990
----------------------------------------------------------------------*)

IMPLEMENTATION MODULE Message;

FROM SYSTEM    IMPORT ADDRESS;
FROM Intuition IMPORT IDCMPFlagSet, IntuiMessage, IntuiMessagePtr, WindowPtr,
                      Window;
FROM Exec      IMPORT WaitPort, GetMsg, ReplyMsg;


PROCEDURE WaitForMsg (    wptr  : ADDRESS;
                      VAR class : IDCMPFlagSet;
                      VAR code  : CARDINAL;
                      VAR addr  : ADDRESS);
(* Warten auf Meldung vom Fenster *)

VAR IMes : IntuiMessagePtr;
    WPtr : WindowPtr;

BEGIN

 WPtr := wptr;

 WaitPort (WPtr^.userPort);
 IMes := GetMsg (WPtr^.userPort);

 class := IMes^.class;
 code := IMes^.code;
 addr := IMes^.iAddress;

 ReplyMsg (IMes);

END WaitForMsg;

END Message.
