(*----------------------------------------------------------------------
  :Program.    Test2.mod
  :Contents.   Testprogramm fr GadgetEd
  :Contents.   Verwendet Standard-Window
  :Author.     Hubert Bildstein
  :Copyright.  Public Domain
  :Language.   Modula-2
  :Translator. M2Amiga V3.3d
  :History.    V1.0   5.12.1990
----------------------------------------------------------------------*)

MODULE Test2;

FROM SYSTEM    IMPORT ADR;
FROM Req2      IMPORT InitReq2,CloseReq2,GetReq2GPtr;
FROM Gadgets   IMPORT WaitForGadget, DefineWindow;
FROM Intuition IMPORT WindowPtr, IDCMPFlagSet, IDCMPFlags, GadgetPtr,
                      ActivateGadget;

VAR w : WindowPtr;
    c : IDCMPFlagSet;
    id : INTEGER;
    gp : GadgetPtr;
    ok : BOOLEAN;

BEGIN

 w := NIL;
 InitReq2 (w,NIL,ADR("Req2"));    (* Aufbau von Fenster und Gadgets *)
 DefineWindow (w);                 (* Window festelegen *)

 REPEAT
   WaitForGadget (c,id,gp);
   IF (gadgetUp IN c) THEN
     (* jeweils nchstes String-Gadget aktivieren: *)
     CASE id OF
     |  3..6 : ok := ActivateGadget (GetReq2GPtr(id+1),w,NIL);
     |  7    : ok := ActivateGadget (GetReq2GPtr(3),w,NIL);
     ELSE
     END; (*CASE*)
   END; (*IF*)
 UNTIL (id <= 2);     (* eines der Boolean-G. oder Close-Gadget gewhlt *)

 CloseReq2; (* Ende *)

END Test2.
