(*-------------------------------------------------------------------------
   :Program.      WildStar
   :Contents.     Allows/disables "*" to be replacement for "#?"
   :Author.       Kai Bolay [kai]
   :Address.      Hoffmannstrae 168,
   :Address.      D7250 Leonberg 1
   :History.      v1.0 [kai] 28-May-91
   :Copyright.    PD
   :Language.     Oberon
   :Translator.   AMIGA OBERON v2.02, A+L AG
   :Remark.       requires AmigaOS 2.0 or greater.
-------------------------------------------------------------------------*)
MODULE WildStar;

IMPORT
  d: Dos;

BEGIN
  IF d.dos.lib.version>=36 THEN
    d.dos.root.flags := d.dos.root.flags / LONGSET{d.wildStar};
    IF d.wildStar IN d.dos.root.flags THEN
      d.PrintF("WildStar set\n");
    ELSE
      d.PrintF("WildStar cleared\n")
    END;
  END;
END WildStar.
