(***************************************************************************

    :Program.    FileReqTest.mod
    :Contents.   Test des Interfaces zum FileRequester der "req.library"
    :Author.     Jrgen Zimmermann [JnZ]
    :Address.    Ringstrae 6, W-6719 Altleiningen, Germany
    :Phone.      06356/1456
    :Copyright.  Public Domain (but donation is always welcome!)
    :Language.   Modula-2
    :Translator. M2Amiga AMSoft V4.096d
    :Imports.    Die "req.library" mu im Verzeichnis "LIBS:" stehen!
    :History.    V1.0  [JnZ] 25.May.1991 first internal version which works
*****************************************************************************)


MODULE FileReqTest;

FROM InOut         IMPORT WriteString;
FROM FileRequester IMPORT FileRequest;

VAR name: ARRAY[0..255] OF CHAR;

BEGIN
   WriteString("Starte nun den FileRequester...bitte testen Sie die Funktionen!\n\n");
   IF FileRequest(NIL,TRUE,"FileRequest-Test",name)
      THEN
         WriteString("Sie haben folgendes gewhlt: ");
         WriteString(name);
      ELSE
         WriteString("Sie haben den Filerequester verlassen, ohne ein File zu whlen!");
   END; (* IF *)
END FileReqTest.
