(* ReqSupport.mod   ported to M2Amiga 4.0 1991 by Jrgen Zimmermann  *)
(*                  Hilfsroutinen der Oberon-Implementation          *)
(* Req.mod          ported to Oberon 1990 by Achim Siebert           *)
(* reqlibrary.h    1988/1989 reserved by Colin Fox and Bruce Dawson *)

IMPLEMENTATION MODULE ReqSupport;

IMPORT rd: ReqD,
       rl: ReqL,
       SYSTEM;



PROCEDURE SimpleRequest(string       : ARRAY OF CHAR;
                        parameterlist: SYSTEM.ADDRESS);

   VAR textR:rd.TRStructure;

   BEGIN
      textR.text          := SYSTEM.ADR(string);
      textR.controls      := parameterlist;
      textR.window        := NIL;
      textR.middleText    := NIL;
      textR.positiveText  := NIL;
      textR.negativeText  := SYSTEM.ADR("Resume");
      textR.title         := SYSTEM.ADR("okay?");
      textR.keyMask       := {0..15};
      textR.textcolor     := 1;
      textR.detailcolor   := 0;
      textR.blockcolor    := 0;
      textR.versionnumber := 0;
      textR.rfu1          := 0;
      textR.rfu2          := 0;
      IF (rl.TextRequest(SYSTEM.ADR(textR)) = 0)
         THEN
      END; (* IF *)
   END SimpleRequest;


PROCEDURE TwoGadRequest(string       : ARRAY OF CHAR;
                        parameterlist: SYSTEM.ADDRESS): INTEGER;

   VAR textR : rd.TRStructure;
       result: INTEGER;

   BEGIN
      textR.text          := SYSTEM.ADR(string);
      textR.controls      := parameterlist;
      textR.window        := NIL;
      textR.middleText    := NIL;
      textR.positiveText  := SYSTEM.ADR("  Ok  ");
      textR.negativeText  := SYSTEM.ADR("Cancel");
      textR.title         := SYSTEM.ADR("okay?");
      textR.keyMask       := {0..15};
      textR.textcolor     := 1;
      textR.detailcolor   := 0;
      textR.blockcolor    := 0;
      textR.versionnumber := 0;
      textR.rfu1          := 0;
      textR.rfu2          := 0;
      result:=rl.TextRequest(SYSTEM.ADR(textR));
      RETURN(result);
   END TwoGadRequest;

END ReqSupport.
