MODULE EasyRexxDemo;

IMPORT er := EasyRexx, io, e := Exec;

VAR
  signal: LONGSET;
  quit: BOOLEAN;

PROCEDURE * Exit(com: er.RexxCommandPtr; args: er.String; VAR result: er.String);
BEGIN
  io.WriteString("\nExit wurde aufgerufen!\n");
  io.WriteString("Argument ist: "); io.WriteString(args); io.WriteLn;
  quit := TRUE;
END Exit;


PROCEDURE * Test(com: er.RexxCommandPtr; args: er.String; VAR result: er.String);
BEGIN
  io.WriteString("\nTest wurde aufgerufen!\n");
  io.WriteString("Argument ist: "); io.WriteString(args); io.WriteLn;
  result := "Oberon REXX Demo";
END Test;


BEGIN

  IF NOT(er.EasyAddCommand("exit",Exit) AND er.EasyAddCommand("test",Test)) THEN
    io.WriteString("Kein Speicher!\n");
  END;

  signal := er.OpenRexx("EasyRexxDemo");

  IF signal#LONGSET{} THEN
  
    quit := FALSE;
  
    WHILE NOT quit DO
  
      REPEAT UNTIL LONGSET{}#e.Wait(signal);
      er.HandleRexx;
  
    END;
  
    er.CloseRexx;

  END;

END EasyRexxDemo.

