(**********************************************************************

    :Program.    VInfo.mod
    :Contents.   Procedure, die die Versionsnummer und die Addresse des
    :Contents.   Autors im Programm VTrainer anzeigt
    :Author.     Dieter WILHELM
    :Address.    Albert-Schweitzer-Str.44, 8000 Mnchen 83
    :Phone.      089/671693
    :Copyright.  PD
    :Language.   Modula-2
    :Translator. M2Amiga A+L V4.0d
    :History.    V1.0 Dieter WILHELM 13.Jan.1991
    :History.    V1.1 Dieter WILHELM 29.Sept.1991

**********************************************************************)

IMPLEMENTATION MODULE VInfo ;


  FROM GraphicsD  IMPORT jam1, jam2, RastPortPtr;
  FROM GraphicsL  IMPORT Move, RectFill, SetAPen, SetDrMd, Text;
  FROM IntuitionD IMPORT WindowPtr;
  FROM String     IMPORT Length;
  FROM SYSTEM     IMPORT ADR;


  PROCEDURE RandText(rp: RastPortPtr; x, y: INTEGER; string:
                     ARRAY OF CHAR; VFarbe, HFarbe: CARDINAL);
    BEGIN
      SetAPen(rp, VFarbe) ;
      Move(rp,x+1,y);
      Text(rp,ADR(string),Length(string));
      Move(rp,x-1,y);
      Text(rp,ADR(string),Length(string));
      Move(rp,x,y+1);
      Text(rp,ADR(string),Length(string));
      Move(rp,x,y-1);
      Text(rp,ADR(string),Length(string));
      Move(rp,x-1,y-1);
      Text(rp,ADR(string),Length(string));
      Move(rp,x+1,y+1);
      Text(rp,ADR(string),Length(string));
      Move(rp,x+1,y-1);
      Text(rp,ADR(string),Length(string));
      Move(rp,x-1,y+1);
      Text(rp,ADR(string),Length(string));
      SetAPen(rp,HFarbe);
      Move(rp,x,y);
      Text(rp,ADR(string),Length(string));
  END RandText;


  PROCEDURE Info(W: WindowPtr) ;
    VAR  rp : RastPortPtr ;
    BEGIN
      rp := W^.rPort ;
      SetAPen(rp, 0);
      RectFill(rp, 0, 15, W^.width, W^.height);
      SetDrMd(rp, jam1) ;
      RandText(rp, 235, 55, "VokabelTrainer  V1.1", 3, 0) ;
      RandText(rp, 180, 85, "Dieses Programm ist Public Domain", 3, 0);
      RandText(rp, 170, 100, "Fehler, Anregungen, u.s.w. bitte an", 3,0);
      RandText(rp, 250, 120, "Dieter WILHELM", 1, 0) ;
      RandText(rp, 225, 135, "Alb.-Schweitzer-Str.44", 1, 0) ;
      RandText(rp, 250, 152, "8000 Mnchen 83", 1, 0) ;
      RandText(rp, 200, 172, "entwickelt mit M2Amiga V4.0d", 3, 0) ;
      SetDrMd(rp, jam2) ;
  END Info ;


END VInfo.
