(*---------------------------------------------------------------------------
 :Program.     IntuiPointerDemo.mod
 :Author.      Christian Stiens
 :Address.     Snail-Mail:           E-Mail:
 :Address.     Heustiege 2           UUCP: Christian_Stiens@ouzonix.bo.open.de
 :Address.     W-4710 Ldinghausen   FIDO: 2:241/5807
 :Copyright.   public domain
 :Language.    Oberon-2
 :Translator.  Amiga Oberon V2.42d
 :Imports.     IntuiPointer
---------------------------------------------------------------------------*)

MODULE IntuiPointerDemo;

  IMPORT
    d:=Dos, ip:=IntuiPointer, di:=Display;

  VAR
    win : di.WindowPtr;
    i   : INTEGER;

BEGIN
  NEW(win);
  IF di.OpenWindow(win,"IntuiPointerDemo",0,50,640,100,NIL) THEN
    d.Delay(30);
    FOR i := 0 TO 16 DO
      d.Delay(20);
      ip.AnimBusy(win.window,i);
    END;
    ip.Normal(win.window);
    d.Delay(50);
    di.Close(win);
  END;
END IntuiPointerDemo.


