(************************************************************************************

:Program.       Images

:Contents.      Die Bitplanes der Images des Spiels Mine


:Author.        Thomas Ansorge

:Address.       Dinkelackerring 55, W-6730 Neustadt, Deutschland


:Language.      Modula-2

:Translator.    M2Amiga V4.0 (deutsch)


:Version.       1.0 vom 08. August 1992

:History.       1.0 vom 08.08.1992


************************************************************************************)


(*$ ChipCode := TRUE *)

IMPLEMENTATION MODULE Images;

FROM SYSTEM IMPORT ASSEMBLE;

(* ------------------------------------------------------------------------------- *)

(*$ EntryExitCode := FALSE *)

PROCEDURE BombePlane;

   BEGIN

   ASSEMBLE (
      DC.W $ffff
      DC.W $fc00
      DC.W $c000
      DC.W $0000
      DC.W $c000
      DC.W $0000
      DC.W $c07c
      DC.W $0000
      DC.W $c07c
      DC.W $0000
      DC.W $c7ff
      DC.W $c000
      DC.W $cfff
      DC.W $e000
      DC.W $cfff
      DC.W $e000
      DC.W $c7ff
      DC.W $c000
      DC.W $c000
      DC.W $0000
      DC.W $8000
      DC.W $0000
      DC.W $0000
      DC.W $0000

      DC.W $0000
      DC.W $0200
      DC.W $0000
      DC.W $0600
      DC.W $0000
      DC.W $0600
      DC.W $0000
      DC.W $0600
      DC.W $0000
      DC.W $0600
      DC.W $0000
      DC.W $0600
      DC.W $0000
      DC.W $0600
      DC.W $0000
      DC.W $0600
      DC.W $0000
      DC.W $0600
      DC.W $0000
      DC.W $0600
      DC.W $7fff
      DC.W $fe00
      DC.W $0000
      DC.W $0000
   END);
END BombePlane;

(* ------------------------------------------------------------------------------- *)

(*$ EntryExitCode := FALSE *)

PROCEDURE ClickedPlane;

   BEGIN

   ASSEMBLE (
      DC.W $ffff
      DC.W $fc00
      DC.W $c000
      DC.W $0000
      DC.W $c000
      DC.W $0000
      DC.W $c000
      DC.W $0000
      DC.W $c000
      DC.W $0000
      DC.W $c000
      DC.W $0000
      DC.W $c000
      DC.W $0000
      DC.W $c000
      DC.W $0000
      DC.W $c000
      DC.W $0000
      DC.W $c000
      DC.W $0000
      DC.W $8000
      DC.W $0000
      DC.W $0000
      DC.W $0000

      DC.W $0000
      DC.W $0200
      DC.W $0000
      DC.W $0600
      DC.W $0000
      DC.W $0600
      DC.W $0000
      DC.W $0600
      DC.W $0000
      DC.W $0600
      DC.W $0000
      DC.W $0600
      DC.W $0000
      DC.W $0600
      DC.W $0000
      DC.W $0600
      DC.W $0000
      DC.W $0600
      DC.W $0000
      DC.W $0600
      DC.W $7fff
      DC.W $fe00
      DC.W $0000
      DC.W $0000
   END);
END ClickedPlane;

(* ------------------------------------------------------------------------------- *)

(*$ EntryExitCode := FALSE *)

PROCEDURE ClickMePlane;

   BEGIN

   ASSEMBLE (
      DC.W $0000
      DC.W $0200
      DC.W $0000
      DC.W $0600
      DC.W $0000
      DC.W $0600
      DC.W $0000
      DC.W $0600
      DC.W $0000
      DC.W $0600
      DC.W $0000
      DC.W $0600
      DC.W $0000
      DC.W $0600
      DC.W $0000
      DC.W $0600
      DC.W $0000
      DC.W $0600
      DC.W $0000
      DC.W $0600
      DC.W $7fff
      DC.W $fe00
      DC.W $0000
      DC.W $0000

      DC.W $ffff
      DC.W $fc00
      DC.W $c000
      DC.W $0000
      DC.W $c000
      DC.W $0000
      DC.W $c000
      DC.W $0000
      DC.W $c000
      DC.W $0000
      DC.W $c000
      DC.W $0000
      DC.W $c000
      DC.W $0000
      DC.W $c000
      DC.W $0000
      DC.W $c000
      DC.W $0000
      DC.W $c000
      DC.W $0000
      DC.W $8000
      DC.W $0000
      DC.W $0000
      DC.W $0000
   END);
END ClickMePlane;

(* ------------------------------------------------------------------------------- *)

(*$ EntryExitCode := FALSE *)

PROCEDURE ExplosionPlane;

   BEGIN

   ASSEMBLE (
      DC.W $ffff
      DC.W $fc00
      DC.W $c810
      DC.W $1000
      DC.W $d041
      DC.W $0000
      DC.W $c000
      DC.W $0000
      DC.W $d000
      DC.W $0800
      DC.W $c000
      DC.W $0000
      DC.W $c030
      DC.W $0000
      DC.W $ca82
      DC.W $6000
      DC.W $c7ff
      DC.W $c000
      DC.W $c000
      DC.W $0000
      DC.W $8000
      DC.W $0000
      DC.W $0000
      DC.W $0000

      DC.W $0000
      DC.W $0200
      DC.W $0000
      DC.W $0600
      DC.W $0410
      DC.W $2600
      DC.W $0b5a
      DC.W $4600
      DC.W $04fc
      DC.W $9600
      DC.W $0f73
      DC.W $e600
      DC.W $05ce
      DC.W $8600
      DC.W $057d
      DC.W $8600
      DC.W $0000
      DC.W $0600
      DC.W $0000
      DC.W $0600
      DC.W $7fff
      DC.W $fe00
      DC.W $0000
      DC.W $0000
   END);
END ExplosionPlane;

(* ------------------------------------------------------------------------------- *)

(*$ EntryExitCode := FALSE *)

PROCEDURE FahnePlane;

   BEGIN

   ASSEMBLE (
      DC.W $0000
      DC.W $0200
      DC.W $0000
      DC.W $0600
      DC.W $00c0
      DC.W $0600
      DC.W $00c0
      DC.W $0600
      DC.W $00c0
      DC.W $0600
      DC.W $00c0
      DC.W $0600
      DC.W $00c0
      DC.W $0600
      DC.W $00c0
      DC.W $0600
      DC.W $03f0
      DC.W $0600
      DC.W $0000
      DC.W $0600
      DC.W $7fff
      DC.W $fe00
      DC.W $0000
      DC.W $0000

      DC.W $ffff
      DC.W $fc00
      DC.W $c000
      DC.W $0000
      DC.W $c000
      DC.W $0000
      DC.W $c03f
      DC.W $8000
      DC.W $c03e
      DC.W $0000
      DC.W $c03f
      DC.W $8000
      DC.W $c000
      DC.W $0000
      DC.W $c000
      DC.W $0000
      DC.W $c000
      DC.W $0000
      DC.W $c000
      DC.W $0000
      DC.W $8000
      DC.W $0000
      DC.W $0000
      DC.W $0000
   END);
END FahnePlane;

(* ------------------------------------------------------------------------------- *)

(*$ EntryExitCode := FALSE *)

PROCEDURE FahneORPlane;
   
   BEGIN
   
   ASSEMBLE (
      DC.W $3000
      DC.W $3000
      DC.W $3000
      DC.W $3000
      DC.W $3000
      DC.W $3000
      DC.W $fc00
      DC.W $0000

      DC.W $0000
      DC.W $0fe0
      DC.W $0f80
      DC.W $0fe0
      DC.W $0000
      DC.W $0000
      DC.W $0000
      DC.W $0000
   END);
END FahneORPlane;

(* ------------------------------------------------------------------------------- *)

END Images (* IMPLEMENTATION MODULE *).
