(*************************************************************************

:Program.    SpecialStrings.mod
:Contents.   some spacial string routines
:Author.     Hartmut Goebel [hG]
:Address.    Aufseplatz 5, D-8500 Nrnberg 40
:Address.    UseNet: hartmut@oberon.nbg.sub.org
:Address.    Z-Netz: hartmut@asn.zer   Fido: 2:246/81.1
:Copyright.  Copyright  1990 by Hartmut Goebel
:Language.   Oberon-2
:Translator. Amiga Oberon V2.45
:Imports.    Printf (Volker Rudolph)
:History.    V1.0, 12 Nov 1992 [hG]
:Date.       12 Nov 1992 22:00:08

(* $StackChk- $NilChk- $RangeChk- $CaseChk- $OvflChk- $ReturnChk- $ClearVars- *)

*************************************************************************)

MODULE SpecialStrings;

IMPORT
  pf := Printf,
  y  := SYSTEM;

PROCEDURE MakeUnique * (VAR unique: ARRAY OF CHAR;
                              base: ARRAY OF CHAR; (* $CopyArrays- *)
                        VAR    num: INTEGER): BOOLEAN;
BEGIN
  IF num = MAX(INTEGER) THEN RETURN FALSE; END;
  INC(num);
  pf.SPrintf2(unique,"%s.%ld",y.ADR(base),num);
  RETURN TRUE;
END MakeUnique;

END SpecialStrings.
