MODULE Ueberweg;

IMPORT
  FAmpel, VAmpel, io;

TYPE
  Ueberweg* = POINTER TO UeberwegDesc;
  UeberwegDesc* = RECORD
    fussAmpel* : FAmpel.FAmpel;
    autoAmpel* : VAmpel.VAmpel;
  END;

PROCEDURE (u: Ueberweg) Anzeigen*();
BEGIN
  io.WriteString("Fuss: "); u.fussAmpel.Anzeigen();
  io.WriteString("--- ");
  io.WriteString("Auto: "); u.autoAmpel.Anzeigen();
  io.WriteString("---"); io.Write(CHR(10));
END Anzeigen;

PROCEDURE Init*(u: Ueberweg; autoGruen: BOOLEAN);
BEGIN

  NEW(u.fussAmpel); FAmpel.Init(u.fussAmpel);
  NEW(u.autoAmpel); VAmpel.Init(u.autoAmpel);

  IF autoGruen THEN
    WHILE ~u.fussAmpel.istRot() DO
      u.fussAmpel.Schalten();
    END;
    WHILE ~u.autoAmpel.istGruen() DO
      u.autoAmpel.Schalten();
    END;
  ELSE
    WHILE ~u.fussAmpel.istGruen() DO
      u.fussAmpel.Schalten();
    END;
    WHILE ~u.autoAmpel.istRot() DO
      u.autoAmpel.Schalten();
    END;
  END;

END Init;

END Ueberweg.
