MODULE VAmpel;

IMPORT
  Ampel, io;

TYPE
  VAmpel* = POINTER TO VAmpelDesc;
  VAmpelDesc* = RECORD (Ampel.AmpelDesc)
    gelb*: BOOLEAN;
  END;

PROCEDURE (a: VAmpel) Schalten*();
BEGIN

  IF a.gruen THEN (* gruen -> gelb *)
    a.gruen := FALSE; a.gelb := TRUE;
  ELSIF a.gelb & ~a.rot THEN (* gelb -> rot *)
    a.gelb := FALSE; a.rot := TRUE;
  ELSIF a.rot & ~a.gelb THEN (* rot -> rot,gelb *)
    a.gelb := TRUE;
  ELSIF a.rot & a.gelb THEN (* rot,gelb -> gruen *)
    a.rot := FALSE; a.gelb := FALSE; a.gruen := TRUE;
  ELSE (* unvorhergesehener Fall *)
    a.rot := TRUE; a.gelb := FALSE; a.gruen := FALSE;
  END;

END Schalten;

PROCEDURE (a: VAmpel) Anzeigen*();
BEGIN
  io.Write(a.Leuchte(a.rot));
  io.Write(a.Leuchte(a.gelb));
  io.Write(a.Leuchte(a.gruen));
END Anzeigen;

PROCEDURE (a: VAmpel) istRot*(): BOOLEAN;
BEGIN
  RETURN a.istRot^() & ~a.gelb;
END istRot;

PROCEDURE (a: VAmpel) istGruen*(): BOOLEAN;
BEGIN
  RETURN a.istGruen^() & ~a.gelb;
END istGruen;

PROCEDURE Init*(a: VAmpel);
BEGIN
  Ampel.Init(a); a.gelb := FALSE;
END Init;

END VAmpel.
