MODULE StreamTest;

IMPORT
  d := Dos,
  T := TextStreams,
  F := FileStreams;

VAR
  t : T.TextStream;
  f : F.FileStream;

  str: ARRAY 256 OF CHAR;
  l : LONGINT;

BEGIN
  t := T.Create(0,11,640,100);
  f := F.Create();

  IF ~t.Open("StreamTest", TRUE) THEN HALT(99) END;

  IF ~f.Open("ram:StreamTest", TRUE) THEN
      t.WriteString("Konnte File nicht oeffnen!\n");
      HALT(99)
  END;

  t.WriteString("\nString eingeben: ");
  t.ReadString(str);
  f.WriteString(str);

  REPEAT t.WriteString("\nLongint eingeben: ") UNTIL t.ReadLongInt(l);
  f.WriteLongInt(l,9);

  IF ~f.Close() THEN
      t.WriteString("\nKonnte File nicht schliessen\n");
      HALT(99)
  END;

  t.WriteString("File wurde geschlossen!\n");

  IF ~f.Open("ram:StreamTest", FALSE) THEN
      t.WriteString("Konnte File nicht oeffnen!\n");
      HALT(99)
  END;

  t.WriteString("\nFolgenden String hast Du eingegeben: ");
  f.ReadString(str);
  t.WriteString(str);

  t.WriteString("\nFolgenden LongInt-Zahl hast Du eingegeben: ");
  IF f.ReadLongInt(l) THEN END;
  t.WriteLongInt(l, 9);

  t.WriteLn;

  IF ~f.Close() THEN
      t.WriteString("\nKonnte File nicht schliessen\n");
      HALT(99)
  END;

  d.Delay(100);

  IF ~t.Close() THEN
      HALT(99)
  END;

END StreamTest.
