(*------------------------------------------

  :Module.      C2OData.mod
  :Author.      Albert Weinert  [awn]
  :Address.     Krhenweg 21 , 50829 Kln
  :EMail.       Usenet_> aweinert@darkness.gun.de
  :EMail.       Z-Netz_> A.WEINERT@DARKNESS.ZER
  :Phone.       0221 / 580 29 84
  :Revision.    R.1
  :Date.        17-May-1993
  :Copyright.   Albert Weinert
  :Language.    Oberon-2
  :Translator.  Amiga Oberon 3.00d
  :Contents.    Enthlt die Strukturen und so allerlei anderes.
  :Imports.     <Importiertes, Name/ShortCut des Autors>
  :Remarks.     <Was Du willst, evtl. Usage>
  :Bugs.        <Bekannte Fehler>
  :Usage.       <Angaben zur Anwendung>
  :History.     .0     [awn] 16-May-1993 : Erstellt
  :History.     .1     [awn] 17-May-1993 : error, para1 und para2 aufgenommen.

--------------------------------------------*)
MODULE  C2OData;

IMPORT  BT:=BasicTypes,
        ll:=LinkedLists;

TYPE
  List *= POINTER TO ListDesc;
  ListDesc *= RECORD(ll.ListDesc);
                language * : ARRAY 256 OF CHAR;
                version  * : LONGINT;
              END;

  Node *= POINTER TO NodeDesc;
  NodeDesc *= RECORD(ll.NodeDesc);
                IDName   * : BT.DynString;
                IDNumber * : LONGINT;
                string   * : BT.DynString;
              END;

VAR SList * : List;
    error * : LONGINT;
    para1 * : LONGINT;
    para2 * : LONGINT;
  PROCEDURE Create():List;
  (*------------------------------------------
    :Input.
    :Output.    List = Liste
    :Semantic.  Erstellt eine Liste
    :Note.
    :Update.    16-May-1993 [awn] - erstellt.
  --------------------------------------------*)
    VAR list: List;
    BEGIN
      NEW(list);
      RETURN list;
    END Create;

  PROCEDURE (list:List) Init*();
  (*------------------------------------------
    :Input.     list = liste
    :Output.
    :Semantic.  Initialisiert eine Liste.
    :Note.
    :Update.    16-May-1993 [awn] - erstellt.
  --------------------------------------------*)
    BEGIN
      list.Init^();
      list.language:="deutsch";
      list.version:=0;
    END Init;
BEGIN
  SList:=Create();
  SList.Init();
END C2OData.
