MODULE Draw;

FROM DrawLines IMPORT DrawLines;
FROM SYSTEM IMPORT ADR,ADDRESS,BYTE;
FROM Intuition IMPORT ScreenPtr,ScreenFlags,ScreenFlagSet,customScreen,
       NewScreen,OpenScreen,CloseScreen;
FROM Graphics IMPORT ViewModeSet,ViewModes,DrawModeSet,DrawModes,SetDrMd,
       Draw,Move,GfxBasePtr;
FROM Exec IMPORT OpenLibrary,CloseLibrary;

VAR
  MyScreen: ScreenPtr;
  MyNewScreen: NewScreen;
  x: INTEGER;
  GraphicsBase: ADDRESS; (* woher kann man GfxBase importieren ??? *)

BEGIN

  GraphicsBase := OpenLibrary(ADR("graphics.library"),0);

  WITH MyNewScreen DO
    leftEdge := 0;    topEdge  := 0;
    width    := 640;  height   := 256;  depth   := 1;
    detailPen:= 0;    blockPen := 1;
    viewModes:= ViewModeSet{hires};
    type     := ScreenFlagSet{screenQuiet}+customScreen;
    font     := NIL; defaultTitle := NIL; gadgets := NIL;
    customBitMap := NIL;
  END;
  MyScreen := OpenScreen(MyNewScreen);
  SetDrMd(ADR(MyScreen^.rastPort),DrawModeSet{complement});

  DrawLines(ADR(MyScreen^.rastPort),ADDRESS(GraphicsBase));

  CloseScreen(MyScreen);

  CloseLibrary(GraphicsBase);

END Draw.
