;--------------------------------------------------------------------
;                          DrawLines:                               !
;--------------------------------------------------------------------
;                                                                   !
; bergeben: a6: GraphicsBase                                       !
;            a2: RastPort                                           !
;                                                                   !
;--------------------------------------------------------------------

;----------------  Makros & Konstanten:  ----------------------------

_lvoMove = -240
_lvoDraw = -246

CallSys: macro $\1
  jsr _lvo\1(a6)
  endm

;--------------------  Programm:  -----------------------------------

    moveq   #16,d3          ; Schleife 16 mal durchlaufen
loop2:
    clr     d2              ; d2 enthlt x-Koordinate. x:= 0
loop:
    move.l  a2,a1           ; RastPort an Move bergeben (in a1)
    clr     d0
    clr     d1
    CallSys Move            ; Move (0,0)
    move.l  a2,a1           ; RP
    move    d2,d0           ; x-koordinate
    move    #255,d1         ; y=255
    CallSys Draw            ; Draw (x,255)
    move.l  a2,a1
    move    #639,d0
    move    #0,d1
    CallSys Draw            ; Draw (639,0)
    move.l  a2,a1
    clr     d0
    move    #255,d1
    CallSys Move            ; Move (0,255)
    move.l  a2,a1
    move    d2,d0
    clr     d1
    CallSys Draw            ; Draw (x,0)
    move.l  a2,a1
    move    #639,d0
    move    #255,d1
    CallSys Draw            ; Draw (639,255)
    addq    #2,d2           ; x um 2 erhhen
    cmp     #640,d2         ; bis x rechts am Bildschirm ankommt.
    blo     loop            ; also 320 mal 4 Linien zeichen
    subq    #1,d3           ; Zhler in d3 erniedrigen
    bne     loop2           ; also insgesamt 4x320x16 = 20480

    end                     ; das war's schon.
