IMPLEMENTATION MODULE MODIV;

FROM SYSTEM IMPORT SHIFT, LONGSET, CAST;

CONST
  ZweiHoch31 = 2147483648;

VAR
  ShiftedB: LONGCARD;
  CountShift: CARDINAL;
  Result: LONGSET;

PROCEDURE Mod(a,b:LONGCARD): LONGCARD;

BEGIN
  Result := LONGSET{};
  IF a<=b THEN RETURN a END;
  IF b=0 THEN a := a DIV (a-a) END;
  ShiftedB := b;
  WHILE (ShiftedB<a) AND (ShiftedB<ZweiHoch31) DO
    ShiftedB := SHIFT(ShiftedB,1);
  END;
  IF ShiftedB>a THEN ShiftedB := SHIFT(ShiftedB,-1) END;
  WHILE a>b DO
    WHILE a<ShiftedB DO
      ShiftedB := SHIFT(ShiftedB,-1);
    END;
    DEC(a,ShiftedB);
  END;
  RETURN a;
END Mod;

PROCEDURE Div(a,b:LONGCARD): LONGCARD;

BEGIN
  Result := LONGSET{};
  IF a<=b THEN RETURN 0 END;
  IF b=0 THEN a := a DIV (a-a) END;
  ShiftedB := b;
  CountShift := 0;
  WHILE (ShiftedB<a) AND (ShiftedB<ZweiHoch31) DO
    ShiftedB := SHIFT(ShiftedB,1);
    INC(CountShift);
  END;
  IF ShiftedB>a THEN
    ShiftedB := SHIFT(ShiftedB,-1);
    DEC(CountShift);
  END;
  WHILE a>b DO
    WHILE a<ShiftedB DO
      ShiftedB := SHIFT(ShiftedB,-1);
      DEC(CountShift);
    END;
    DEC(a,ShiftedB);
    INCL(Result,CountShift);
  END;
  RETURN CAST(LONGCARD,Result);
END Div;

END MODIV.
