(*********************************************************************
 
    :Program.  	Memory.mod
    :Author.   	Pit Burkhardt  
    :Address.   Stettinerstrae 25 D-7030 Bblingen
    :shortcut. 	[pit]
    :Version.  	1.0   
    :Date.     	July 1988
    :Copyright. PD
    :Language. 	Modula-II
    :Translator.M2Amiga
    :Imports.	none 
    :UpDate.	none
    :Contents.	Memory allocating PROCEDUREs.
    :Remark.	Studienarbeit 
    		Im Kernfach TECHNISCHES DESIGN
                an der Universitt Stuttgart
                
                This Module was installed to allow changes in 
                Memory-Allocation quickly.	 
    
**********************************************************************)

IMPLEMENTATION MODULE Memory;

FROM Heap IMPORT	AllocMem;

FROM SYSTEM IMPORT	ADDRESS;

 
PROCEDURE AllocMemory(VAR adr: ADDRESS; size:LONGINT; chipMem:BOOLEAN);
 BEGIN
  AllocMem(adr,size,chipMem);
 END AllocMemory;

END Memory.
