(*********************************************************************
 *                                                                   *
 *  :Program.    PrinterSupportTest.mod                              *
 *  :Author.     Michael Frie                                       *
 *  :Address.    Kernerstr. 22a                                      *
 *  :Address.    7000 Stuttgart 1                                    *
 *  :shortcut.   [mif]                                               *
 *  :Version.    2.0                                                 *
 *  :Date.       18.09.88                                            *
 *  :Copyright.  PD                                                  *
 *  :Language.   Modula-II                                           *
 *  :Translator. M2Amiga                                             *
 *  :Contents.   Test fr PrinterSupport V2.0                        *
 *  :Imports.    PrinterSupport V2.0                                 *
 *                                                                   *
 *********************************************************************)

MODULE PrinterSupportTest;

FROM Terminal IMPORT WriteLn, WriteString;
FROM ASCII IMPORT eol;
FROM Printer IMPORT sgr4, sgr24;
FROM PrinterSupport IMPORT OpenPrinter, PrintString, PrintRaw,
     PrintCommand, PrintChar;

BEGIN
  WriteString ("DruckerTest"); WriteLn;
  OpenPrinter;
  WriteString ("Drucker bereitgestellt"); WriteLn;
  PrintString ("Alle meine Entchen sind schon da.(String)");
  PrintChar (eol);
  WriteString ("Alle meine Entchen sind schon da.");
  WriteLn;
  PrintCommand (sgr4, 0,0,0,0);
  WriteString ("Unterstreichen ein "); WriteLn;
  PrintRaw ("Alle meine Entchen sind schon da.(Raw)");
  PrintChar (eol);
  PrintString ("Alle meine Entchen sind schon da.(String)");
  PrintCommand (sgr24, 0,0,0,0);
  WriteString ("Unterstreichen aus "); WriteLn;
  PrintChar (eol);
  PrintRaw ("Alle meine Entchen sind schon da.(Raw)");
  PrintChar (eol);
  WriteString("ClosePrinter wird automatisch ausgefhrt.");
  WriteLn
END PrinterSupportTest.
