(*
  :Program.       PrintfTest
  :Author.        Volker Rudolph
  :Address.       Medicusstr. 31 / 6750 Kaiserslautern
  :Phone.         0631/17160
  :ShortCut.      [vor]
  :Version.       1.0
  :Date.          25.6.1989
  :Copyright.     PD
  :Language.      Modula-2
  :Translator.    M2Amiga 3.2d
  :Imports.       Printf [vor]
  :Contents.      Testprogramm zum Modul NoGuru.
  :Usage.         Starten
*)
MODULE PrintfTest;

FROM Printf IMPORT Printf0,Printf2,L,writeProc;
FROM Str IMPORT Length;
FROM Terminal IMPORT WriteString;
FROM SYSTEM IMPORT ADR;

VAR
  string:ARRAY [1..80] OF CHAR;

BEGIN
  (* Damit das Programm auch von der Workbench aus luft *)
  writeProc := WriteString;

  Printf0("\[0;33;40m RED \[0;31;40m WHITE\n");

  string := "Teststring";
  Printf2("Der String %6.8s ist %ld Zeichen lang.\n",
          ADR(string),Length(string));

  string := "Test";
  Printf2("Der String %6.8s ist %ld Zeichen lang.\n",
          ADR(string),Length(string));

  Printf2("Dezimal %3ld = Hex $%04lx.\n",123H,123H);

END PrintfTest.
