(*

    Programm	:	Kurve
    Autor	:	Jrg Wesemann
    Adresse	:	Auf der Heide 10 , 2807 Achim - Baden
    Telefon	:	04202 / 70658
    Version	:	3.20 (deutsch)
    Datum	:	28.09.1989
    Copyright	:	Public Domain, bei eigenen nderungen bitte Nachricht !
    Compiler	:	M2-Amiga Modula-2, Version 3.2d, 01.11.88
    Importiert	:	-
    Fehler	:	nicht bekannt 
    Quelle      :       DIFFER: Hans Josef Classen, Original in Pascal
*)

IMPLEMENTATION MODULE ableitung;
  
  FROM Strings 			IMPORT	Length,Copy,Compare;
  FROM Str 			IMPORT 	Concat,CapString;
  FROM InOut			IMPORT 	WriteLn,Write,WriteString,ReadString;
  FROM SYSTEM			IMPORT 	ADR;
  FROM LongRealConversions	IMPORT 	StrToReal,RealToStr;
  FROM Arts			IMPORT  BreakPoint;

  IMPORT Str;
  
  CONST anzahl=21;
        null='0';
        eins='1';
        leer="";
        klauf='(';
        klazu=')';
        MAXC = 80;

  TYPE string = ARRAY[0..MAXC] OF CHAR;
       wuerfel= [1..6];
       fktart=RECORD
                funk:string;
                abli,abre:string;
              END;

  VAR feld			:ARRAY[1..anzahl] OF fktart;
      s				:CHAR;
      i				:INTEGER;
      lenx			:ARRAY[1..anzahl] OF INTEGER;
      h				:string;
      ok			:BOOLEAN;




  PROCEDURE loesch(VAR f:ARRAY OF CHAR);
  VAR 
    i : CARDINAL;
  BEGIN
    FOR i:= 0 TO HIGH(f) DO
      f[i]:= CHR(0);
    END;
  END loesch;

  PROCEDURE stringreal(s:ARRAY OF CHAR):LONGREAL;
  VAR
    erg : LONGREAL;
    err : BOOLEAN;
  BEGIN
    StrToReal(s,erg,err);
    IF err THEN 
      erg := 0.0;
    END;
    RETURN erg;
  END stringreal;
  
  PROCEDURE realstring(VAR s:ARRAY OF CHAR;r:LONGREAL);
  VAR
    err : BOOLEAN;
  BEGIN
    RealToStr(r,s,4,0,FALSE,err);
  END realstring;
  
  PROCEDURE init;
    BEGIN
    feld[1].funk :='SIN(';
    feld[1].abli :='COS';
    feld[1].abre :='';
    feld[2].funk :='COS(';
    feld[2].abli :='(-1)*SIN';
    feld[2].abre :='';
    feld[3].funk :='TAN(';
    feld[3].abli :='(1+TAN';
    feld[3].abre :='^2)';
    feld[4].funk :='COTAN(';
    feld[4].abli :='(-1)*(1+COTAN';
    feld[4].abre :='^2)';
    feld[5].funk :='SINH(';
    feld[5].abli :='COSH';
    feld[5].abre :='';
    feld[6].funk :='COSH(';
    feld[6].abli :='SINH';
    feld[6].abre :='';
    feld[7].funk :='TANH(';
    feld[7].abli :='(1-TANH';
    feld[7].abre :='^2)';
    feld[8].funk :='COTANH(';
    feld[8].abli :='(1-COTANHH';
    feld[8].abre :='^2)';
    feld[9].funk :='EXP(';
    feld[9].abli :='EXP';
    feld[9].abre :='';
    feld[10].funk:='SQRT(';
    feld[10].abli:='0.5/SQRT';
    feld[10].abre:='';
    feld[11].funk:='ASIN(';
    feld[11].abli:='1/SQRT(1-';
    feld[11].abre:='^2)';
    feld[12].funk:='ACOS(';
    feld[12].abli:='(-1)/SQRT(1-';
    feld[12].abre:='^2)';
    feld[13].funk:='ATAN(';
    feld[13].abli:='1/(1+';
    feld[13].abre:='^2)';
    feld[14].funk:='ACOT(';
    feld[14].abli:='(-1)/(1+';
    feld[14].abre:='^2)';
    feld[15].funk:='ASINH(';
    feld[15].abli:='1/SQRT(1+';
    feld[15].abre:=')^2';
    feld[16].funk:='ACOSH(';
    feld[16].abli:='1/SQRT(';
    feld[16].abre:=')^2-1)';
    feld[17].funk:='ATANH(';
    feld[17].abli:='1/(1-';
    feld[17].abre:=')^2)';
    feld[18].funk:='ACOTANH(';
    feld[18].abli:='1/(1-';
    feld[18].abre:=')^2)';
    feld[19].funk:='LN(';
    feld[19].abli:='1/';
    feld[19].abre:='';
    feld[20].funk:='LOG(';
    feld[20].abli:='1/(LN(10)*';
    feld[20].abre:=')';
    feld[21].funk:='LD(';
    feld[21].abli:='1/(LN(2)*';
    feld[21].abre:=')';
  END init;



  PROCEDURE noleer(VAR f:string);
  VAR 
    i,hi:INTEGER;
    h:string;
    BEGIN;
    hi:= 0;
    loesch(h);
    FOR i:= 0 TO Length(f)-1 DO
      IF f[i] # ' ' THEN
        h[hi]:= f[i];
        INC(hi);
      END;
    END;
    Str.Copy(f,h);
    END noleer;

  PROCEDURE zeichen(f:ARRAY OF CHAR;VAR pos:INTEGER):wuerfel;
    VAR klam,i:INTEGER;
        zeich:wuerfel;
        ch:CHAR;
    BEGIN
    pos:=-1;
    zeich:=6;
    klam:=0;
    FOR i:=0 TO Length(f) DO
      ch:=f[i];
      IF ch=klauf THEN 
        INC(klam);
      ELSIF ch=klazu THEN 
          DEC(klam);
      END;
      IF klam=0 THEN
          CASE ch OF
            |'+','-':
                pos:=i;
                zeich:=1+ORD(ch='-');
            |'*','/':
                IF zeich>2 THEN
                  pos:=i;
                  zeich:=3+ORD(ch='/');
                END;
            |'^'    :
                IF zeich>4 THEN
                  zeich:=5;
                  pos:=i;
                END;
          ELSE
            ;
          END;
      END;
    END;
    IF klam<>0 THEN
      ok:=FALSE;
    END;
    RETURN zeich;
  END zeichen;

  PROCEDURE zahl(f:string):BOOLEAN;
    VAR ises:BOOLEAN;
        dum :LONGREAL; 
    BEGIN
      StrToReal(f,dum,ises);
    RETURN NOT(ises);
    END zahl;

  PROCEDURE inner (VAR f:string);
  VAR h:string;
  BEGIN
    loesch(h);
    Concat(h,klauf);
    Concat(h,f);
    Concat(h,klazu);
    Str.Copy(f,h);
  END inner;

  PROCEDURE drei(VAR f:string);
    VAR pos:INTEGER;
    BEGIN
    IF zeichen(f,pos)<3 THEN 
      inner(f);
    END;
  END drei;


PROCEDURE ableitung (f:ARRAY OF CHAR;VAR fstrich:ARRAY OF CHAR);
VAR mypos,pos				: INTEGER;
    zeich,myzeich			: wuerfel;
    h,aktabl,u,v,ustrich,vstrich,temp	: string;
    
    PROCEDURE fktvorn;
      VAR i,liste:INTEGER;
      flag:BOOLEAN;
      BEGIN
      i:=1;
      liste:=0;
      flag:=FALSE;
      REPEAT
        Copy(h,f,0,lenx[i]);
        IF Compare(h,0,Length(h),feld[i].funk,FALSE)=0 THEN
          flag:=TRUE;
          liste:=i;
        ELSE 
          INC(i);
        END;
      UNTIL flag OR (i>anzahl);
      IF flag AND (f[Length(f)-1]<>klazu) THEN 
        ok:=FALSE;
      ELSIF NOT flag THEN
          IF (f[0]=klauf) AND (f[Length(f)-1]=klazu) THEN
            Copy(h,f,1,Length(f)-2);
            IF zahl(h) THEN 
              aktabl:=null;
            ELSE
              Copy(h,f,1,Length(f)-2);
              Str.Copy(f,h);
              loesch(aktabl);
              ableitung(f,aktabl);
            END;
          ELSE
            IF Compare(f,0,Length(f),"x",FALSE)=0 THEN 
              aktabl:=eins;
            ELSE 
              aktabl:=null;
            END;
          END;
        ELSE
          loesch(u);
          Copy(u,f,lenx[liste],Length(f)-lenx[liste]-1);
          loesch(ustrich);
          ableitung(u,ustrich);
          IF Compare(ustrich,0,Length(ustrich),null,FALSE)=0 THEN 
            aktabl:=null;
          ELSE
            drei(ustrich);
            loesch(h);
            Concat(h,feld[liste].abli); Concat(h,klauf);
            Concat(h,u); Concat(h,klazu); Concat(h,feld[liste].abre);
            aktabl:= h;
            IF Compare(ustrich,1,Length(ustrich),eins,FALSE) <> 0 THEN 
              loesch(h);
              Concat(h,ustrich); Concat(h,"*"); Concat(h,aktabl);
              aktabl:= h;
            END;
          END;
      END;
    END fktvorn;

    PROCEDURE potenzen;
      BEGIN
      IF Compare(vstrich,0,Length(vstrich),null,FALSE) = 0 THEN
        IF Compare(ustrich,0,Length(ustrich),null,FALSE) = 0 THEN 
          Str.Copy(aktabl,null);
        ELSE
          IF Compare(ustrich,0,Length(ustrich),eins,FALSE) = 0 THEN 
            loesch(aktabl);
          ELSE
            drei(ustrich);
            loesch(aktabl);
            Concat(aktabl,ustrich);
            Concat(aktabl,"*");
          END;
          IF Compare(v,0,Length(v),eins,FALSE) # 0 THEN 
            h := aktabl;
            loesch(aktabl);
            Concat(aktabl,v); Concat(aktabl,"*");Concat(aktabl,h);
          END;
          IF v[0]=klauf THEN 
            loesch(h);
            Copy(h,v,1,Length(v)-1);
            Str.Copy(v,h);
          END;
          Str.Copy(vstrich,v);
      (*    realstring(vstrich,stringreal(v));*)
          IF (Compare(vstrich,0,Length(vstrich),null,FALSE)=0) (*OR 
             (Compare(v,0,Length(v),vstrich,FALSE)#0)*) THEN
            Str.Copy(vstrich,v);
            IF vstrich[Length(vstrich)-1]=klazu THEN 
              Copy(h,vstrich,0,Length(vstrich)-1);
              Str.Copy(vstrich,h);
              Concat(vstrich,"-1");
              inner(vstrich);
            END;
          ELSE
          (*  IF Compare(v,0,Length(v),vstrich,FALSE) = 0 THEN *)
              realstring(vstrich,(stringreal(vstrich)-1.0));
              IF vstrich[0]="-" THEN 
                inner (vstrich);
              END;
           (* END; *)
          END;
          IF Compare(vstrich,0,Length(vstrich),eins,FALSE) = 0 THEN 
            Concat(aktabl,u)
          ELSE
            IF Compare(vstrich,0,Length(vstrich),null,FALSE) = 0 THEN 
              Concat(aktabl,eins)
            ELSE 
              Concat(aktabl,u);Concat(aktabl,"^"); Concat(aktabl,vstrich);
            END;
          END;
        END;
      ELSE
        Str.Copy(temp,u);
        drei(temp);
        drei(ustrich);
        drei(v);
        drei(vstrich);
        Str.Copy(aktabl,f);
        Concat(aktabl,"*(");
        IF Compare(ustrich,0,Length(ustrich),null,FALSE) <> 0 THEN 
          Concat(aktabl,ustrich); Concat(aktabl,"/");
          Concat(aktabl,temp); Concat(aktabl,"*");
          Concat(aktabl,v); Concat(aktabl,"+");
        END;
        Concat(aktabl,'LN');
        IF u[0]<>klauf THEN 
          inner (u);
        END;
        Concat(aktabl,u);
        IF Compare(vstrich,0,Length(vstrich),eins,FALSE) = 0 THEN 
          Concat(aktabl,klazu)
        ELSE 
          Concat(aktabl,'*');
          Concat(aktabl,vstrich); Concat(aktabl,klazu);
        END;
      END;
    END potenzen;

BEGIN
  init();
  FOR i:= 1 TO anzahl DO
    lenx[i]:= Length(feld[i].funk);
  END;
  CapString(f);
  ok:= TRUE;
  loesch(aktabl);
  loesch(fstrich);
  IF ok THEN
    zeich:=zeichen(f,pos);
    IF (pos<>0) AND (pos<>Length(f)-1) THEN
      IF pos=-1 THEN 
        fktvorn;
      ELSE
        Copy(u,f,0,pos);
        Copy(v,f,pos+1,Length(f)-pos-1);
        loesch(ustrich);
        loesch(vstrich);
        ableitung(u,ustrich);
        ableitung(v,vstrich);
        CASE zeich OF
          | 1,2:
          IF (Compare(ustrich,0,Length(ustrich),null,FALSE)=0) 
          OR (Compare(vstrich,0,Length(vstrich),null,FALSE)=0) THEN
            
            IF Compare(ustrich,0,Length(ustrich),null,FALSE) = 0 THEN
              IF Compare(vstrich,0,Length(vstrich),null,FALSE) = 0 THEN 
                Str.Copy(aktabl,null);
              ELSE 
                CASE zeich OF
                  |1:Str.Copy(aktabl,vstrich);
                  |2:Str.Copy(aktabl,"-");
                     Concat(aktabl,vstrich);
                END;
              END;
                
            ELSE 
              Str.Copy(aktabl,ustrich);
            END;
          ELSE 
            CASE zeich OF
              |1:Str.Copy(aktabl, ustrich);
                 Concat(aktabl,"+"); 
                 Concat(aktabl,vstrich);
              |2:Str.Copy(aktabl,ustrich);
                 Concat(aktabl,"-");
                 Concat(aktabl,vstrich);
            END; 
          END;
          |3,4:
          IF Compare(ustrich,0,Length(ustrich),null,FALSE)=0 THEN 
            Str.Copy(aktabl,null);
          ELSE
            IF Compare(ustrich,0,Length(ustrich),eins,FALSE)=0 THEN 
              Str.Copy(aktabl,v);
            ELSE
              drei(ustrich);
              Str.Copy(temp,v);
              drei(temp);
              Str.Copy(aktabl,ustrich);
              Concat(aktabl,"*"); Concat(aktabl,temp);
            END;
          END;
          IF Compare(vstrich,0,Length(vstrich),null,FALSE) <> 0 THEN
            CASE zeich OF
              | 3:
              IF Compare(aktabl,0,Length(aktabl),null,FALSE)=0 THEN 
                loesch(aktabl);  
              ELSE 
                Concat(aktabl,"+");
              END;
              | 4:
              IF Compare(aktabl,0,Length(aktabl),null,FALSE)=0 THEN 
                Str.Copy(aktabl,"-");
              ELSE 
                Concat(aktabl,"-");
              END;
            END;
            IF Compare(vstrich,0,Length(vstrich),eins,FALSE)=0 THEN 
              Concat(aktabl,u)
            ELSE
              drei(u);
              drei(vstrich);
              myzeich:= zeichen(vstrich,mypos);
              Copy(h,vstrich,0,pos);
              IF zahl(h) THEN
                CASE myzeich OF
                  |3: realstring(h, stringreal(u)*stringreal(h) );
                END;
                Str.Copy(u,h);
                Copy(h,vstrich,pos+1,Length(vstrich)-pos-1);
                Str.Copy(vstrich,h);
              END;
              Concat(aktabl,u); Concat(aktabl,"*");
              Concat(aktabl,vstrich);
            END;
          END;
          IF ( (Compare(aktabl,0,Length(aktabl),null,FALSE)#0) AND 
             (zeich=4) ) THEN
            drei(aktabl);
            drei(v);
            Concat(aktabl,"/"); Concat(aktabl,v);
            Concat(aktabl,"^2");
          END;
          | 5:
            potenzen;
        END;
      END;
    END;
  END;
  noleer(aktabl);
  Str.Copy(fstrich,aktabl);
END ableitung;


END ableitung.
