(*

    Programm	:	Kurve
    Autor	:	Jrg Wesemann
    Adresse	:	Auf der Heide 10 , 2807 Achim - Baden
    Telefon	:	04202 / 70658
    Version	:	3.20 (deutsch)
    Datum	:	28.09.1989
    Copyright	:	Public Domain, bei eigenen nderungen bitte Nachricht !
    Compiler	:	M2-Amiga Modula-2, Version 3.2d, 01.11.88
    Importiert	:	ARP,IFFLib : arp.library + iff.library in DEVS: !
    Fehler	:	keine bekannt
    
*)

IMPLEMENTATION MODULE datei;

FROM	SYSTEM			IMPORT	ADR;
FROM    Arts			IMPORT	BreakPoint;
FROM	Dos			IMPORT  Execute;
FROM	Str			IMPORT	Copy,Concat;
FROM 	ARP			IMPORT	FileRequest,FileRequester,FileName,
					DirName,FileReqFlagSet;
FROM 	JWELib			IMPORT	WBExecute;
FROM	startupproc		IMPORT	sp,namestr;		

IMPORT IFFLIB;					

 PROCEDURE callprolog;
 
   VAR
     error		: LONGINT;
     
 BEGIN
   error:= WBExecute(ADR(
"runback PROLOG:prolog -p CON:0/0/640/214/MAIN PROLOG:examples/symbdiff.pro"));
 
 END callprolog; 
 


PROCEDURE SaveScreen();
VAR
  FileR 	: FileRequester;
  File		: FileName;
  Dir		: DirName;
  pfadname      : ARRAY[0..80] OF CHAR;
  ok		: BOOLEAN;
  
BEGIN
  Copy(File,namestr);
  Dir  := "jh0:Mathe";
  WITH FileR DO
    hail      := ADR("Plotter-Screen abspeichern");
    ddef      := ADR(File);
    ddir      := ADR(Dir);
    wind      := NIL;
    funcFlags := FileReqFlagSet{};
    reserved1 := 0;
    function  := NIL;
    reserved2 := 0;
  END;
  IF FileRequest(ADR(FileR))#NIL THEN
    Copy(pfadname,Dir);
    Concat(pfadname,File);
    ok:=IFFLib.SaveBitMap( 
        ADR(pfadname),ADR(sp^.bitMap),sp^.viewPort.colorMap^.colorTable,
        IFFLib.SaveIFFFlagSet{IFFLib.cmpByteRun1});
  END;
END SaveScreen;
  
END datei.
                        

