(*

    Programm	:	Kurve
    Autor	:	Jrg Wesemann
    Adresse	:	Auf der Heide 10 , 2807 Achim - Baden
    Telefon	:	04202 / 70658
    Version	:	3.20 (deutsch)
    Datum	:	28.09.1989
    Copyright	:	Public Domain, bei eigenen nderungen bitte Nachricht !
    Compiler	:	M2-Amiga Modula-2, Version 3.2d, 01.11.88
    Importiert	:	
    Fehler	:	nicht bekannt
    
*)

IMPLEMENTATION MODULE monotonie;

FROM SYSTEM 		IMPORT 	ADR;
FROM LongRealInOut	IMPORT 	WriteReal, ReadReal;
FROM InOut 		IMPORT 	Write,WriteString,WriteLn,WriteCard,OpenOutput,
				CloseOutput;
FROM startupproc 	IMPORT 	CLS,crlf,cursorr,fn,solve,m,n,eps,center,string,
				nullbuffer,dateiabfrage,fragedatei,wptr;
FROM intervall 		IMPORT 	kleinintervall;
FROM lparser 		IMPORT 	lparse;    
FROM Strings 		IMPORT 	Length;
FROM menu 		IMPORT 	wartemenu;
FROM Intuition		IMPORT	WindowToFront;


PROCEDURE monotonie;

  VAR
    x,dx,xmin,xmax 	: LONGREAL;
    success	 	: BOOLEAN;
    art		 	: CARDINAL;
  
BEGIN
  nullbuffer[2]:= "0.2";
  kleinintervall(nullbuffer,ADR("MONOTONIE - Intervall"));
  xmin:= lparse(nullbuffer[1],0.0);
  dx:=   lparse(nullbuffer[2],0.0);
  xmax:= lparse(nullbuffer[3],0.0);
  art:=  CARDINAL(lparse(nullbuffer[4],0.0));
  WindowToFront(wptr);
  Write(CLS);
  IF dateiabfrage THEN
    fragedatei();
  END;  
  center("Monotonieberprfung"); WriteLn;
  center("--------------------"); crlf(2);
  center("von"); crlf(2);
  cursorr(20+(31-Length(string)) DIV 2 );
  WriteString("f(x) = ");
  WriteString(string); crlf(3);
  center("Die Funktion ist im Bereich"); crlf(3); cursorr(22);
  WriteString("["); WriteReal(xmin,m,n); WriteString(",");
  x:= solve(xmin,xmax,dx,1,art,success);
  IF success THEN
    REPEAT
      WriteReal(x,m,n); WriteString("  ] monoton ");
      IF fn(x,2) < -eps THEN
        WriteString("steigend");
      ELSIF fn(x,2) > eps THEN				(* IF 2		*)
        WriteString("fallend");
      END;						(* IF 2		*)
      WriteLn; cursorr(22);
      WriteString("["); WriteReal(x,m,n); WriteString(",");
      xmin:= x + dx;
      x:= solve(xmin,xmax,dx,1,art,success);
    UNTIL NOT success OR (x>xmax);			(* REPEAT 1	*)
  END;							(* IF 1		*)
  WriteReal(xmax,m,n); WriteString("  ] monoton ");
  IF fn(x,1) <= -eps THEN
    WriteString("fallend");
  ELSIF fn(x,1) >=eps THEN
    WriteString("steigend");
  ELSE
    WriteString("!!  A C H T U N G  !!"); WriteLn; cursorr(22);
    WriteString(" -eps < f'(x) < eps "); WriteLn; cursorr(22);
    WriteString("Bitte Grenzen anders whlen");
  END;
  WriteLn;
  CloseOutput;
  crlf(3); cursorr(22);
  WriteString("Bitte 'RETURN' drcken fr MENU ");
  wartemenu;

END monotonie; 


END monotonie.
