(******************************************************************************
*                                                                             *
*    Programmname:  ToolRoutines                                              *
*                                                                             *
*    Stand:         21.11.89                            Uhrzeit:  21:00:19    *
*                                                                             *
*    Bearbeitet mit dem MODULETool V1.1         () by  Thomas Stolze 1989    *
*                                                                             *
******************************************************************************)

(* $R- *) (* $V- *) (* $S- *) (* $N- *) (* $F- *)
IMPLEMENTATION MODULE ToolRoutines;

FROM SYSTEM     IMPORT ADDRESS;
FROM Str        IMPORT Concat;
FROM FileSystem IMPORT Close,File,Length,Lookup,ReadBytes,Response,WriteBytes;
FROM Storage    IMPORT ALLOCATE,Available,DEALLOCATE;

PROCEDURE SicherheitsKopie(name : ARRAY OF CHAR);
VAR in,out : File;
    adr    : ADDRESS;
    act,pos: LONGINT;
BEGIN
   Lookup(in,name,1024,FALSE);
   IF (in.res = done) THEN
      Concat(name,"O");
      Lookup(out,name,1024,TRUE);
      IF (out.res = done) THEN
         Length(in,pos);
         IF Available(pos) THEN
            ALLOCATE(adr,pos);
              ReadBytes(in,adr,pos,act); WriteBytes(out,adr,pos,act);
            DEALLOCATE(adr,pos);  
         END;   
      END;
      Close(out);
   END;
   Close(in);          
END SicherheitsKopie;

BEGIN
END ToolRoutines.
