(******************************************************************************
*                                                                             *
*    Programmname:  InputDevice                                               *
*                                                                             *
*    Stand:         09.11.89                            Uhrzeit:  16:13:52    *
*                                                                             *
*    Bearbeitet mit dem MODULETool V1.1         () by  Thomas Stolze 1989    *
*                                                                             *
******************************************************************************)

(* $R- *) (* $V- *) (* $S- *) (* $N- *) (* $F- *)
IMPLEMENTATION MODULE InputDevice;

IMPORT Exec;

FROM SYSTEM     IMPORT ADDRESS,ADR,CAST,REG,SETREG;
FROM InputEvent IMPORT InputEvent,InputEventPtr,Qualifiers;
FROM Intuition  IMPORT DisplayBeep;
FROM Exec       IMPORT PutMsg;

PROCEDURE Handler;
VAR  a0,a1    : ADDRESS;
     eventptr : InputEventPtr;
BEGIN
 a0:=REG(8); a1:=REG(9);
 
 eventptr:=CAST(InputEventPtr,a0);
 IF (control IN eventptr^.qualifier) AND (lShift IN eventptr^.qualifier) THEN
    IF (eventptr^.code = HELP) OR (eventptr^.code = ESC) THEN
       inMessage.event.code:=eventptr^.code;
       inMessage.event.class:=eventptr^.class;
       inMessage.event.subClass:=eventptr^.subClass;
       inMessage.event.nextEvent:=eventptr^.nextEvent;
       inMessage.event.qualifier:=eventptr^.qualifier;
       inMessage.event.timeStamp.secs:=eventptr^.timeStamp.secs;
       inMessage.event.timeStamp.micro:=eventptr^.timeStamp.micro;
    
       inMessage.nachricht.node.type:=Exec.message;
       inMessage.nachricht.length:=SIZE(InputEvent);
       a0:=NIL;
       DisplayBeep(NIL);
       PutMsg(sleepPort,ADR(inMessage));
    END;
 END;
 
 SETREG(8,a0); SETREG(9,a1);
END Handler;

BEGIN
END InputDevice.

