(* Written by Urs Pntener *)
(* on Amiga 2000 with M2-Amiga *)

             
MODULE KommentarKiller ;

FROM   FileSystem IMPORT Response ;
IMPORT FileSystem ;
IMPORT InOut      ;
IMPORT Strings    ;

TYPE  Name                                   = ARRAY [0..100] OF CHAR ;
     
VAR   OldFile,NewFile                        : FileSystem.File ;
      CharA,CharB                            : CHAR ;
      InputFileName,OutputFileName           : Name ;
      Index                                  : INTEGER ;
      Mark,Attention                         : BOOLEAN ;
     
CONST Space              = 40C ;
      OpenBracket        = 50C ;
      CloseBracket       = 51C ;
      Asterisk           = 52C ;
          
PROCEDURE FetchChar;
(* Get the Chars from Input-Text-File *)

  BEGIN
    FileSystem.SetPos(OldFile,Index) ;
    FileSystem.ReadChar(OldFile,CharA) ;
    INC(Index) ;
    FileSystem.SetPos(OldFile,Index) ;
    FileSystem.ReadChar(OldFile,CharB) ;     
  END FetchChar ; 
  
      
BEGIN (* KommentarKiller *)      
  
  (* Getting some Infos from the User *)
  WHILE (Strings.Length(InputFileName) = 0) DO 
      InOut.WriteString ("InputFileName: ") ;
      InOut.ReadString(InputFileName) ;
  END (* WHILE *) ;
  WHILE (Strings.Length(OutputFileName) = 0) DO
      InOut.WriteString ("Attention ! If the OutputFile exists, ");
      InOut.WriteString ("it will be erased. ");
      InOut.WriteLn ;
      InOut.WriteString ("OutputFileName: ") ;
      InOut.ReadString(OutputFileName) ;
  END (* WHILE *) ;
  
  (* Open the Input-Text-File *)
  FileSystem.Lookup(OldFile,InputFileName,0,FALSE) ;
    IF (OldFile.res  = notFound) THEN
      InOut.WriteString("File not found  !") ;
      HALT ;
    END (* IF *) ;
  
  (* Open the Output-Text-File *)
  FileSystem.Lookup(NewFile,OutputFileName,0,TRUE) ;
  
  (* Preparation *)
  Index     := 0 ;
  CharA     := Space ;
  CharB     := Space ;
  Mark      := FALSE ;
  Attention := FALSE ;




  (* Main LOOP *)
  
  FetchChar ;
  
  WHILE ( NOT(OldFile.eof)) DO
  
    (* A new Command begins without closing the old *)
    IF (CharA=OpenBracket) AND (CharB=Asterisk) AND (Mark=TRUE) THEN
        Attention := TRUE ;
    END (* IF *) ;  
    
    (* Setting Mark if the Command begins *)
    IF (CharA=OpenBracket) AND (CharB=Asterisk) AND (Mark=FALSE) THEN
        Mark := TRUE ;
    END (* IF *) ;
    
    (* Writting CharA if there is no Mark *)
    IF (Mark = FALSE) THEN
      FileSystem.WriteChar(NewFile,CharA) ;
      InOut.Write(CharA) ;
    END (* IF *) ;
       
    (* Commandend without opening Command *)
    IF (CharB=CloseBracket) AND (CharA=Asterisk) AND (Mark=FALSE) THEN
      Attention := TRUE ;   
    END (* IF *) ;
        
    (* Deleting Mark at Commandend *)
    IF (CharB=CloseBracket) AND (CharA=Asterisk) AND (Mark=TRUE) THEN
      Mark := FALSE ;   
      INC(Index) ;
    END (* IF *) ;
    
    FetchChar ;
    
  END (* WHILE *) ;  
  
  FileSystem.WriteChar(NewFile,CharA) ;
  InOut.Write(CharA) ;      
  InOut.WriteLn ;
  InOut.WriteLn ;  
  
  (* Something wonderful happend ...... *)
  IF (Mark = TRUE) OR (Attention = TRUE) THEN 
    InOut.WriteString("Attention ! One of the Commands wasnot closed");
    InOut.WriteLn ;    
    InOut.WriteString(" Translation of the File failed. ") ;    
    InOut.WriteLn ;
  END (* IF *) ;
    
  InOut.WriteLn ;      
  InOut.WriteString(" End of Translation. ") ;  
  
  (* Closing the Files *)
  FileSystem.Close(NewFile) ;
  FileSystem.Close(OldFile) ;

END KommentarKiller .
