MODULE TestIt;

FROM SYSTEM      IMPORT ADR;
FROM Arts        IMPORT TermProcedure, Assert;
FROM Dos         IMPORT Delay;
FROM BrushData   IMPORT Gadget, GadgetCol;
FROM IntuiStruct IMPORT StructScreen;
FROM Graphics    IMPORT ViewModeSet, ViewModes, LoadRGB4;
FROM Intuition   IMPORT OpenScreen, CloseScreen, DrawImage, NewScreen,
                        ScreenPtr, customScreen, MakeScreen;

VAR NewScr : NewScreen;
    MyScr  : ScreenPtr;

PROCEDURE CleanUp;

BEGIN
   IF MyScr # NIL THEN
      CloseScreen (MyScr);
      MyScr := NIL;
   END; (* IF *)
END CleanUp;


BEGIN
   TermProcedure (CleanUp);

   (* Screen auf! *)
   StructScreen (NewScr, 3, 0, 1, ViewModeSet{}, customScreen,
                 ADR ("Hallo Inspector!!!"));
   MyScr := OpenScreen (NewScr);
   Assert (MyScr # NIL, ADR ("Screen klemmt!"));

   (* Farben setzen! *)
   LoadRGB4 (ADR (MyScr^.viewPort), GadgetCol.colorTable, GadgetCol.count);
   MakeScreen (MyScr);

   (* Malen! *)
   DrawImage (ADR (MyScr^.rastPort), ADR (Gadget), 50, 50);

   (* Warten... *)
   Delay (5 * 50);
END TestIt.
