(**********************************************************************

    :Program.    Dame.mod
    :Contents.   Lsung des 8-Damen Problems
    :Author.     Markus Uhlendahl
    :Address.    Vorm Burgtor 16, 4408 Dlmen
    :Phone.      02594/81540
    :Copyright.  Public Domain
    :Language.   Modula-2
    :Translator. M2Amiga AMSoft V3.3d

**********************************************************************)
MODULE Damen;


FROM InOut IMPORT Write,WriteInt,WriteString,WriteLn;


CONST n = 8;


TYPE vektorTyp = ARRAY[0..n] OF INTEGER;


VAR v : vektorTyp;
    i : INTEGER;
    l : INTEGER;


PROCEDURE Ausgabe (v : vektorTyp);

  VAR i : INTEGER;

  BEGIN
    FOR i:=1 TO n DO
      Write ("(");WriteInt (v[i],2);Write ("|");
      WriteInt (i,2);Write (")");
    END;
    WriteLn;
  END Ausgabe;


PROCEDURE akzeptiert (v : vektorTyp) : BOOLEAN;

  VAR a : BOOLEAN;
      i : INTEGER;

  BEGIN
    a:=TRUE;
    i:=1;
    WHILE (i<v[0]) AND (a) DO
      IF v[v[0]]=v[i] THEN
        a:=FALSE;
      END;
      IF v[v[0]]+v[0]=v[i]+i THEN
        a:=FALSE;
      END;
      IF v[v[0]]-v[0]=v[i]-i THEN
        a:=FALSE;
      END;
      i:=i+1;
    END;
    RETURN (a);
  END akzeptiert;


PROCEDURE versuche (v : vektorTyp);

  VAR i : INTEGER;

  BEGIN
    v[0]:=v[0]+1;
    FOR i:=1 TO n DO
      v[v[0]]:=i;
      IF akzeptiert (v) THEN
        IF v[0]=n THEN
          Ausgabe (v);
          l:=l+1;
        ELSE
          versuche (v);
        END;
      END;
    END;
  END versuche;


BEGIN
  l:=0;
  FOR i:=0 TO n DO
    v[i]:=0;
  END;
  versuche (v);
  WriteString ("Anzahl der Lsungen:");WriteInt (l,6);WriteLn;
END Damen.
