IMPLEMENTATION MODULE NoteConversions;

FROM Menus IMPORT CH; (* ist Schweizer Note *)

FROM Str IMPORT Copy;
FROM RealConversions IMPORT RealToStr;

PROCEDURE NoteToString(N: REAL; Dec: BOOLEAN; VAR Str: ARRAY OF CHAR);
VAR G: INTEGER;
    err: BOOLEAN;
BEGIN
   IF NOT CH() THEN
      N := 7.0 - N
   END;
   IF Dec THEN
      RealToStr(N , Str, 4, 2, FALSE, err);
      IF err THEN
         Copy(Str, "Ungltige Note")
      END
   ELSE
      N := N * 2.0 + 0.50001;
      G := TRUNC(N)     ;
      CASE G OF
        2: Copy(Str, " 1 ");
      | 3: Copy(Str, "1-2");
      | 4: Copy(Str, " 2 ");
      | 5: Copy(Str, "2-3");
      | 6: Copy(Str, " 3 ");
      | 7: Copy(Str, "3-4");
      | 8: Copy(Str, " 4 ");
      | 9: Copy(Str, "4-5");
      |10: Copy(Str, " 5 ");
      |11: Copy(Str, "5-6");
      |12: Copy(Str, " 6 ");
      ELSE
         Copy(Str, "Ungltige Note")
      END
   END
END NoteToString;

END NoteConversions.
