(*---------------------------------------------------------------------------
   :Program.      NoClick.mod
   :Author.       Fridtjof Siebert
   :Address.      Nobileweg 67, D-7000 Stuttgart 40
   :Shortcut.     [fbs]
   :Copyright.    PD
   :Language.     Oberon
   :Translator.   Amiga Oberon Compiler V2.01
   :History.      V1.0 05-May-91 first release [fbs]
   :Contents.     Avoids drive-clicking
   :Usage.        NoClick
   :Remark.       needs Kick 2.0!
---------------------------------------------------------------------------*)

MODULE NoClick;

IMPORT e: Exec,
       d: Dos,
       td:TrackDisk,
       y: SYSTEM;


VAR
  c: INTEGER;
  mp: e.MsgPortPtr;
  ior: e.IOStdReqPtr;
  tu: td.PublicUnitPtr;

BEGIN
  IF d.dos.lib.version>=36 THEN
    mp := e.CreateMsgPort();
    ior := e.CreateIORequest(mp,y.SIZE(ior^));
    c := 0;
    REPEAT
      IF e.OpenDevice(td.name,c,ior,LONGSET{})=0 THEN
        tu := ior.unit;
        tu.pubFlags := tu.pubFlags / SHORTSET{td.noClick};
        IF td.noClick IN tu.pubFlags THEN d.PrintF("Clicked off drive DF%ld:\n",c);
                                     ELSE d.PrintF("Clicked on drive DF%ld:\n" ,c) END;
        e.CloseDevice(ior);
      END;
      INC(c);
    UNTIL c=3;
  END;
END NoClick.

