(*---------------------------------------------------------------------------
  :Program.    FastLister
  :Author.     Thomas Stolze
  :Address.    Goslarsche Str. 32 3000 Hannover 21, Germany
  :Phone.      (0)511 / 75 10 77
  :Version.    V2.5
  :Date.       05-Sep-90
  :Copyright.  Shareware
  :Language.   Modula-2
  :Translator. M2Amiga V4.0d
  :LastUpdate. 07-JUN-91
  :Contents.   Programming Utility.
  :Remark.     Needs "MuchMore" in C:-Directory  by F. Siebert
  :Imports.    QText  by F. Siebert AMOK#19
  :LastUpdate. 29-JUN-91
---------------------------------------------------------------------------*)
(*$ LargeVars:=FALSE NilChk:= FALSE OverflowChk:=FALSE RangeChk:=FALSE
    StackChk:=FALSE *)
IMPLEMENTATION MODULE InputDevice;

IMPORT ExecD;
IMPORT R;

FROM SYSTEM     IMPORT ADR;
FROM InputEvent IMPORT InputEvent,InputEventPtr,Qualifiers;
FROM ExecL      IMPORT PutMsg;

(*$LoadA4:=TRUE *)
PROCEDURE Handler(eventptr{R.A0} : InputEventPtr): InputEventPtr;
BEGIN
 IF (control IN eventptr^.qualifier) AND (lShift IN eventptr^.qualifier) THEN
    CASE eventptr^.code OF HELP, ESC :

       inMessage.event.code:=eventptr^.code;
       inMessage.event.class:=eventptr^.class;
       inMessage.event.subClass:=eventptr^.subClass;
       inMessage.event.nextEvent:=eventptr^.nextEvent;
       inMessage.event.qualifier:=eventptr^.qualifier;
       inMessage.event.timeStamp.secs:=eventptr^.timeStamp.secs;
       inMessage.event.timeStamp.micro:=eventptr^.timeStamp.micro;

       inMessage.newNews.node.type:=ExecD.message;
       inMessage.newNews.length:=SIZE(InputEvent);
         PutMsg(sleepPort,ADR(inMessage));
       eventptr:=eventptr^.nextEvent;
    ELSE
    END;
 END;
 RETURN eventptr;
END Handler;

BEGIN
END InputDevice.

