(*---------------------------------------------------------------------------
  :Program.    QText.mod
  :Author.     Fridtjof Siebert
  :Address.    Nobileweg 67, D-7-Stgt-40
  :Phone.      (0)711/822509
  :Shortcut.   [fbs]
  :Version.    1.0
  :Date.       29-Apr-89
  :Copyright.  PD
  :Language.   Assembler
  :Translator. M2Amiga v3.1d / Profimat
  :Contents.   Procedure for fast text-output on a BitMap
  :Update.     28-JUN-91 for Compiler 4.0d
---------------------------------------------------------------------------*)
(*$ LargeVars:=FALSE NilChk:= FALSE OverflowChk:=FALSE RangeChk:=FALSE
    StackChk:=FALSE *)
IMPLEMENTATION MODULE QText;

IMPORT R;

FROM SYSTEM    IMPORT ADDRESS, ASSEMBLE;
FROM GraphicsD IMPORT BitMapPtr, TextFontPtr;

PROCEDURE QText(x{R.D0},y{R.D1}: INTEGER;
                str{R.A0}      : ADDRESS;
                bm {R.A1}      : BitMapPtr;
                tf {R.A2}      : TextFontPtr);  (*$EntryExitCode:=FALSE *)

(* Gibt str^ an Position x,y in bm mit dem Font tf aus *)
(* x gibt position in Zeichenbreiten (8 Pixel) an.     *)

BEGIN
ASSEMBLE(DC.W
(*0000*) $048E7,$0F0F0,$03429,$00000,$048C2,$0C2C2,$048C0,$0D280,
(*0010*) $02269,$00008,$0D3C1,$02202,$0E781,$09282,$05381,$0246A,
(*0020*) $00022,$01018,$06700,$00082,$01600,$0C63C,$00060,$06600,
(*0030*) $00034,$012BC,$000FE,$0D3C2,$012BC,$000C6,$0D3C2,$012BC,
(*0040*) $000C6,$0D3C2,$012BC,$000C6,$0D3C2,$012BC,$000C6,$0D3C2,
(*0050*) $012BC,$000C6,$0D3C2,$012BC,$000FE,$0D3C2,$012BC,$00000,
(*0060*) $093C1,$060BE,$0903C,$00020,$06A04,$0903C,$00020,$0C07C,
(*0070*) $000FF,$047F2,$00000,$01293,$0D3C2,$012AB,$000C0,$0D3C2,
(*0080*) $012AB,$00180,$0D3C2,$012AB,$00240,$0D3C2,$012AB,$00300,
(*0090*) $0D3C2,$012AB,$003C0,$0D3C2,$012AB,$00480,$0D3C2,$012AB,
(*00A0*) $00540,$093C1,$06000,$0FF7C,$04CDF,$00F0F,$04E75    END);
END QText;

END QText.

