MODULE CheckTime;

IMPORT d := Dos, arg: Arguments;

VAR
  date: d.DateTime;
  from, to : d.DatString;

BEGIN
  IF d.dos.lib.version<36 THEN HALT(20) END;
  NEW(date.strTime);
  IF date.strTime=NIL THEN HALT(20) END;
  IF arg.NumArgs()#2 THEN
    d.PrintF("Usage: CheckTime <from> <to>\n");
  ELSE
    arg.GetArg(1,from);
    arg.GetArg(2,to);
    d.DateStamp(date);
    IF d.DateToStr(date) THEN
      IF from < to THEN
        IF (from < date.strTime^) AND (date.strTime^ < to) THEN
          HALT(d.warn)
        END;
      ELSE
        IF (from < date.strTime^) OR (date.strTime^ < to) THEN
          HALT(d.warn)
        END;
      END;
    END;
  END;
END CheckTime.

