
(* After this test WBench must show the memory avail-memory *)

MODULE MultiMemTest;

IMPORT
  NoGuru,
  e: Exec,
  mm: MultiMem,
  sys: SYSTEM;

VAR
  h1, h2, h3, h4: mm.HeapPtr;
  e1, e2, e3, e4, e5: e.STRPTR;

BEGIN
  mm.NewHeap(h1); IF h1 = NIL THEN HALT(20); END;

  mm.New(h1,e1,4);
  mm.New(h1,e2,4);
  mm.Dispose(e1);   (* give one free *)
  mm.EmptyHeap(h2); (* free only contents, not the heap itself *)

  mm.NewHeap(h2); IF h2 = NIL THEN HALT(20); END;

  mm.New(h2,e1,4);
  mm.New(h2,e3,4);
  mm.Dispose(e1);   (* give one free *)
  mm.New(h2,e4,4);
  mm.New(h2,e5,4);

  mm.NewHeap(h3); IF h3 = NIL THEN HALT(20); END;

  mm.New(h3,e1,4);

  mm.DisposeHeap(h3); (* other Heaps should be disposed by MultiMem *)

END MultiMemTest.


