(* ------------------------------------------------------------------------
  :Program.     Lhlib
  :Contents.    Interface to "lh.library"
  :Author.      Thomas Stolze
  :Address.     Goslarsche Str. 32
  :Address.     D-W-3000 Hannover 21
  :History.     Ported from Oberon 31-JUL-92
  :Remark.      Oberon Version by Christoph Teuber,
  :Remark.                        Rheinstr. 65, 5600 Wuppertal 1, Germany
  :Copyright.   PD
  :Language.    Modula-2
  :Translator.  M2AMIGA V4.0d
  :Remark.      You MUST check lhBase # NIL !!
------------------------------------------------------------------------ *)

(*$ LargeVars:=FALSE LongAlign:=FALSE Volatile:=FALSE StackParms:=FALSE *)
IMPLEMENTATION MODULE LhLib;

FROM ExecL  IMPORT CloseLibrary,OpenLibrary;
FROM SYSTEM IMPORT ADR;

BEGIN  (* LhLib *)
  lhBase := OpenLibrary(ADR(LhName), LhVersion);
  IF lhBase # NIL THEN
     lhVersion:=lhBase^.version;
  END;
CLOSE
  IF lhBase # NIL THEN CloseLibrary(lhBase); lhBase:=NIL; END;
END LhLib.
