IMPLEMENTATION MODULE TalkBase;
(*$ LargeVars:=FALSE StackParms:=FALSE Volatile:=FALSE *)

FROM SYSTEM	IMPORT	ADR,ADDRESS,TAG;
FROM Requester	IMPORT	OKRequest;
IMPORT	(*c:WbClone,*)
	A:Arts,
	GL:GadToolsL,
	GraphicsD,
	ID:IntuitionD,
	IL:IntuitionL,
	IntuiPointer;

CONST
  myTopaz8=GraphicsD.TextAttr{name:ADR("topaz.font"),ySize:8};

VAR
  oldIDCMPs:ID.IDCMPFlagSet;
  min1:CARDINAL;

PROCEDURE OpenSW;
VAR
  tBuff:ARRAY[1..10] OF LONGINT;
BEGIN
  (* Trick17 fr 3D-Look: *)
  min1:=0FFFFH; (* Kennung: Ende der Colorliste *)

  (* Screen ffnen: *)
  myScreen:=IL.OpenScreenTagList(NIL,TAG(tBuff,
	ID.saDepth,	2,
	ID.saDisplayID,	GraphicsD.hiresKey,
	ID.saPens,	ADR(min1), (* ergibt "new look"!!! *)
	ID.saTitle,	ADR("Talker 1.1   1992 Bernd Preusing AMSoft"),
	0));
  IF myScreen=NIL THEN
    OKRequest("Cannot open Screen!");
    A.Exit(10);
  ELSE
    myWindow:=IL.OpenWindowTagList(NIL,TAG(tBuff,
	ID.waTop,		myScreen^.barHeight+myScreen^.barVBorder,
	ID.waHeight,		myScreen^.height-(myScreen^.barHeight+myScreen^.barVBorder),
	ID.waCustomScreen,	myScreen,
	ID.waFlags,		ID.WindowFlagSet{ID.backDrop, ID.borderless, ID.activate},
	0));
    IF myWindow=NIL THEN
      OKRequest("Cannot open Screen!");
      A.Exit(10);
    ELSE
      myRp:=myWindow^.rPort;
    END;
  END;
END OpenSW;

PROCEDURE SetBusy(busy:BOOLEAN);
BEGIN
  IF busy THEN
    oldIDCMPs:=myWindow^.idcmpFlags;
    IL.ModifyIDCMP(myWindow,ID.IDCMPFlagSet{ID.closeWindow});
    IntuiPointer.Busy(myWindow);
  ELSE
    IL.ModifyIDCMP(myWindow,oldIDCMPs);
    IntuiPointer.Normal(myWindow);
  END;
END SetBusy;


BEGIN
  A.Assert(A.kickVersion>=37,ADR("Needs kick>=37!!"));
  quit:=FALSE;
  saveIcons:=TRUE;

  OpenSW;
  myTextAttr:=ADR(myTopaz8);
  vi:=GL.GetVisualInfoA(myScreen,NIL);
  centLabs:=AA12{
  	ADR("IY"),
  	ADR("IH"),
  	ADR("EH"),
  	ADR("AE"),
  	ADR("AA"),
	ADR("AH"),
	ADR("AO"),
	ADR("OW"),
	ADR("UH"),
	ADR("ER"),
	ADR("UW"),
	NIL};
CLOSE

  IF vi#NIL THEN
    GL.FreeVisualInfo(vi);
    vi:=NIL;
  END;
  IF myWindow#NIL THEN
    IL.CloseWindow(myWindow);
    myWindow:=NIL;
  END;
  IF myScreen#NIL THEN
    IL.CloseScreen(myScreen);
    myScreen:=NIL;
  END;
END TalkBase.mod
