MODULE Simulation;

IMPORT
  Ueberweg, io, Break;

VAR
  u: Ueberweg.Ueberweg;

PROCEDURE Wait(s: LONGINT);
VAR
  a: ARRAY 128 OF CHAR;
BEGIN
  io.WriteString("RETURN> "); io.ReadString(a);
END Wait;

BEGIN
  NEW(u); Ueberweg.Init(u,FALSE); (* --- FALSE: Fussgaenger zuerst gruen *)

  io.WriteString("Simulation eines Fussgaenger-Ueberwegs"); io.WriteLn;
  io.WriteString("Oberon-2 Version von Peter Froehlich"); io.WriteLn;
  io.WriteString("Press CTRL-C to stop."); io.WriteLn;
  io.WriteLn;

  LOOP
    WHILE ~u.autoAmpel.istRot() DO
      u.autoAmpel.Schalten();
      u.Anzeigen();
    END;

    WHILE ~u.fussAmpel.istGruen() DO
      u.fussAmpel.Schalten();
      u.Anzeigen();
    END;

    Wait(100000);

    WHILE ~u.fussAmpel.istRot() DO
      u.fussAmpel.Schalten();
      u.Anzeigen();
    END;

    WHILE ~u.autoAmpel.istGruen() DO
      u.autoAmpel.Schalten();
      u.Anzeigen();
    END;

    Wait(100000);

  END;

END Simulation.
