(*------------------------------------------

  :Program.     Printf
  :Author.      Dieter Bogdoll [db]
  :Address.     SMail: Gudrunstr. 7, D-8000 Mnchen 19
  :Address.     EMail: landon@amc.zer
  :Address.     EMail: 2:246/221.3@fidonet
  :Address.     EMail: bogdoll@informatik.tu-muenchen.de
  :Version.     V1.0
  :Date.        20-Feb-1993
  :Copyright.   Public Domain
  :Language.    Oberon
  :Translator.  Amiga Oberon 3.00d
  :Support.     Format aus io.mod, Printf: Volker Rudolph, hartmut Goebel [hG]
  :Contents.    stellt Printf zur verfgung hnlich wie in C
  :Remarks.     Formatiersteuerung siehe Format aus io.mod
  :Bugs.        nicht ausfuehrlich getestet
  :History.     V0.0   [db] 15-Feb-1993 : Erstellt
  :History.     V1.0   [db] 20-Feb-1993 : Gebrauchsfertig

--------------------------------------------*)
MODULE Printf;

(* $OvflChk- $RangeChk- $NilChk- $ReturnChk- $CaseChk- *)

IMPORT f:Format;

TYPE
  wproc = PROCEDURE(a:ARRAY OF CHAR);

VAR
  writeProc* : wproc;

PROCEDURE Printf0*(a:ARRAY OF CHAR);
  VAR hstr : ARRAY 256 OF CHAR;
  BEGIN
    f.Format0(hstr, a);
    writeProc(hstr);
END Printf0;

PROCEDURE Printf1*(a:ARRAY OF CHAR; d1:LONGINT);
  VAR hstr : ARRAY 256 OF CHAR;
  BEGIN
    f.Format1(hstr, a, d1);
    writeProc(hstr);
END Printf1;

PROCEDURE Printf2*(a:ARRAY OF CHAR; d1,d2:LONGINT);
  VAR hstr : ARRAY 256 OF CHAR;
  BEGIN
    f.Format2(hstr, a, d1, d2);
    writeProc(hstr);
END Printf2;

PROCEDURE Printf3*(a:ARRAY OF CHAR; d1,d2,d3:LONGINT);
  VAR hstr : ARRAY 256 OF CHAR;
  BEGIN
    f.Format3(hstr, a, d1,d2,d3);
    writeProc(hstr);
END Printf3;

PROCEDURE Printf4*(a:ARRAY OF CHAR; d1,d2,d3,d4:LONGINT);
  VAR hstr : ARRAY 256 OF CHAR;
  BEGIN
    f.Format4(hstr, a, d1,d2,d3,d4);
    writeProc(hstr);
END Printf4;

PROCEDURE Printf5*(a:ARRAY OF CHAR; d1,d2,d3,d4,d5:LONGINT);
  VAR hstr : ARRAY 256 OF CHAR;
  BEGIN
    f.Format5(hstr, a, d1,d2,d3,d4,d5);
    writeProc(hstr);
END Printf5;

PROCEDURE Printf6*(a:ARRAY OF CHAR; d1,d2,d3,d4,d5,d6:LONGINT);
  VAR hstr : ARRAY 256 OF CHAR;
  BEGIN
    f.Format6(hstr, a, d1,d2,d3,d4,d5,d6);
    writeProc(hstr);
END Printf6;

PROCEDURE Printf7*(a:ARRAY OF CHAR; d1,d2,d3,d4,d5,d6,d7:LONGINT);
  VAR hstr : ARRAY 256 OF CHAR;
  BEGIN
    f.Format7(hstr, a, d1,d2,d3,d4,d5,d6,d7);
    writeProc(hstr);
END Printf7;

END Printf.
