
MODULE StopWatchDemo;

  IMPORT
    d:=Dos, e:=Exec, g:=Graphics, StopWatch, io;

  VAR
    micros: LONGINT;
    oldpri: SHORTINT;
    vk,nk:  LONGINT;
    i: INTEGER;

BEGIN
  IF e.exec.libNode.version < 37 THEN HALT(d.error) END; (* BIG ERROR :-) *)

  oldpri := e.SetTaskPri(e.FindTask(NIL),127);
  (* Disable geht nicht wegen WaitTOF *)

  g.WaitTOF;
  StopWatch.Start();
  i := 16;
  REPEAT DEC(i); g.WaitTOF UNTIL i=0;
  micros := StopWatch.Stop();

  oldpri := e.SetTaskPri(e.FindTask(NIL),oldpri);

  micros := micros DIV 16;

  d.PrintF("One frame is %ld micro sec.\n",micros);

  nk := 10000000 DIV micros;
  vk := nk DIV 10; nk := nk MOD 10;

  d.PrintF("Your vertical screen frequency is %ld.%ld Hz\n",vk,nk);

END StopWatchDemo.

